SystemOrganization addCategory: #'Pier-Model-Command'!
SystemOrganization addCategory: #'Pier-Model-Core'!
SystemOrganization addCategory: #'Pier-Model-Document'!
SystemOrganization addCategory: #'Pier-Model-Exception'!
SystemOrganization addCategory: #'Pier-Model-Kernel'!
SystemOrganization addCategory: #'Pier-Model-Magritte'!
SystemOrganization addCategory: #'Pier-Model-Persistence'!
SystemOrganization addCategory: #'Pier-Model-Structure'!
SystemOrganization addCategory: #'Pier-Model-Utilities'!
SystemOrganization addCategory: #'Pier-Model-Visitor'!

MAValidationError subclass: #PRChildNotFoundError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Exception'!

MAValidationError subclass: #PRDecorationError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Exception'!

MAValidationError subclass: #PRInvalidKernelError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Exception'!

MAValidationError subclass: #PRPersistencyError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Exception'!

MAValidationError subclass: #PRStructureError
	instanceVariableNames: 'structure'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Exception'!

PRStructureError subclass: #PRConflictingNameError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Exception'!

PRStructureError subclass: #PRInvalidNestingError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Exception'!

!PRInvalidNestingError class methodsFor: 'instance creation' stamp: 'lr 3/9/2006 11:30'!
of: aChildStructure in: aParentStructure
	^ (self structure: aParentStructure)
		signal: aChildStructure title printString , ' can not be a child of ' , aParentStructure title printString! !

!PRStructureError class methodsFor: 'instance creation' stamp: 'lr 3/9/2006 11:30'!
structure: aStructure
	^ self new
		setStructure: aStructure;
		yourself! !

!PRStructureError methodsFor: 'initialization' stamp: 'lr 3/9/2006 11:30'!
setStructure: aStructure
	structure := aStructure! !

!PRStructureError methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
structure
	^ structure! !

MADelegatorAccessor subclass: #PRDocumentAccessor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Magritte'!

!PRDocumentAccessor methodsFor: 'model' stamp: 'lr 2/14/2008 13:07'!
write: anObject to: aModel
	super write: anObject to: aModel.
	anObject isNil
		ifFalse: [ anObject owner: aModel ]! !

!MAVisitor methodsFor: '*pier-model-accessing' stamp: 'lr 3/9/2006 11:29'!
context
	^ PRCurrentContext value! !

!MAVisitor methodsFor: '*pier-model-accessing' stamp: 'lr 3/9/2006 11:29'!
context: aContext
	PRCurrentContext value: aContext! !

!MAVisitor methodsFor: '*pier-model-visiting-description' stamp: 'lr 10/17/2007 23:02'!
visitDocumentDescription: anObject
	self visitMemoDescription: anObject! !

!MAVisitor methodsFor: '*pier-model-visiting-description' stamp: 'lr 10/16/2007 20:03'!
visitStructureDescription: anObject
	self visitElementDescription: anObject! !

!MAStringReader methodsFor: '*pier-model-visiting' stamp: 'lr 10/16/2007 20:12'!
visitDocumentDescription: aDescription
	self object: (aDescription parserClass
		parseStream: self stream)! !

!MAStringReader methodsFor: '*pier-model-visiting' stamp: 'lr 4/11/2009 11:10'!
visitStructureDescription: aDescription
	self object: (self context structure
		lookupPath: self contents
		ifAbsent: [ self error: 'Invalid path' ])! !

GRNotification subclass: #PRCurrentContext
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Kernel'!

!PRCurrentContext commentStamp: 'lr 5/28/2006 17:06' prior: 0!
I am a dynamic variable. I answer the current context when being raised.!

!PRCurrentContext class methodsFor: 'utilities' stamp: 'lr 3/9/2006 11:30'!
use: anObject during: aBlock
	^ aBlock on: self do: [ :notification | notification resume: anObject ]! !

!PRCurrentContext class methodsFor: 'accessing' stamp: 'jf 9/24/2009 14:32'!
value
	"This is the read accessor of the current context."

	| holder |
	holder := self signal.
	^ holder isNil ifFalse: [ holder context ]! !

!PRCurrentContext class methodsFor: 'accessing' stamp: 'jf 9/6/2009 20:13'!
value: aContext
	"This is the write accessor of the current context."

	self signal context: aContext! !

MAMemoDescription subclass: #PRDocumentDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Magritte'!

!PRDocumentDescription class methodsFor: 'accessing-defaults' stamp: 'lr 9/3/2009 17:23'!
defaultKind
	^ PRDocument! !

!PRDocumentDescription class methodsFor: 'accessing' stamp: 'lr 10/17/2007 22:59'!
label
	^ 'Document'! !

!PRDocumentDescription methodsFor: 'visiting' stamp: 'lr 10/16/2007 20:02'!
acceptMagritte: aVisitor
	aVisitor visitDocumentDescription: self! !

!PRDocumentDescription methodsFor: 'accessing' stamp: 'lr 4/10/2008 14:18'!
accessor: anAccessor
	super accessor: (PRDocumentAccessor on: anAccessor asAccessor)! !

!PRDocumentDescription methodsFor: 'testing' stamp: 'lr 9/22/2008 08:38'!
isDocumentDescription
	^ true! !

!PRDocumentDescription methodsFor: 'accessing' stamp: 'lr 10/16/2007 20:10'!
parserClass
	"Answer the default document parser for the receiver."

	^ PRDocumentParser! !

!PRDocumentDescription methodsFor: 'accessing' stamp: 'lr 10/16/2007 20:10'!
writerClass
	"Answer the default document writer for the receiver."

	^ PRWikiWriter! !

!Collection methodsFor: '*pier-model' stamp: 'lr 3/9/2006 11:29'!
accept: aVisitor
	aVisitor visitAll: self! !

MAElementDescription subclass: #PRStructureDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Magritte'!

!PRStructureDescription class methodsFor: 'accessing-defaults' stamp: 'lr 9/3/2009 17:24'!
defaultKind
	^ PRStructure! !

!PRStructureDescription class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRStructureDescription class methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
label
	^ 'Structure'! !

!PRStructureDescription methodsFor: 'visiting' stamp: 'lr 3/9/2006 11:30'!
acceptMagritte: aVisitor
	aVisitor visitStructureDescription: self! !

!MADescription methodsFor: '*pier-model' stamp: 'lr 5/24/2006 15:15'!
beEditable
	self propertyAt: #editable put: true! !

!MADescription methodsFor: '*pier-model' stamp: 'lr 12/15/2006 12:08'!
beSearchable
	self propertyAt: #searchable put: true! !

!MADescription methodsFor: '*pier-model' stamp: 'lr 9/22/2008 08:39'!
isDocumentDescription
	^ false! !

!MADescription methodsFor: '*pier-model' stamp: 'lr 5/24/2006 15:15'!
isEditable
	^ self propertyAt: #editable ifAbsent: [ false ]! !

!MADescription methodsFor: '*pier-model' stamp: 'lr 12/15/2006 12:08'!
isSearchable
	^ self propertyAt: #searchable ifAbsent: [ false ]! !

!MADescription methodsFor: '*pier-model' stamp: 'lr 3/26/2009 20:56'!
parameterName
	^ self propertyAt: #parameterName ifAbsent: [ nil ]! !

!MADescription methodsFor: '*pier-model' stamp: 'lr 3/26/2009 20:57'!
parameterName: aString
	self propertyAt: #parameterName put: aString! !

GRError subclass: #PRError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Core'!

GRObject subclass: #PRBasicObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Core'!

!PRBasicObject class methodsFor: 'error handling' stamp: 'jf 9/18/2009 15:40'!
defaultErrorClass
	^ PRError! !

!PRBasicObject class methodsFor: 'license' stamp: 'jf 9/24/2009 14:09'!
pierLicense
	"Return a string with the license of the package. This string shall not be removed or altered in any case."

	^ 'The MIT License

Copyright (c) 2003-' , Date today year printString , ' Lukas Renggli, renggli at gmail.com

Copyright (c) 2003-' , Date today year printString , ' Contributors

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.'! !

PRBasicObject subclass: #PRDocumentParser
	instanceVariableNames: 'document stream textMatcher lineMatcher currentMarkup currentStart remainingString'
	classVariableNames: 'CharacterCr CharacterLf LineMatcher LineMatcherDefault TextMatcher'
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRDocumentParser class methodsFor: 'private' stamp: 'lr 5/26/2009 22:17'!
buildLineMatcher
	| result |
	result := Dictionary new.
	result
		at: PRAnchor markup put: PRAnchor;
		at: PRHorizontalRule markup put: PRHorizontalRule;
		at: PRHeader markup put: PRHeader;
		at: PRDataItem markup put: PRList;
		at: PRTermItem markup put: PRList;
		at: PRUnorderedList markup put: PRList;
		at: PROrderedList markup put: PRList;
		at: PRTableCell markup put: PRTable;
		at: PRPreformatted markup put: PRPreformatted;
		at: PRAnnotatedParagraph markup put: PRAnnotatedParagraph.
	^ result! !

!PRDocumentParser class methodsFor: 'private' stamp: 'lr 2/2/2010 15:38'!
buildTextMatcher
	| result |
	result := Dictionary new.
	result
		at: '*' put: PRLink;
		at: '+' put: PRLink;
		at: PRVerbatim markupBegin put: PRVerbatim.
	PRFormat allSubclassesDo: [ :each |
		result
			at: each markup
			put: each ].
	^ result! !

!PRDocumentParser class methodsFor: 'escaping' stamp: 'lr 12/21/2009 14:02'!
escape: aString
	^ self escape: aString all: (PRDocumentParser on: nil) textMatcher reverse! !

!PRDocumentParser class methodsFor: 'escaping' stamp: 'lr 12/21/2009 14:02'!
escape: aString all: anArray
	^ anArray
		inject: (self escape: aString using: '\')
		into: [ :result :each | self escape: result using: each ]! !

!PRDocumentParser class methodsFor: 'escaping' stamp: 'lr 4/5/2007 14:04'!
escape: aString using: aSearchString
	| string index |
	string := aString.
	index := string findString: aSearchString.
	[ index > 0 ] whileTrue: [
		string := (string first: index - 1) , '\' , (string allButFirst: index - 1).
		index := string findString: aSearchString startingAt: index + aSearchString size + 1 ].
	^ string! !

!PRDocumentParser class methodsFor: 'utilities' stamp: 'lr 2/2/2010 15:26'!
findFirst: aSearchString at: anInteger in: aString
	"Find the first non-escaped occurence of aSearchString starting at anInteger in aString."

	| index |
	index := aString findString: aSearchString startingAt: anInteger.
	[ anInteger < index and: [ (aString at: index - 1 ifAbsent: nil) = $\ ] ]
		whileTrue: [ index := aString findString: aSearchString startingAt: index + 1 ].
	^ index! !

!PRDocumentParser class methodsFor: 'utilities' stamp: 'lr 2/2/2010 15:42'!
findFirstOf: anArray at: anInteger in: aString
	"Find the first non-escaped occurence of any of the search strings in anArray starting at anInteger in aString. Answer the search string or nil if not found."

	| index minIndex minMarkup |
	minIndex := aString size. minMarkup := nil.
	anArray do: [ :each |
		index := self findFirst: each at: anInteger in: aString.
		(0 < index and: [ index < minIndex ])
			ifTrue: [ minIndex := index. minMarkup := each ] ].
	^ minMarkup! !

!PRDocumentParser class methodsFor: 'initialization' stamp: 'lr 2/2/2010 15:39'!
initialize
	CharacterCr := Character cr.
	CharacterLf := Character lf.
	LineMatcher := LineMatcherDefault := TextMatcher := nil! !

!PRDocumentParser class methodsFor: 'accessing' stamp: 'lr 12/30/2007 22:34'!
lineMatcher
	^ LineMatcher ifNil: [ LineMatcher := self buildLineMatcher ]! !

!PRDocumentParser class methodsFor: 'accessing' stamp: 'lr 4/24/2007 21:08'!
lineMatcherDefault
	^ LineMatcherDefault ifNil: [ LineMatcherDefault := PRParagraph ]! !

!PRDocumentParser class methodsFor: 'parsing' stamp: 'lr 4/4/2007 14:59'!
on: aStream
	^ self basicNew initializeOn: aStream! !

!PRDocumentParser class methodsFor: 'parsing' stamp: 'lr 4/4/2007 14:58'!
parse: aString
	^ self parseStream: aString readStream! !

!PRDocumentParser class methodsFor: 'parsing' stamp: 'lr 4/4/2007 14:58'!
parseStream: aStream
	^ (self on: aStream) parse! !

!PRDocumentParser class methodsFor: 'private' stamp: 'damiencassou 7/23/2009 16:52'!
resetLineMatcher 
	LineMatcher := nil! !

!PRDocumentParser class methodsFor: 'private' stamp: 'damiencassou 7/23/2009 16:52'!
resetTextMatcher 
	TextMatcher := nil! !

!PRDocumentParser class methodsFor: 'accessing' stamp: 'lr 4/24/2007 21:08'!
textMatcher
	^ TextMatcher ifNil: [ TextMatcher := self buildTextMatcher ]! !

!PRDocumentParser class methodsFor: 'escaping' stamp: 'lr 6/15/2009 20:09'!
unescape: aString
	| input output |
	input := aString readStream.
	output := WriteStream on: (String new: aString size).
	[ input atEnd ] whileFalse: [
		output nextPutAll: (input upTo: $\).
		input atEnd
			ifFalse: [ output nextPut: input next ] ].
	^ output contents! !

!PRDocumentParser methodsFor: 'adding' stamp: 'lr 1/28/2009 10:06'!
add: aDocumentItem
	^ document add: aDocumentItem! !

!PRDocumentParser methodsFor: 'adding' stamp: 'lr 1/28/2009 10:09'!
addParagraph: aParagraph
	aParagraph children isEmpty
		ifTrue: [ self add: PREmptyParagraph new ]
		ifFalse: [
			self lastDocumentItem class = aParagraph class
				ifFalse: [ self add: aParagraph ]
				ifTrue: [
					self lastDocumentItem
						add: PRLineBreak new;
						addAll: aParagraph children ] ].
	^ self lastDocumentItem! !

!PRDocumentParser methodsFor: 'adding' stamp: 'lr 1/28/2009 10:09'!
combine: aClass with: aDocumentItem
	^ self lastDocumentItem class = aClass
		ifTrue: [ self lastDocumentItem add: aDocumentItem ]
		ifFalse: [ self add: (aClass with: aDocumentItem) ]! !

!PRDocumentParser methodsFor: 'accessing' stamp: 'lr 1/28/2009 10:07'!
document
	^ document! !

!PRDocumentParser methodsFor: 'initialization' stamp: 'lr 2/2/2010 17:40'!
initialize
	super initialize.
	textMatcher := self class textMatcher keys asArray
		sort: [ :a :b | a size > b size ];
		yourself.
	lineMatcher := self class lineMatcher keys asArray
		sort: [ :a :b | a size > b size ];
		yourself.
	self resetTopState.! !

!PRDocumentParser methodsFor: 'initialization' stamp: 'lr 9/4/2009 17:18'!
initializeOn: aStream
	self initialize.
	stream := aStream! !

!PRDocumentParser methodsFor: 'accessing' stamp: 'lr 1/28/2009 10:30'!
lastDocumentItem
	^ document children isEmpty ifFalse: [ document children last ]! !

!PRDocumentParser methodsFor: 'accessing' stamp: 'lr 4/12/2007 14:04'!
lineMatcher
	^ lineMatcher! !

!PRDocumentParser methodsFor: 'private' stamp: 'lr 12/20/2007 13:22'!
nextLine
	"Answer the next line. This method implements a state machine to properly detect line endings (cr, cr lf, or lf) as encountered from different sources."

	| output next |
	stream atEnd ifTrue: [ ^ nil ].
	output := WriteStream on: (String new: 100).
	[ stream atEnd ] whileFalse: [
		next := stream next.
		next == CharacterLf
			ifTrue: [ ^ output contents ].
		next == CharacterCr ifTrue: [
			stream peek == CharacterLf
				ifTrue: [ stream next ].
			^ output contents ].
		output nextPut: next ].
	^ output contents! !

!PRDocumentParser methodsFor: 'parsing' stamp: 'lr 2/2/2010 16:46'!
parse
	"Parse the input from the given stream and answer a *PRDocument*."

	document := PRDocument new.
	[ stream atEnd ]
		whileFalse: [ self parseLine: self nextLine ].
	^ document! !

!PRDocumentParser methodsFor: 'parsing' stamp: 'lr 2/2/2010 16:38'!
parseChunk! !

!PRDocumentParser methodsFor: 'parsing' stamp: 'lr 2/2/2010 16:41'!
parseLine
	"Parses a line, that represents a single line of input, to a *PRDocumentItem* and add it to the ==items== collection."

	self lineMatcher do: [ :string |
		(stream match: string) ifTrue: [
			^ (self class lineMatcher at: string)
				parse: stream with: self ] ].
	self class lineMatcherDefault
		parse: stream with: self! !

!PRDocumentParser methodsFor: 'parsing' stamp: 'lr 5/28/2007 16:31'!
parseLine: aString
	"Parses ==aString==, that represents a single line of input, to a *PRDocumentItem* and add it to the ==items== collection."

	self lineMatcher do: [ :string |
		(aString beginsWith: string) ifTrue: [
			^ (self class lineMatcher at: string)
				parse: aString with: self ] ].
	self class lineMatcherDefault
		parse: aString with: self! !

!PRDocumentParser methodsFor: 'parsing' stamp: 'lr 4/5/2007 16:02'!
parseString: aString
	| string |
	string := self class unescape: aString.
	string isEmpty ifTrue: [ ^ #() ].
	^ Array with: (PRText content: string)! !

!PRDocumentParser methodsFor: 'parsing' stamp: 'lr 2/18/2010 11:10'!
parseText: aString
	"Parses ==aString== and answer a collection of *PRText*, *PRFormat* and *PRLink* instances. Take care not to take into account any markup item that is escaped. This implementation is a bit slow, but who cares, it happens only once."

	| markup class start stop result |
	markup := self class findFirstOf: self textMatcher at: 1 in: aString.
	markup isNil ifFalse: [
		class := self class textMatcher at: markup.
		start := self class findFirst: markup at: 1 in: aString.
		stop := self class findFirst: (class markupEnd: markup) at: start + markup size in: aString.
		start < stop ifTrue: [
			result := WriteStream on: Array new.
			result nextPutAll: (self parseString: (aString first: start - 1)).
			result nextPut: (class
				parse: (aString copyFrom: start to: stop + markup size - 1)
				with: self).
			result nextPutAll: (self parseText: (aString allButFirst: stop + markup size - 1)).
			^ result contents ] ].
	^ self parseString: aString! !

!PRDocumentParser methodsFor: 'parsing' stamp: 'lr 2/18/2010 11:10'!
parseTopText: aString
	"Parses ==aString== and answer a collection of *PRText*, *PRFormat* and *PRLink* instances. Take care not to take into account any markup item that is escaped. This implementation is a bit slow, but who cares, it happens only once."

	| class stop result workingString previousStop |
	workingString := remainingString isEmpty
		ifTrue: [ aString ]
		ifFalse: [ remainingString , (String with: Character cr) , aString ].
	currentMarkup isNil ifTrue: [
		currentMarkup := self class
				findFirstOf: self textMatcher
				at: 1
				in: workingString ].
	currentMarkup isNil ifFalse: [ 
		class := self class textMatcher at: currentMarkup.
		currentStart := remainingString isEmpty
			ifTrue: [
				self class
					findFirst: currentMarkup
					at: 1
					in: workingString ]
			ifFalse: [ currentStart ].
		stop := self class
			findFirst: (class markupEnd: currentMarkup)
			at: currentStart + currentMarkup size
			in: workingString.
		currentStart < stop
			ifTrue:
				[ result := WriteStream on: Array new.
				result nextPutAll: (self parseString: (workingString first: currentStart - 1)).
				result nextPut: (class parse: (workingString copyFrom: currentStart to: stop + currentMarkup size - 1) with: self).
				previousStop := stop + currentMarkup size - 1.
				self resetTopState.
				result nextPutAll: (self parseTopText: (workingString allButFirst: previousStop)).
				^ result contents ]
			ifFalse:
				[ remainingString := workingString.
				^ stream atEnd
					ifTrue:
						[ self resetTopState.
						self parseText: workingString ]
					ifFalse: [ self parseTopText: self nextLine ] ] ].
	^ self parseString: aString! !

!PRDocumentParser methodsFor: 'private' stamp: 'lr 2/18/2010 11:10'!
resetTopState
	currentMarkup := nil.
	currentStart := 0.
	remainingString := String new! !

!PRDocumentParser methodsFor: 'accessing' stamp: 'lr 4/12/2007 14:04'!
textMatcher
	^ textMatcher! !

PRBasicObject subclass: #PRMacroExpander
	instanceVariableNames: 'character table'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Utilities'!

PRMacroExpander class
	instanceVariableNames: 'default'!

PRMacroExpander class
	instanceVariableNames: 'default'!

!PRMacroExpander class methodsFor: 'accessing' stamp: 'lr 2/17/2009 09:30'!
default
	^ default! !

!PRMacroExpander class methodsFor: 'class initialization' stamp: 'lr 2/17/2009 09:31'!
initialize
	default := self new.
	default
		on: $c do: #(command label);	" current command "
		on: $r do: #(kernel root title);	" current root structure "
		on: $t do: #(structure title);		" current structure "
		on: $k do: #(kernel name)		" current kernel name "! !

!PRMacroExpander class methodsFor: 'instance creation' stamp: 'lr 3/9/2006 11:30'!
on: aDictionary
	^ self new
		table: aDictionary;
		yourself! !

!PRMacroExpander class methodsFor: 'class initialization' stamp: 'jf 9/23/2009 14:51'!
unload
	default := nil! !

!PRMacroExpander methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
character
	^ character! !

!PRMacroExpander methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
character: aCharacter
	character := aCharacter! !

!PRMacroExpander methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2006 11:29'!
defaultCharacter
	^ $%! !

!PRMacroExpander methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2006 11:29'!
defaultTable
	^ Dictionary new! !

!PRMacroExpander methodsFor: 'evaluation' stamp: 'lr 4/24/2008 08:46'!
expand: aString with: anObject
	^ aString isEmptyOrNil
		ifTrue: [ aString ]
		ifFalse: [ self expandFrom: aString readStream with: anObject ]! !

!PRMacroExpander methodsFor: 'private' stamp: 'lr 4/24/2008 08:44'!
expandFrom: aReadStream with: anObject
	^ String streamContents: [ :writeStream |
		[ aReadStream atEnd ] whileFalse: [
			writeStream nextPutAll: (aReadStream upTo: self character).
			aReadStream atEnd 
				ifFalse: [ self expandFrom: aReadStream with: anObject on: writeStream ] ] ]! !

!PRMacroExpander methodsFor: 'private' stamp: 'lr 4/24/2008 08:45'!
expandFrom: aReadStream with: anObject on: aWriteStream
	| accessor char result |
	accessor := self table
		at: (char := aReadStream next)
		ifAbsent: [ nil ].
	accessor isNil
		ifTrue: [ aWriteStream nextPut: char ]
		ifFalse: [ 
			result := accessor read: anObject.
			result isNil
				ifFalse: [ aWriteStream nextPutAll: result ] ]! !

!PRMacroExpander methodsFor: 'initialization' stamp: 'jf 9/18/2009 15:44'!
initialize
	super initialize.
	self table: self defaultTable.
	self character: self defaultCharacter! !

!PRMacroExpander methodsFor: 'configuration' stamp: 'lr 4/24/2008 08:15'!
on: aCharacter do: anAccessor
	table at: aCharacter put: anAccessor asAccessor! !

!PRMacroExpander methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
table
	^ table! !

!PRMacroExpander methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
table: aDictionary
	table := aDictionary! !

PRBasicObject subclass: #PRMigrations
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Utilities'!

!PRMigrations class methodsFor: 'initialization' stamp: 'lr 11/15/2009 23:32'!
initialize
	self migrateParameters.
	self migrateChildren.
	self migrateTableCells.
	self migrateLinkOwner.
	self migrateObsoleteWidgets.
	self migrateChildrenArray! !

!PRMigrations class methodsFor: 'migrations' stamp: 'jf 9/30/2009 00:19'!
migrateChildren
	GRPlatform current 
		magritteAllSubInstancesOf: PRChildren
		do: 
			[ :each | 
			(each children isKindOf: Dictionary) ifTrue: [ each setChildren: each children asOrderedCollection ] ]! !

!PRMigrations class methodsFor: 'migrations' stamp: 'NickAger 1/7/2010 18:25'!
migrateChildrenArray
	GRPlatform current magritteAllSubInstancesOf: PRChildren do: [ :each |
		(each children isKindOf: OrderedCollection)
			ifTrue: [ each setChildren: each children ] ]! !

!PRMigrations class methodsFor: 'migrations' stamp: 'jf 9/30/2009 00:19'!
migrateLinkOwner
	GRPlatform current 
		magritteAllSubInstancesOf: PRStructure
		do: 
			[ :structure | 
			structure outgoingReferences
				continue: [ :link | false ];
				do: [ :link | link owner isNil ifTrue: [ link owner: structure ] ] ]! !

!PRMigrations class methodsFor: 'migrations' stamp: 'jf 9/30/2009 00:19'!
migrateObsoleteWidgets
	| componentClass |
	componentClass := (GRPlatform current magritteClassNamed: #PRComponent) ifNil: [ ^ self ].
	GRPlatform current 
		magritteAllSubInstancesOf: componentClass
		do: 
			[ :component | 
			
			[ :className :descriptionSelector | 
			| widgetClass theDescription |
			widgetClass := GRPlatform current magritteClassNamed: className.
			(widgetClass notNil and: [ component componentClass includesBehavior: widgetClass ]) ifTrue: 
				[ theDescription := widgetClass perform: descriptionSelector.
				component settings 
					at: theDescription
					ifPresent: 
						[ :classes | 
						component settings 
							at: theDescription
							put: (classes reject: [ :each | each isObsolete ]) ] ] ]
				value: #PRViewsWidget
					value: #descriptionViewClasses;
				value: #PRCommandsWidget
					value: #descriptionCommandClasses ]! !

!PRMigrations class methodsFor: 'migrations' stamp: 'jf 9/30/2009 00:19'!
migrateParameters
	GRPlatform current 
		magritteAllSubInstancesOf: PRLink
		do: [ :each | each parameters isNil ifTrue: [ each parameters: #() ] ]! !

!PRMigrations class methodsFor: 'migrations' stamp: 'jf 9/30/2009 00:19'!
migrateTableCells
	GRPlatform current 
		magritteAllSubInstancesOf: PRTableCell
		do: [ :each | each heading isNil ifTrue: [ each heading: false ] ]! !

PRBasicObject subclass: #PRObject
	instanceVariableNames: 'properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Core'!

!PRObject commentStamp: 'jf 9/18/2009 15:47' prior: 0!
I am a superclass of most objects within Pier. I hold a dictionary of properties, so that users can easily annotate me with new values. I am visitable.!

PRObject subclass: #PRCommand
	instanceVariableNames: 'timestamp context answer checked'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Command'!

!PRCommand commentStamp: 'lr 4/10/2007 21:13' prior: 0!
I am an abstract superclass of the command pattern in Pier. All modifications to the model have to be done through subclasses of myself, else they do not get properly logged with the persistency mechanism. I hold the context in which the receiver is executed in the instance variable context. To modify the resulting context, create a copy of the current context and store it in the instance variable answer.

The following event-handlers are called when executing an action in the given order. Do override these messages to customize the command, never override the other internal methods:
- Override the message ==#doValidate== to check the valid setup of the command and to raise exceptions in case any precondition isn't met. Speak here or forever have your peace!! Don't change the model in there.
- Override the message ==#doExecute== to execute the actual command. Do not raise exceptions in there, catch all the problems in ==#doValidate==.
- Override the message ==#doPersistency== to save the command that has been just executed with the current persistency strategy. Most commands don't need to override this message and just stick with the default behavior.
- Override the message ==#doAnswer== to create the answer context. Most commands don't need to override this message and just stick with the default behavior.

Do not play with funny jumpy things, such as resumable exceptions or continuations, inside the code of the command hierarchy or you will very likely run into severe problems.!

PRCommand subclass: #PRAddCommand
	instanceVariableNames: 'name type link title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Command'!

!PRAddCommand commentStamp: '<historical>' prior: 0!
I'm a command used to add new structures to your structures. My code is very interesting if you want to understand how Pier is designed.

Type is the class (subclass of PRStructure) for which a new instance will be created.!

!PRAddCommand class methodsFor: 'accessing' stamp: 'lr 5/3/2006 16:58'!
accessKey
	^ $a! !

!PRAddCommand class methodsFor: 'accessing-description' stamp: 'lr 5/31/2009 20:00'!
descriptionName
	^ MAStringDescription new
		addCondition: (MACondition receiver: PRPath selector: #isValidName:)
			labelled: 'Invalid structure name';
		parameterName: 'name';
		accessor: #name;
		label: 'Name';
		priority: 100;
		beRequired;
		yourself! !

!PRAddCommand class methodsFor: 'accessing-description' stamp: 'jf 9/17/2009 15:43'!
descriptionType
	^ MASingleOptionDescription new
		options: [ self structureClasses ] magritteDynamicObject;
		reference: MAClassDescription new;
		parameterName: 'type';
		default: PRPage;
		accessor: #type;
		label: 'Type';
		priority: 110;
		beRequired;
		beSorted;
		yourself! !

!PRAddCommand class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRAddCommand class methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
label
	^ 'Add'! !

!PRAddCommand class methodsFor: 'private' stamp: 'lr 3/28/2007 11:07'!
structureClasses
	| context |
	context := PRCurrentContext value.
	^ PRStructure withAllConcreteClasses select: [ :each |
		(context structure class canBeParentOf: each)
			and: [ each canBeChildOf: context structure class ] ]! !

!PRAddCommand methodsFor: 'private' stamp: 'lr 11/3/2009 21:55'!
child
	"Create a new structure of the selected species, a subclass of PRStructure. Set the title if necessary, else it will be generated automatically."

	| child |
	child := self type named: self name.
	(self title notNil and: [ self title notEmpty ])
		ifTrue: [ child title: self title ].
	^ child! !

!PRAddCommand methodsFor: 'events' stamp: 'lr 9/27/2007 09:15'!
doExecute
	"Create a new structure of requested type and add it to the children list of the current structure. If possible the following context will be set to an editor or a view onto the new structure."

	| structure |
	super doExecute.
	self structure
		addChild: (structure := self child).
	self link isNil
		ifFalse: [ self link target: structure; update ].
	self answer: (self context
		structure: structure
		command: (structure editCommandClass notNil
			ifTrue: [ structure editCommandClass ]
			ifFalse: [ structure viewCommandClass ])
				new)! !

!PRAddCommand methodsFor: 'events' stamp: 'lr 1/29/2007 15:10'!
doValidate
	"Verify that the new structure can be added before launching #doExecute. Basically, the name must be unique."

	super doValidate.
	self validateChild: self child in: self structure! !

!PRAddCommand methodsFor: 'accessing' stamp: 'lr 9/6/2006 13:14'!
link
	^ link! !

!PRAddCommand methodsFor: 'accessing' stamp: 'lr 9/6/2006 13:14'!
link: aLink
	link := aLink! !

!PRAddCommand methodsFor: 'accessing' stamp: 'lr 7/2/2009 18:38'!
name
	^ name ifNil: [ name := self uniqueName: self structure defaultChildName in: self structure ]! !

!PRAddCommand methodsFor: 'accessing' stamp: 'lr 11/3/2009 21:51'!
name: aString
	name := aString! !

!PRAddCommand methodsFor: 'actions' stamp: 'lr 11/3/2009 21:57'!
suggestName: aString
	"Suggest aString as the name and title of the newly created structure."

	self name: (aString collect: [ :char |
		(PRPath validCharacters includes: char)
			ifTrue: [ char ]
			ifFalse: [
				char = Character space
					ifTrue: [ $- ]
					ifFalse: [ $_ ] ] ]).
	self title: aString capitalized! !

!PRAddCommand methodsFor: 'accessing' stamp: 'lr 11/3/2009 21:55'!
title
	^ title! !

!PRAddCommand methodsFor: 'accessing' stamp: 'lr 11/3/2009 21:55'!
title: aString
	title := aString! !

!PRAddCommand methodsFor: 'accessing' stamp: 'lr 5/26/2009 21:43'!
type
	^ type ifNil: [ type := self structure defaultChildClass ]! !

!PRAddCommand methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
type: aClass
	type := aClass! !

PRCommand subclass: #PRChangeCommand
	instanceVariableNames: 'fields'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Command'!

!PRChangeCommand commentStamp: 'lr 11/5/2007 21:34' prior: 0!
Abstract command to edit structures.!

!PRChangeCommand methodsFor: 'events' stamp: 'lr 11/6/2007 08:17'!
doExecute
	super doExecute.
	self fields keysAndValuesDo: [ :desc :value | self target write: value using: desc ]! !

!PRChangeCommand methodsFor: 'accessing' stamp: 'lr 2/8/2009 19:23'!
fields
	"Answer a dictionary mapping descriptions to their respective data fields."
	
	^ fields ifNil: [ fields := Dictionary new ]! !

!PRChangeCommand methodsFor: 'copying' stamp: 'lr 11/20/2007 16:23'!
postCopy
	super postCopy.
	fields := fields copy! !

!PRChangeCommand methodsFor: 'private' stamp: 'lr 11/5/2007 21:53'!
readUsing: aDescription
	^ self fields at: aDescription ifAbsent: [ self target readUsing: aDescription ]! !

!PRChangeCommand methodsFor: 'accessing' stamp: 'lr 11/5/2007 21:53'!
target
	"The target where this edit operation is applied to."

	^ self structure! !

!PRChangeCommand methodsFor: 'private' stamp: 'lr 11/5/2007 21:38'!
write: anObject using: aDescription
	self fields at: aDescription put: anObject! !

PRChangeCommand subclass: #PREditCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Command'!

!PREditCommand commentStamp: 'lr 11/5/2007 21:40' prior: 0!
Command to edit a structure, e.g. all the descriptions that are tagged as ==#beEditable==.!

!PREditCommand class methodsFor: 'accessing' stamp: 'lr 5/3/2006 16:58'!
accessKey
	^ $e! !

!PREditCommand class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PREditCommand class methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
label
	^ 'Edit'! !

!PREditCommand methodsFor: 'accessing' stamp: 'lr 4/4/2009 17:33'!
description
	^ self structure editDescription! !

!PREditCommand methodsFor: 'testing' stamp: 'lr 3/9/2006 11:29'!
isEdit
	^ true! !

!PRCommand class methodsFor: 'accessing' stamp: 'lr 5/3/2006 16:57'!
accessKey
	^ nil! !

!PRCommand class methodsFor: 'instance creation' stamp: 'lr 1/29/2008 09:04'!
context: aContext
	(self isValidIn: aContext)
		ifFalse: [ self error: self label , ' is not useable in the given context.' ].
	^ self new
		setContext: aContext;
		yourself! !

!PRCommand class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isValidIn: aContext
	"Verify that a command as a meaning for the context aContext. Override this command to add new constraints that are static to the command."

	^ aContext structure isValidCommand: self in: aContext! !

!PRCommand class methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
shortLabel
	^ self label! !

!PRCommand class methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
structureClass
	^ PRStructure! !

!PRCommand methodsFor: 'accessing' stamp: 'lr 10/22/2007 22:12'!
answer
	"Return a new context that should be activated after executing this action. Since the answer might get modified afterwards, this should always be a copy."

	^ answer copy! !

!PRCommand methodsFor: 'accessing' stamp: 'lr 10/22/2007 22:12'!
answer: aContext
	"Set the resulting context of this command."

	answer := aContext! !

!PRCommand methodsFor: 'toggling' stamp: 'lr 2/12/2007 19:07'!
beChecked
	"Enable checks when executing the receiver. This is the default."

	checked := true! !

!PRCommand methodsFor: 'toggling' stamp: 'lr 3/10/2009 10:43'!
beUnchecked
	"Disable checks when executing the receiver. Do this only in a trusted environment and if you are absolutely sure that the execution will cause no conflicts."

	checked := false! !

!PRCommand methodsFor: 'accessing-readonly' stamp: 'lr 3/9/2006 11:29'!
context
	"Return the current context of the receiver."

	^ context! !

!PRCommand methodsFor: 'accessing-readonly' stamp: 'jf 9/18/2009 16:34'!
date
	"Answer the date when the command was executed."

	^ self timestamp isNil ifFalse: [ self timestamp date ]! !

!PRCommand methodsFor: 'events' stamp: 'lr 4/13/2007 14:45'!
doAnswer
	"Override this message to create the answer context. Most commands don't need to override this message and just stick with the default behavior."

	self answer ifNil: [ self answer: (self context structure: self structure) ]! !

!PRCommand methodsFor: 'events' stamp: 'lr 4/10/2007 21:44'!
doExecute
	"Override this message to execute the actual command. Do not raise exceptions in there, catch all the problems in ==#doValidate==."! !

!PRCommand methodsFor: 'events' stamp: 'lr 9/11/2006 10:54'!
doValidate
	"Override this message to check the valid setup of the command and to raise exceptions in case any precondition isn't met. Speak here or forever have your peace!! Don't change the model in there."

	self structure validateCommand: self! !

!PRCommand methodsFor: 'actions' stamp: 'jf 11/2/2009 10:06'!
execute
	"Execute the command of the receiver. To implement your action in the code of one of my subclasses. Never override this message, but instead have a look at the different template methods (==#doValidate==, ==#doExecute==, ==#doAnswer==) available in the events protocol."
	self context command == self ifFalse: [ self error: 'Attempt to execute command not in context.' ].
	self isView ifTrue: [ self shouldNotImplement ].
	self timestamp: GRPlatform current magritteTimeStampClass now.
	self kernel persistency execute: self.
	self doAnswer! !

!PRCommand methodsFor: 'testing' stamp: 'lr 4/10/2007 21:44'!
isChecked
	"Answer ==true== if the command should be checked before execution, e.g. the method ==#doValidate== should be executed at all."

	^ checked ifNil: [ checked := true ]! !

!PRCommand methodsFor: 'testing' stamp: 'lr 3/9/2006 11:29'!
isEdit
	^ false! !

!PRCommand methodsFor: 'testing' stamp: 'lr 5/27/2006 17:26'!
isLogged
	"Most commands are logged. This means they do modify the model and are therefore preserved in the history. However there are some that just display something or change the state of the current context and neither change the model nor need to be logged."

	^ true! !

!PRCommand methodsFor: 'testing' stamp: 'lr 5/27/2006 17:26'!
isQuick
	"Quick commands do not have a configuration interface (probably not even Magritte descriptions) and therefore should not be presented to the user but simply executed."

	^ false! !

!PRCommand methodsFor: 'testing' stamp: 'lr 4/10/2007 21:44'!
isView
	"Most commands are not a view. This means they override ==#doExecute== to do something meaningful on the context or the model."

	^ false! !

!PRCommand methodsFor: 'accessing-readonly' stamp: 'lr 5/28/2006 21:10'!
kernel
	"Answer the kernel the receiver is working on."

	^ self context kernel! !

!PRCommand methodsFor: 'accessing-readonly' stamp: 'lr 1/29/2008 09:01'!
label
	^ self class label! !

!PRCommand methodsFor: 'accessing-readonly' stamp: 'lr 3/9/2006 11:29'!
root
	^ self context kernel root! !

!PRCommand methodsFor: 'private' stamp: 'lr 5/5/2009 17:22'!
sanitizeAnswer
	<sanitize>
	
	answer := nil! !

!PRCommand methodsFor: 'initialization' stamp: 'lr 1/17/2007 11:30'!
setContext: aContext
	context := aContext! !

!PRCommand methodsFor: 'accessing-readonly' stamp: 'rjl 5/11/2006 22:36'!
structure
	^ self context structure! !

!PRCommand methodsFor: 'accessing-readonly' stamp: 'jf 9/18/2009 16:34'!
time
	"Answer the date when the command was executed."

	^ self timestamp isNil ifFalse: [ self timestamp time ]! !

!PRCommand methodsFor: 'accessing' stamp: 'lr 1/17/2007 11:30'!
timestamp
	^ timestamp! !

!PRCommand methodsFor: 'accessing' stamp: 'lr 1/17/2007 11:34'!
timestamp: aTimeStamp
	timestamp := aTimeStamp! !

!PRCommand methodsFor: 'private' stamp: 'jf 9/30/2009 01:10'!
uniqueName: aString in: aStructure 
	"Answer an unique structure name with the prefix aString within the parent aStructure."
	| index name |
	(aStructure isNil or: [ aStructure hasChildren not ]) ifTrue: [ ^ aString ].
	(aStructure childrenDecoration includes: aString) ifFalse: [ ^ aString ].
	index := 1.
	
	[ aStructure childrenDecoration includes: (name := aString , '-' , (index := index + 1) greaseString) ] whileTrue.
	^ name! !

!PRCommand methodsFor: 'validating' stamp: 'lr 4/10/2007 21:45'!
validateChild: aChildStructure in: aStructure
	"Make sure that ==aChildStructure== can be added as child or replace an existing child in a ==aStructure==."

	self validateChild: aChildStructure named: aChildStructure name in: aStructure! !

!PRCommand methodsFor: 'validating' stamp: 'lr 3/9/2006 11:29'!
validateChild: aChildStructure named: aString in: aStructure
	self validateName: aString of: aChildStructure in: aStructure.
	self validateNestingOf: aChildStructure in: aStructure! !

!PRCommand methodsFor: 'validating' stamp: 'lr 4/10/2007 21:45'!
validateName: aString of: aChildStructure in: aStructure
	"Make sure that ==aChildStructure== with the title ==aString== can be added as child or replace an existing child in a ==aStructure==."

	| child |
	(aStructure isNil or: [ aStructure hasChildren not ])
		ifTrue: [ ^ self ].
	child := aStructure childrenDecoration
		at: aString
		ifAbsent: [ ^ self ].
	child ~= aChildStructure
		ifTrue: [ PRConflictingNameError description: self description signal: aString printString , ' conflicts in ' , aStructure title printString ]! !

!PRCommand methodsFor: 'validating' stamp: 'lr 5/28/2007 16:31'!
validateNestingOf: aChildStructure in: aStructure
	"Make sure that ==aChildStructure== can be added as child to ==aStructure== and that ==aStructure== can have ==aChildStructure== as a child."

	aStructure isNil
		ifTrue: [ ^ self ].
	((aStructure canBeParentOf: aChildStructure)
		and: [ aChildStructure canBeChildOf: aStructure ])
			ifTrue: [ ^ self ].
	PRInvalidNestingError
		description: self description
		signal: aChildStructure title printString , ' can not be a child of ' , aStructure title printString! !

PRCommand subclass: #PRLocationCommand
	instanceVariableNames: 'name target'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Command'!

!PRLocationCommand commentStamp: 'lr 11/5/2007 21:36' prior: 0!
Abstract command to copy or move a structure.!

PRLocationCommand subclass: #PRCopyCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Command'!

!PRCopyCommand commentStamp: 'lr 11/5/2007 21:35' prior: 0!
Command to copy a structure.!

!PRCopyCommand class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRCopyCommand class methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
label
	^ 'Copy'! !

!PRCopyCommand methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2006 11:29'!
defaultName
	^ self uniqueName: self structure name , ' copy' in: self target! !

!PRCopyCommand methodsFor: 'events' stamp: 'lr 4/15/2009 18:31'!
doExecute
	| structure |
	super doExecute.
	self target childrenDecoration
		add: (structure := self structure copy
			name: self name;
			title: nil;
			yourself).
	self updateLinksFor: structure.
	self answer: (self context
		structure: structure)! !

!PRLocationCommand class methodsFor: 'accessing-description' stamp: 'lr 5/31/2009 20:01'!
descriptionName
	^ MAStringDescription new
		addCondition: (MACondition receiver: PRPath selector: #isValidName:)
			labelled: 'Invalid structure name';
		parameterName: 'name';
		accessor: #name;
		label: 'Name';
		priority: 110;
		beRequired;
		yourself! !

!PRLocationCommand class methodsFor: 'accessing-description' stamp: 'lr 5/31/2009 20:01'!
descriptionTarget
	^ PRStructureDescription new
		parameterName: 'target';
		accessor: #target;
		label: 'Target';
		priority: 100;
		beRequired;
		yourself! !

!PRLocationCommand methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2006 11:29'!
defaultName
	^ self structure name! !

!PRLocationCommand methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2006 11:29'!
defaultTarget
	^ self structure parent! !

!PRLocationCommand methodsFor: 'events' stamp: 'lr 3/9/2006 11:29'!
doValidate
	super doValidate.
	self validateChild: self structure named: self name in: self target! !

!PRLocationCommand methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
name
	^ name ifNil: [ name := self defaultName ]! !

!PRLocationCommand methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
name: aString
	name := aString! !

!PRLocationCommand methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
target
	^ target ifNil: [ target := self defaultTarget ]! !

!PRLocationCommand methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
target: aStructure
	target := aStructure! !

!PRLocationCommand methodsFor: 'private' stamp: 'lr 4/15/2009 18:32'!
updateLinksFor: aStructure
	| structures |
	structures := aStructure enumerator
		everything contents.
	aStructure root incomingReferences
		toAll: structures;
		do: [ :each | each update ].
	structures do: [ :structure |
		structure outgoingReferences
			do: [ :link | link update ] ]! !

PRLocationCommand subclass: #PRMoveCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Command'!

!PRMoveCommand commentStamp: 'lr 11/5/2007 21:35' prior: 0!
Command to move a structure.!

!PRMoveCommand class methodsFor: 'accessing' stamp: 'lr 5/3/2006 16:58'!
accessKey
	^ $m! !

!PRMoveCommand class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRMoveCommand class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isValidIn: aContext
	^ (super isValidIn: aContext)
		and: [ aContext structure isRoot not ]! !

!PRMoveCommand class methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
label
	^ 'Move'! !

!PRMoveCommand methodsFor: 'events' stamp: 'lr 6/12/2009 11:15'!
doExecute
	super doExecute.
	self structure name: self name.
	self structure parent = self target ifFalse: [
		self target 
			addChild: self structure remove ].
	self updateLinksFor: self structure! !

!PRMoveCommand methodsFor: 'events' stamp: 'lr 2/12/2007 19:07'!
doValidate
	super doValidate.
	(self structure isAncestorOf: self target)
		ifFalse: [ ^ self ].
	PRInvalidNestingError
		description: self description
		signal: self structure title printString , ' can not be moved into itself'! !

PRCommand subclass: #PROrderCommand
	instanceVariableNames: 'structures'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Command'!

!PROrderCommand class methodsFor: 'accessing-description' stamp: 'lr 11/15/2009 23:42'!
descriptionStructures
	^ MAToManyRelationDescription new
		classes: (Array with: PRStructure);
		reference: (MAContainer new
			add: PRStructure descriptionTitle;
			add: PRStructure descriptionName;
			yourself);
		accessor: #structures;
		label: 'Order';
		priority: 200;
		beDefinitive;
		beOrdered;
		yourself! !

!PROrderCommand class methodsFor: 'testing' stamp: 'lr 3/18/2008 21:52'!
isAbstract
	^ false! !

!PROrderCommand class methodsFor: 'testing' stamp: 'lr 11/15/2009 19:57'!
isValidIn: aContext
	^ (super isValidIn: aContext) and: [ aContext structure hasChildren ]! !

!PROrderCommand class methodsFor: 'accessing' stamp: 'lr 3/18/2008 21:51'!
label
	^ 'Order'! !

!PROrderCommand methodsFor: 'private' stamp: 'lr 3/18/2008 22:57'!
currentStructures
	^ self structure enumerator contents! !

!PROrderCommand methodsFor: 'events' stamp: 'lr 11/15/2009 23:35'!
doExecute
	super doExecute.
	self structure childrenDecoration 
		setChildren: self structures! !

!PROrderCommand methodsFor: 'events' stamp: 'lr 3/18/2008 22:58'!
doValidate
	"The order command needs to make sure that we don't loose added and that we don't reintroduce deleted structures. This code ensures that new structures are just a permutation of the existing ones."
	
	| prev next |
	super doValidate.
	prev := self currentStructures.
	next := structures copy.
	prev do: [ :each |
		(next includes: each)
			ifFalse: [ structures := structures copyWith: each ] ].
	next do: [ :each |
		(prev includes: each)
			ifFalse: [ structures := structures copyWithout: each ] ]! !

!PROrderCommand methodsFor: 'accessing' stamp: 'lr 3/18/2008 22:07'!
structures
	^ structures ifNil: [ structures := self currentStructures ]! !

!PROrderCommand methodsFor: 'accessing' stamp: 'lr 3/18/2008 22:57'!
structures: aCollection
	structures := aCollection! !

PRCommand subclass: #PRRemoveCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Command'!

!PRRemoveCommand commentStamp: 'lr 11/5/2007 21:35' prior: 0!
Command to remove a structure.!

!PRRemoveCommand class methodsFor: 'accessing' stamp: 'lr 5/3/2006 16:58'!
accessKey
	^ $r! !

!PRRemoveCommand class methodsFor: 'accessing-description' stamp: 'lr 9/9/2009 19:05'!
descriptionConfirmation
	^ PRDocumentDescription new
		accessor: #confirmation;
		priority: 100;
		beReadonly;
		yourself! !

!PRRemoveCommand class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRRemoveCommand class methodsFor: 'testing' stamp: 'lr 9/9/2009 18:59'!
isValidIn: aContext
	^ (super isValidIn: aContext) and: [ aContext structure isRoot not ]! !

!PRRemoveCommand class methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
label
	^ 'Remove'! !

!PRRemoveCommand methodsFor: 'accessing' stamp: 'lr 9/9/2009 19:31'!
confirmation
	^ self propertyAt: #confirmation ifAbsentPut: [
		| wiki |
		wiki := String streamContents: [ :stream |
			| structures |
			stream nextPutAll: '!!Do you really want to remove '; print: self structure title; nextPutAll: '?'; cr.
			structures := self structure enumerator all contents.
			structures isEmpty ifFalse: [
				stream nextPutAll: 'There '; nextPutAll: (structures size > 1 ifTrue: [ 'are' ] ifFalse: [ 'is' ]); nextPutAll: ' '; print: structures size; nextPutAll: ' child '; nextPutAll: (structures size > 1 ifTrue: [ 'structures' ] ifFalse: [ 'structure' ]); nextPut: $:; cr.
				structures 
					do: [ :structure | stream nextPutAll: '# *'; nextPutAll: structure absolutePath; nextPutAll: '*'; cr ] ].
			structures := self root incomingReferences to: self structure; collect: [ :each | each owner ].
			structures isEmpty ifFalse: [
				stream nextPutAll: 'There '; nextPutAll: (structures size > 1 ifTrue: [ 'are' ] ifFalse: [ 'is' ]); nextPutAll: ' '; print: structures size; nextPutAll: ' incoming '; nextPutAll: (structures size > 1 ifTrue: [ 'references' ] ifFalse: [ 'reference' ]); nextPut: $:; cr.
				structures 
					do: [ :structure | stream nextPutAll: '# *'; nextPutAll: structure absolutePath; nextPutAll: '*'; cr ] ] ].
		(PRDocumentParser parse: wiki) owner: self structure; yourself]! !

!PRRemoveCommand methodsFor: 'events' stamp: 'lr 3/28/2007 10:30'!
doExecute
	| parent |
	super doExecute.
	self root incomingReferences
		toAll: (self structure enumerator
			everything contents);
		do: [ :each | each target: nil ].
	parent := self structure parent.
	self structure remove.
	self answer: (self context
		structure: parent)! !

!PRRemoveCommand methodsFor: 'events' stamp: 'lr 3/5/2007 14:07'!
doValidate
	super doValidate.
	self structure isRoot
		ifFalse: [ ^ self ].
	(PRStructureError structure: self structure)
		signal: 'Unable to remove root node.'! !

PRCommand subclass: #PRViewCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Command'!

!PRViewCommand commentStamp: 'lr 11/5/2007 21:35' prior: 0!
Command (so called) to view a structure.!

!PRViewCommand class methodsFor: 'accessing' stamp: 'lr 5/3/2006 16:58'!
accessKey
	^ $v! !

!PRViewCommand class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRViewCommand class methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
label
	^ 'View'! !

!PRViewCommand methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isLogged
	^ false! !

!PRViewCommand methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isView
	^ true! !

PRObject subclass: #PRContext
	instanceVariableNames: 'kernel structure command'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Kernel'!

!PRContext commentStamp: 'lr 6/1/2006 21:12' prior: 0!
I am the context in which a user is browsing the system. I hold all the information any part of Pier might be interested in: the currently used kernel, the structure that is currently displayed, the command that is being executed and the user currently logged in.

I am an immutable object. Users should never try to modify me. Instead use the modification methods that return a copy of myself.!

!PRContext class methodsFor: 'descriptions' stamp: 'lr 5/5/2009 16:57'!
descriptionCommand
	^ MAStringDescription new
		chainAccessor: #(command label);
		label: 'Command';
		priority: 200;
		beReadonly;
		yourself! !

!PRContext class methodsFor: 'descriptions' stamp: 'lr 5/5/2009 16:57'!
descriptionDate
	^ MADateDescription new
		accessor: #(command date);
		parameterName: 'date';
		priority: 300;
		label: 'Date';
		beReadonly;
		yourself! !

!PRContext class methodsFor: 'descriptions' stamp: 'lr 5/5/2009 16:57'!
descriptionStructure
	^ PRStructureDescription new
		accessor: (MASelectorAccessor read: #structure write: #setStructure:);
		label: 'Structure';
		priority: 100;
		yourself! !

!PRContext class methodsFor: 'descriptions' stamp: 'lr 5/5/2009 16:57'!
descriptionTime
	^ MATimeDescription new
		accessor: #(command time);
		parameterName: 'time';
		priority: 400;
		label: 'Time';
		beReadonly;
		yourself! !

!PRContext class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRContext class methodsFor: 'instance creation' stamp: 'lr 3/9/2006 11:30'!
kernel: aKernel
	^ self kernel: aKernel structure: aKernel root! !

!PRContext class methodsFor: 'instance creation' stamp: 'lr 3/9/2006 11:30'!
kernel: aKernel structure: aStructure
	^ self kernel: aKernel structure: aStructure command: aStructure viewCommandClass new! !

!PRContext class methodsFor: 'instance creation' stamp: 'lr 3/9/2006 11:30'!
kernel: aKernel structure: aStructure command: aCommand
	^ self new
		setKernel: aKernel;
		setStructure: aStructure;
		setCommand: aCommand;
		yourself! !

!PRContext methodsFor: 'accessing' stamp: 'lr 4/10/2006 15:02'!
command
	"Answer the active command of this context."

	^ command! !

!PRContext methodsFor: 'navigation' stamp: 'lr 12/18/2009 13:50'!
command: aCommand
	"Create a copy of the current context with the current command replaced by ==aCommand==."

	^ self structure: self structure command: aCommand! !

!PRContext methodsFor: 'accessing-conveniance' stamp: 'lr 5/27/2006 17:28'!
commands
	"Answer a list of possible commands, dispatching through the command class."

	^ PRCommand withAllConcreteClasses
		select: [ :each | each isValidIn: self ]! !

!PRContext methodsFor: 'enumerating' stamp: 'lr 4/11/2009 10:27'!
enumerator
	"Answer an enumerator on the current context."

	^ self enumeratorFor: self structure! !

!PRContext methodsFor: 'enumerating' stamp: 'lr 11/15/2009 20:06'!
enumeratorFor: aStructure
	"Answer an enumerator on ==aStructure==."

	^ PRChildrenVisitor on: aStructure! !

!PRContext methodsFor: 'testing' stamp: 'lr 4/10/2007 21:46'!
isValid
	"Answer ==true== if the receiver is a valid context."

	^ self isValidCommand: self command class! !

!PRContext methodsFor: 'testing' stamp: 'lr 4/10/2007 21:46'!
isValidCommand: aCommandClass
	"Answer ==true== if the receiver is a valid context with the current command replaced by ==aCommandClass==."

	^ aCommandClass isValidIn: self! !

!PRContext methodsFor: 'accessing' stamp: 'lr 4/10/2006 15:01'!
kernel
	"Answer the underlying kernel of this context."

	^ kernel! !

!PRContext methodsFor: 'accessing-conveniance' stamp: 'lr 5/10/2008 13:02'!
parent
	"Answer the parent structure of the current structure or nil."

	^ self structure parent! !

!PRContext methodsFor: 'copying' stamp: 'lr 8/14/2007 23:51'!
postCopy
	super postCopy.
	self setCommand: command copy! !

!PRContext methodsFor: 'printing' stamp: 'NickAger 1/10/2010 19:56'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' structure: '; print: self structure title.
	aStream nextPutAll: ' command: '; print: self command class label! !

!PRContext methodsFor: 'accessing-conveniance' stamp: 'lr 3/9/2006 11:29'!
root
	"Answer the current root node of the structure-tree."

	^ self kernel root! !

!PRContext methodsFor: 'copying' stamp: 'lr 5/27/2009 16:13'!
sanitize
	"This method is used to prepare the receiver for persistent storage. Use it to clear temporal caches or references to UI objects."

	(Pragma allNamed: #sanitize from: self class to: PRContext)
		do: [ :pragma | self perform: pragma selector ].
	(Pragma allNamed: #sanitize from: self command class to: PRCommand)
		do: [ :pragma | self command perform: pragma selector ]! !

!PRContext methodsFor: 'initialization' stamp: 'lr 3/9/2006 11:29'!
setCommand: aCommand
	command := aCommand.
	command setContext: self! !

!PRContext methodsFor: 'initialization' stamp: 'lr 3/17/2008 16:37'!
setKernel: aKernel
	kernel := aKernel! !

!PRContext methodsFor: 'initialization' stamp: 'lr 3/9/2006 11:29'!
setStructure: aStructure
	structure := aStructure! !

!PRContext methodsFor: 'accessing-conveniance' stamp: 'lr 2/8/2009 19:23'!
siblings
	"Answer a collection of siblings including the current structure."

	^ self parent isNil 
		ifTrue: [ Array with: self structure ]
		ifFalse: [
			(self enumeratorFor: self parent)
				contents ]! !

!PRContext methodsFor: 'accessing' stamp: 'lr 4/10/2006 15:02'!
structure
	"Answer the currently browsed structure of this context."

	^ structure! !

!PRContext methodsFor: 'navigation' stamp: 'lr 4/10/2007 21:46'!
structure: aStructure
	"Create a copy of the current context with the current structure replaced by ==aStructure== and the current command replaced by the default view."

	^ self structure: aStructure command: aStructure viewCommandClass new! !

!PRContext methodsFor: 'navigation' stamp: 'lr 4/10/2007 21:47'!
structure: aStructure command: aCommand
	"Create a copy of the current context with the current structure replaced by ==aStructure== and the current command by ==aCommand==."

	^ self copy
		setStructure: aStructure;
		setCommand: aCommand;
		yourself! !

PRObject subclass: #PRDecorated
	instanceVariableNames: 'decorations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Structure'!

!PRDecorated commentStamp: 'lr 5/28/2006 17:43' prior: 0!
I am an abstract decorated object. My decorations are subclasses of *PRDecoration*. I provide all the tools to add, remove, query and visit my decorations.!

!PRDecorated methodsFor: 'visiting' stamp: 'lr 3/9/2006 11:29'!
acceptDecorated: aVisitor
	self
		decorationsDo: [ :each | aVisitor visit: each ]
		ownerDo: [ :each | super acceptDecorated: aVisitor ]! !

!PRDecorated methodsFor: 'adding' stamp: 'lr 4/10/2007 21:47'!
addDecoration: aDecoration
	"Add ==aDecoration== to the receiver. This message ensures that ==aDecoration== is only added once and that the decorations remain properly sorted."

	^ self
		addDecoration: aDecoration
		ifPresent: [ :value | PRDecorationError signal: 'Decoration is already part of receiver.' ]! !

!PRDecorated methodsFor: 'adding' stamp: 'lr 9/27/2007 10:39'!
addDecoration: aDecoration ifPresent: aBlock
	"Add ==aDecoration== to the receiver. This message ensures that the decorations remain properly sorted and that there are no duplicates. In case ==aDecoration== is already within the receiver, the existing decoration is passed into ==aBlock==."

	| decoration |
	decoration := self decorations
		detect: [ :each | aDecoration = each ]
		ifNone: [ nil ].
	^ decoration isNil
		ifFalse: [ aBlock value: decoration ]
		ifTrue: [
			self setDecorations: ((decorations
				copyWith: (aDecoration
					setDecorated: self;
					yourself)) sort; yourself).
			aDecoration ]! !

!PRDecorated methodsFor: 'querying' stamp: 'lr 4/10/2007 21:47'!
decorationOfClass: aClass
	"Answer the first decoration of ==aClass==, raise an error if none could be found."

	^ self
		decorationOfClass: aClass
		ifAbsent: [ PRDecorationError signal: 'Decoration not found.' ]! !

!PRDecorated methodsFor: 'querying' stamp: 'lr 4/10/2007 21:47'!
decorationOfClass: aClass ifAbsent: aBlock
	"Answer the first decoration of ==aClass==, evaluate ==aBlock== if none could be found."

	^ self decorations
		detect: [ :each | aClass = each species ]
		ifNone: aBlock! !

!PRDecorated methodsFor: 'accessing' stamp: 'lr 5/28/2006 17:37'!
decorations
	"Answer the sorted decorations of the receiver."

	^ decorations! !

!PRDecorated methodsFor: 'enumerating' stamp: 'lr 4/10/2007 21:47'!
decorationsDo: aBlock
	"Evaluate ==aBlock== in the right order with each of the receiver's decorations as the argument."

	self decorations do: aBlock! !

!PRDecorated methodsFor: 'enumerating' stamp: 'lr 4/10/2007 21:48'!
decorationsDo: aBlock ownerDo: anOwnerBlock
	"Evaluate ==aBlock== and ==anOwnerBlock== in the right order with each of the receiver's decorations and the receiver as the argument."

	self decorations do: [ :each |
		each priority negative
			ifTrue: [ aBlock value: each ] ].
	anOwnerBlock value: self.
	self decorations do: [ :each |
		each priority positive
			ifTrue: [ aBlock value: each ] ]! !

!PRDecorated methodsFor: 'initialization' stamp: 'lr 3/9/2006 11:29'!
initialize
	super initialize.
	self setDecorations: #()! !

!PRDecorated methodsFor: 'copying' stamp: 'lr 3/9/2006 11:29'!
postCopy
	super postCopy.
	self setDecorations: (self decorations collect: [ :each |
		each copy postCopyTo: self ])! !

!PRDecorated methodsFor: 'removing' stamp: 'lr 4/10/2007 21:48'!
removeDecoration: aDecoration
	"Remove ==aDecoration== from the receiver, an error is raised if ==aDecoration== is not part of the receiver."

	^ self
		removeDecoration: aDecoration
		ifAbsent: [ PRDecorationError signal: 'Decoration is not part of receiver.' ]! !

!PRDecorated methodsFor: 'removing' stamp: 'lr 4/10/2007 21:48'!
removeDecoration: aDecoration ifAbsent: aBlock
	"Remove ==aDecoration== from the receiver, ==aBlock== is evaluated if ==aDecoration== is not part of the receiver."

	| decoration |
	decoration := self decorations
		detect: [ :each | aDecoration = each ]
		ifNone: [ ^ aBlock value ].
	self setDecorations: (self decorations
		copyWithout: (decoration
			setDecorated: nil;
			yourself)).
	^ decoration! !

!PRDecorated methodsFor: 'initialization' stamp: 'lr 3/9/2006 11:29'!
setDecorations: anArray
	decorations := anArray! !

PRDecorated subclass: #PRStructure
	instanceVariableNames: 'parent name title tags'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Structure'!

!PRStructure commentStamp: 'lr 5/28/2006 17:41' prior: 0!
I am an abstract structure, representing the model of a single page. I've got a name, that must be unique within the scope of my parent, and a title. A structure is identified with a path of structure names.!

PRStructure subclass: #PRCase
	instanceVariableNames: 'document'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Structure'!

!PRCase commentStamp: 'lr 1/15/2007 21:42' prior: 0!
I am an abstract class holding onto a document definition representing the contents of the receiver. Most of my subclasses will allow user to edit myself using the Wiki syntax.!

!PRCase class methodsFor: 'accessing-description' stamp: 'lr 4/10/2008 14:17'!
descriptionDocument
	^ PRDocumentDescription new
		accessor: #document;
		label: 'Contents';
		beSearchable;
		priority: 500;
		beEditable;
		yourself! !

!PRCase methodsFor: 'visiting' stamp: 'lr 3/30/2007 20:01'!
accept: aVisitor
	aVisitor visitCase: self! !

!PRCase methodsFor: 'accessing-dynamic' stamp: 'lr 2/14/2008 11:00'!
contents
	"Answer a wiki string representation of the receiving document."
	
	^ self class descriptionDocument toString: (self readUsing: self class descriptionDocument)! !

!PRCase methodsFor: 'accessing-dynamic' stamp: 'lr 2/14/2008 11:00'!
contents: aString
	self 
		write: (self class descriptionDocument 
			fromString: (aString ifNil: [ String new ]))
		using: self class descriptionDocument! !

!PRCase methodsFor: 'accessing-defaults' stamp: 'lr 10/17/2007 22:52'!
defaultDocument
	"Answer the default document of the receiver."

	^ PRDocument new
! !

!PRCase methodsFor: 'accessing' stamp: 'lr 5/28/2006 17:35'!
document
	"Answer the document of the receiver."

	^ document! !

!PRCase methodsFor: 'accessing' stamp: 'lr 10/18/2007 17:43'!
document: aDocument
	document := aDocument.
	document ifNotNil: [ document owner: self ]! !

!PRCase methodsFor: 'testing' stamp: 'lr 3/9/2006 11:29'!
hasDocument
	^ self document notNil! !

!PRCase methodsFor: 'initialization' stamp: 'lr 1/15/2007 22:05'!
initialize
	super initialize.
	self document: self defaultDocument! !

!PRCase methodsFor: 'accessing-dynamic' stamp: 'lr 10/18/2007 17:31'!
plainText
	"Answer a plain text representation of the receiver's document."
	
	^ PRTextWriter write: self document! !

!PRCase methodsFor: 'copying' stamp: 'lr 3/9/2006 11:29'!
postCopy
	super postCopy.
	self document: self document copy! !

PRCase subclass: #PRPage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Structure'!

!PRPage commentStamp: 'lr 1/15/2007 21:42' prior: 0!
I am the most important class of the structure hierarchy.!

!PRPage class methodsFor: 'testing' stamp: 'lr 1/15/2007 21:35'!
isAbstract
	^ false! !

!PRPage methodsFor: 'visiting' stamp: 'lr 3/30/2007 20:01'!
accept: aVisitor
	aVisitor visitPage: self! !

!PRPage methodsFor: 'accessing-configuration' stamp: 'lr 4/5/2007 14:33'!
defaultDocument
	^ super defaultDocument
		add: (PRParagraph new
			add: (PRText content: 'Edit this page ...');
			yourself);
		yourself! !

PRStructure subclass: #PRFile
	instanceVariableNames: 'file'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Structure'!

!PRFile commentStamp: 'lr 6/2/2006 10:54' prior: 0!
I represent a data container for images, videos, sound, pdf or zip files. I reference an instance of *MAFileModel*. The mime-type is used to determine how the given file is be displayed. As an example images and videos are attempted to be inlined into the resulting output, whereas zip-files are referenced as a link to allow downloading.!

!PRFile class methodsFor: 'accessing-description' stamp: 'jf 9/28/2009 11:00'!
descriptionFile
	^ MAFileDescription new
		accessor: #file;
		priority: 300;
		label: 'File';
		beEditable;
		yourself! !

!PRFile class methodsFor: 'accessing' stamp: 'jf 9/28/2009 11:16'!
fileModel
	^ (self description detect: [ :each |
		each = self descriptionFile ])
			kind! !

!PRFile class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRFile class methodsFor: 'accessing' stamp: 'lr 1/8/2010 22:15'!
label
	^ 'File'! !

!PRFile methodsFor: 'visiting' stamp: 'lr 3/30/2007 20:01'!
accept: aVisitor
	aVisitor visitFile: self! !

!PRFile methodsFor: 'accessing-conveniance' stamp: 'lr 1/15/2010 15:48'!
contents
	"Answer a string representation of the file of the receiver. Directly access the file-model if you need the unconverted data source."

	^ self file contents asString! !

!PRFile methodsFor: 'accessing-conveniance' stamp: 'lr 1/15/2010 15:29'!
contents: aString
	"Set the contents of the receving file. Directly access the underlying file-model, if you do not want automatic conversion."

	self file contents: (aString ifNil: [ String new ]) asByteArray! !

!PRFile methodsFor: 'accessing-description' stamp: 'jf 9/29/2009 12:12'!
editDescription
	"Make text searchable and display a simple editor."

	^ self isText
		ifFalse: [ super editDescription ]
		ifTrue: [
			super editDescription
				add: (MAMemoDescription new 
					accessor: #stringContents;
					label: 'Contents';
					priority: 400;
					yourself);
				yourself ]! !

!PRFile methodsFor: 'accessing' stamp: 'jf 9/28/2009 11:18'!
file
	^ file ifNil: [ file := self class fileModel new ]! !

!PRFile methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
file: aFile
	file := aFile! !

!PRFile methodsFor: 'accessing-conveniance' stamp: 'lr 5/28/2008 15:30'!
filename: aString
	self file filename: aString! !

!PRFile methodsFor: 'testing' stamp: 'lr 1/29/2007 17:10'!
isFile
	^ true! !

!PRFile methodsFor: 'testing' stamp: 'lr 2/5/2009 21:30'!
isImage
	^ self file isImage! !

!PRFile methodsFor: 'testing' stamp: 'lr 2/5/2009 21:37'!
isText
	^ self file isText! !

!PRFile methodsFor: 'accessing-conveniance' stamp: 'lr 5/28/2008 14:43'!
mimetype: aString
	self file mimetype: aString! !

!PRFile methodsFor: 'copying' stamp: 'lr 3/9/2006 11:29'!
postCopy
	super postCopy.
	self file: self file copy! !

!PRFile methodsFor: 'accessing-conveniance' stamp: 'jf 9/30/2009 01:10'!
stringContents
	^ self contents greaseString! !

!PRFile methodsFor: 'accessing-conveniance' stamp: 'jf 9/29/2009 12:13'!
stringContents: aString
	^ self contents: aString asByteArray! !

!PRStructure class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
canBeChildOf: aStructureClass
	^ true! !

!PRStructure class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
canBeParentOf: aStructureClass
	^ true! !

!PRStructure class methodsFor: 'accessing-description' stamp: 'lr 3/26/2009 20:58'!
descriptionName
	^ MAStringDescription new
		parameterName: 'name';
		accessor: #name;
		label: 'Name';
		beSearchable;
		beRequired;
		yourself! !

!PRStructure class methodsFor: 'accessing-description' stamp: 'lr 7/2/2009 08:10'!
descriptionTags
	^ MATokenDescription new
		parameterName: 'tags';
		accessor: #tags;
		beSearchable;
		label: 'Tags';
		priority: 30;
		yourself! !

!PRStructure class methodsFor: 'accessing-description' stamp: 'lr 3/26/2009 20:58'!
descriptionTitle
	^ MAStringDescription new
		parameterName: 'title';
		accessor: #title;
		beSearchable;
		priority: 100;
		label: 'Title';
		beRequired;
		beEditable;
		yourself! !

!PRStructure class methodsFor: 'instance creation' stamp: 'lr 3/9/2006 11:30'!
named: aString
	^ self new
		name: aString;
		yourself! !

!PRStructure methodsFor: 'querying-path' stamp: 'lr 4/11/2009 10:29'!
absolutePath
	"Answer an absolute path from the root to the receiver."

	^ PRPathReference to: self! !

!PRStructure methodsFor: 'visiting' stamp: 'lr 3/30/2007 20:01'!
accept: aVisitor
	aVisitor visitStructure: self! !

!PRStructure methodsFor: 'actions' stamp: 'lr 4/10/2007 21:50'!
addChild: aStructure
	"Add ==aStructure== as child to the receiver."

	^ self childrenDecoration add: aStructure! !

!PRStructure methodsFor: 'testing' stamp: 'lr 4/10/2007 21:50'!
canBeChildOf: aStructure
	"Answer ==true== if the receiver can be a child of ==aStructure==."

	^ self class canBeChildOf: aStructure class! !

!PRStructure methodsFor: 'testing' stamp: 'lr 4/10/2007 21:50'!
canBeParentOf: aStructure
	"Answer ==true== if the receiver can be a parent of ==aStructure==."

	^ self class canBeParentOf: aStructure class! !

!PRStructure methodsFor: 'decorations' stamp: 'lr 9/25/2006 08:13'!
childrenDecoration
	"Answer a decoration with the children of the receiver. If no children exist, an empty children decoration is added to the receiver. Don't call this method directly to avoid empty children decorations."

	^ self
		decorationOfClass: self childrenDecorationClass
		ifAbsent: [ self addDecoration: self childrenDecorationClass new ]! !

!PRStructure methodsFor: 'decorations' stamp: 'lr 3/9/2006 11:30'!
childrenDecorationClass
	^ PRChildren! !

!PRStructure methodsFor: 'accessing-commands' stamp: 'lr 5/26/2009 21:43'!
defaultChildClass
	"Answer the class of the structure that should be selected by default when adding children."
	
	^ PRPage! !

!PRStructure methodsFor: 'accessing-commands' stamp: 'lr 7/2/2009 18:39'!
defaultChildName
	^ 'untitled'! !

!PRStructure methodsFor: 'accessing-commands' stamp: 'cdlm 8/7/2007 01:30'!
defaultCommandClass
	^ self viewCommandClass! !

!PRStructure methodsFor: 'accessing-dynamic' stamp: 'lr 9/27/2009 20:27'!
document
	"Answer a default document to represent the receiver, by default just embed itself."

	^ PRInternalLink new
		embedded: true;
		reference: '.';
		owner: self;
		target: self;
		yourself! !

!PRStructure methodsFor: 'accessing-commands' stamp: 'lr 6/2/2006 09:20'!
editCommandClass
	"Answer an instance of the default edit command of the receiver."

	^ PREditCommand! !

!PRStructure methodsFor: 'accessing-description' stamp: 'lr 4/4/2009 17:34'!
editDescription
	"Answer the descriptions that edit the receiver."

	^ self description select: [ :each | each isEditable ]! !

!PRStructure methodsFor: 'querying-relations' stamp: 'lr 3/9/2006 11:30'!
enumerator
	"Answer an enumerator on the children of the receiver."

	^ PRChildrenVisitor on: self! !

!PRStructure methodsFor: 'querying' stamp: 'lr 5/2/2009 09:55'!
findAncestor: aConditionBlock
	"Find the first structure starting at the receiver going up the parent chain, that satisfies the condition in aConditionBlock. Answer nil, if not present."
	
	^ self findAncestor: aConditionBlock ifAbsent: [ nil ]! !

!PRStructure methodsFor: 'querying' stamp: 'lr 5/2/2009 09:53'!
findAncestor: aConditionBlock ifAbsent: anAbsentBlock
	"Find the first structure starting at the receiver going up the parent chain, that satisfies the condition in aConditionBlock. Evaluate anAbsentBlock, if not present."
	
	| current |
	current := self.
	[ (aConditionBlock value: current)
		ifTrue: [ ^ current ].
	  (current := current parent) isNil ]
			whileFalse.
	^ anAbsentBlock value! !

!PRStructure methodsFor: 'querying-relations' stamp: 'lr 10/30/2006 20:15'!
fullTextSearch
	"Answer a visitor searching for text starting at the receiver."

	^ PRFullTextSearch on: self! !

!PRStructure methodsFor: 'testing' stamp: 'lr 9/27/2007 10:04'!
hasChildren
	"Answer ==true== if the receiver has got children, they might not be visible however."

	self enumerator 
		do: [ :each | ^ true ].
	^ false! !

!PRStructure methodsFor: 'testing' stamp: 'lr 4/7/2009 00:08'!
hasDocument
	"Answer wether the receiver has a changable document."

	^ false! !

!PRStructure methodsFor: 'testing' stamp: 'lr 4/10/2007 21:54'!
hasParent
	"Answer ==true== if the receiver has got a parent. This is the negation of ==#isRoot==."

	^ self parent notNil! !

!PRStructure methodsFor: 'querying-relations' stamp: 'lr 2/8/2009 19:24'!
incomingReferences
	"Answer a visitor on incoming references to structures being specified (using ==to:== and ==toAll:==) to the visitor before starting. The search will take off from the receiver."

	^ PRIncomingReferences on: self! !

!PRStructure methodsFor: 'testing' stamp: 'lr 4/10/2007 21:51'!
isAllowedCommand: aCommandClass in: aContext
 	"Answer ==true== if the receiver accepts ==aCommandClass== as allowed in ==aContext== on the receiver. If a command class is allowed is a security question and should therefore only depend on the permissions in the current context. The default implementation delegates the decision to the decorations of the receiver. Therefor this method should never be overridden by subclasses."

	^ self decorations allSatisfy: [ :each |
		each
			isAllowedCommand: aCommandClass
			in: aContext ]! !

!PRStructure methodsFor: 'testing' stamp: 'lr 4/10/2007 21:51'!
isAncestorOf: aStructure
	"Answer ==true== if the receiver is an ancestor of ==aStructure==."

	^ aStructure parents includes: self! !

!PRStructure methodsFor: 'testing' stamp: 'lr 4/10/2007 21:51'!
isApplyableCommand: aCommandClass in: aContext
 	"Answer ==true== if the receiver accepts ==aCommandClass== as applyable in ==aContext== on the receiver. If a command class is applyable or not is a question of saneness and compatibility, not of security. This method should be overridden by subclasses who want to forbid some commands."

	^ self isKindOf: aCommandClass structureClass! !

!PRStructure methodsFor: 'testing' stamp: 'lr 1/29/2007 17:09'!
isFile
	^ false! !

!PRStructure methodsFor: 'testing' stamp: 'lr 4/10/2007 21:51'!
isRoot
	"Answer ==true== if the receiver is the root of the Pier model. This is the negation of ==#hasParent==."

	^ self parent isNil! !

!PRStructure methodsFor: 'testing' stamp: 'lr 4/10/2007 21:52'!
isValidCommand: aCommandClass in: aContext
 	"Answer ==true== if the receiver accepts to execute ==aCommandClass== in ==aContext==. This message is the combination of ==#isApplyableCommand:in:== and ==#isAllowedCommand:in:==. It should not be overridden."

	^ (self isApplyableCommand: aCommandClass in: aContext)
		and: [ self isAllowedCommand: aCommandClass in: aContext ]! !

!PRStructure methodsFor: 'accessing-dynamic' stamp: 'lr 2/18/2009 14:21'!
kernel
	"Answer the kernel of the receiver."

	| root |
	root := self root.
	^ PRKernel instances
		detect: [ :each | each root = root ]
		ifNone: [ self error: self title , ' is not part of a kernel.' ]! !

!PRStructure methodsFor: 'accessing-dynamic' stamp: 'lr 4/11/2009 23:59'!
level
	"Answer the nesting level of the receiver, the root has a level of 1."

	| level current |
	level := 1.
	current := self.
	[ current isRoot ] whileFalse: [ 
		level := level + 1.
		current := current parent ].
	^ level! !

!PRStructure methodsFor: 'querying-path' stamp: 'lr 4/11/2009 18:10'!
lookupIncompletePath: aString
	"Lookup the path ==aString== as far as possible and answer an association of the last structure and the failing path element."
	
	^ PRIncompletePathLookup start: self path: aString! !

!PRStructure methodsFor: 'querying-path' stamp: 'lr 4/11/2009 11:10'!
lookupPath: aString
	"Lookup the path ==aString== starting at the receiver, answer ==nil== in case the structure can't be found."
	
	^ self lookupPath: aString ifAbsent: [ nil ]! !

!PRStructure methodsFor: 'querying-path' stamp: 'lr 4/11/2009 23:55'!
lookupPath: aString ifAbsent: aBlock
	"Lookup the path ==aString== starting at the receiver, evaluate ==aBlock== in case of an error."
	
	^ PRPathLookup start: self path: aString ifAbsent: aBlock! !

!PRStructure methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
name
	"Answer the name of the receiver. The name should be simple and only contain letters and numbers, since it is used as an identifier within restrictive protocols."

	^ name! !

!PRStructure methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
name: aString
	name := aString! !

!PRStructure methodsFor: 'querying-relations' stamp: 'lr 2/8/2009 19:24'!
outgoingReferences
	"Answer a visitor on all outgoing references taking off at the receiver. The visited objects are instances of ==*PRInternalLink*==."

	^ PROutgoingReferences on: self! !

!PRStructure methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
parent
	"Answer the parent structure of the receiver."

	^ parent! !

!PRStructure methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
parent: aStructure
	parent := aStructure! !

!PRStructure methodsFor: 'accessing-dynamic' stamp: 'lr 4/11/2009 23:58'!
parents
	"Answer an ordered collection of all the parents of the receiver up and including the receiver."
	
	| current result |
	current := self.
	result := OrderedCollection with: self.
	[ current isRoot ]
		whileFalse: [ result addFirst: (current := current parent) ].
	^ result! !

!PRStructure methodsFor: 'copying' stamp: 'lr 4/15/2009 18:06'!
postCopy
	super postCopy.
	self parent: nil; tags: self tags copy.
	self description do: [ :description |
		description isDocumentDescription ifTrue: [
			self
				write: (self readUsing: description) copy
				using: description ] ]! !

!PRStructure methodsFor: 'copying' stamp: 'lr 4/15/2009 18:02'!
postCopyTo: aStructure
	self parent: aStructure! !

!PRStructure methodsFor: 'printing' stamp: 'lr 3/9/2006 11:30'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' name: '; print: self name! !

!PRStructure methodsFor: 'querying-path' stamp: 'lr 4/11/2009 10:33'!
relativePathFrom: aStructrue
	"Answer a relative path from ==aStructure== to the receiver."
	
	^ aStructrue relativePathTo: self! !

!PRStructure methodsFor: 'querying-path' stamp: 'lr 4/11/2009 10:37'!
relativePathTo: aStructure
	"Answer a relative path from the receiver to ==aStructure==."
	
	^ PRPathReference from: self to: aStructure! !

!PRStructure methodsFor: 'actions' stamp: 'lr 6/2/2006 09:22'!
remove
	"Remove the receiver from the parent structure."

	self parent childrenDecoration remove: self! !

!PRStructure methodsFor: 'accessing-dynamic' stamp: 'lr 4/11/2009 23:57'!
root
	"Answer the root structure of the receiver."
	
	| current |
	current := self.
	[ current isRoot ]
		whileFalse: [ current := current parent ].
	^ current! !

!PRStructure methodsFor: 'accessing' stamp: 'lr 4/5/2007 17:59'!
tags
	"Answer a list of tags specific to the receiver."

	^ tags ifNil: [ tags := #() ]! !

!PRStructure methodsFor: 'accessing' stamp: 'lr 3/9/2007 14:20'!
tags: anArray
	tags := anArray! !

!PRStructure methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
title
	"Answer the title of the receiver, essentially the name but starting uppercase."

	^ title ifNil: [ title := self name capitalized ]! !

!PRStructure methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
title: aString
	title := aString! !

!PRStructure methodsFor: 'testing' stamp: 'lr 2/8/2009 19:24'!
validateCommand: aCommand
 	"Validates ==Command== to be executed within the context of the receiver. Throw an exception if there is something wrong with the command."

	self decorations do: [ :each | each validateCommand: aCommand ]! !

!PRStructure methodsFor: 'accessing-commands' stamp: 'lr 6/2/2006 09:20'!
viewCommandClass
	"Answer the default view command of the receiver. Most likely you never need to change the default implementation."

	^ PRViewCommand! !

PRObject subclass: #PRDecoration
	instanceVariableNames: 'decorated'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Structure'!

!PRDecoration commentStamp: 'lr 5/30/2006 19:16' prior: 0!
I am an abstract decoration to add new behaviour and data to structures. Every decoration knows its owner, a subclass of *PRDecorated*. Decorations are considered to be equal if they are of the same species, but subclasses might want to refine this behaviour to be able to add multiple instances of the same class.

Within the owner decorations are ordered according to their priority. Decorations with a negative priority are visited before the owner, decorations with a positive one after the owner.!

PRDecoration subclass: #PRChildren
	instanceVariableNames: 'children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Structure'!

!PRChildren commentStamp: 'lr 5/28/2006 17:47' prior: 0!
I hold the children of the decorated object.!

!PRChildren class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRChildren methodsFor: 'visiting' stamp: 'lr 3/30/2007 20:01'!
accept: aVisitor
	aVisitor visitChildren: self! !

!PRChildren methodsFor: 'actions' stamp: 'lr 11/15/2009 23:24'!
add: aStructure
	"Add ==aStructure== as a child to the receiver."
	
	(self isValidChild: aStructure)
		ifFalse: [ self error: aStructure title , ' is an invalid child in ' , self decorated title , '.' ].
	children := children 
		copyWith: (aStructure
			parent: self decorated;
			yourself).
	self triggerStructureAdded: aStructure.
	^ aStructure! !

!PRChildren methodsFor: 'accessing-children' stamp: 'lr 4/10/2007 21:43'!
at: aString
	"Answer the child structure with the name ==aString==, raise an error if the child can't be found."

	^ self at: aString ifAbsent: [ self error: 'Child not found.' ]! !

!PRChildren methodsFor: 'accessing-children' stamp: 'lr 3/17/2008 16:21'!
at: aString ifAbsent: aBlock
	"Answer the child structure with the name ==aString==, evaluate ==aBlock== if the child can't be found."

	^ children
		detect: [ :each | each name = aString ]
		ifNone: aBlock! !

!PRChildren methodsFor: 'accessing-children' stamp: 'lr 3/17/2008 16:20'!
at: aString ifPresent: aBlock
	^ aBlock value: (self at: aString ifAbsent: [ ^ nil ])! !

!PRChildren methodsFor: 'accessing-children' stamp: 'lr 11/15/2009 23:27'!
children
	"Answer an array of the receivers children."
	
	^ children! !

!PRChildren methodsFor: 'accessing-children' stamp: 'lr 3/17/2008 16:25'!
includes: aString
	self at: aString ifAbsent: [ ^ false ].
	^ true! !

!PRChildren methodsFor: 'initialization' stamp: 'lr 3/17/2008 16:25'!
initialize
	super initialize.
	self setChildren: OrderedCollection new! !

!PRChildren methodsFor: 'testing' stamp: 'lr 3/9/2006 11:29'!
isEmpty
	^ children isEmpty! !

!PRChildren methodsFor: 'testing' stamp: 'lr 6/15/2009 19:50'!
isValidChild: aStructure
	^ (PRPath isValidName: aStructure name)
		and: [ aStructure parent isNil
		and: [ (self includes: aStructure name) not
		and: [ (self decorated canBeParentOf: aStructure)
		and: [ (aStructure canBeChildOf: self decorated) ] ] ] ]! !

!PRChildren methodsFor: 'copying' stamp: 'lr 11/15/2009 23:27'!
postCopyTo: anObject
	super postCopyTo: anObject.
	children := children collect: [ :each | 
		each copy postCopyTo: self decorated ]! !

!PRChildren methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
priority
	^ 200! !

!PRChildren methodsFor: 'actions' stamp: 'TestRunner 11/15/2009 23:29'!
remove: aStructure
	"Remove ==aStructure== from the receiver."

	| index |
	index := children 
		indexOf: aStructure 
		ifAbsent: [ ^ nil ].
	children := (children copyFrom: 1 to: index - 1) , 
		(children copyFrom: index + 1 to: children size).
	self triggerStructureRemoved: aStructure.
	self isEmpty
		ifTrue: [ self remove ].
	^ aStructure
		parent: nil;
		yourself! !

!PRChildren methodsFor: 'initialization' stamp: 'lr 11/15/2009 23:26'!
setChildren: anArray
	children := anArray asArray! !

!PRChildren methodsFor: 'accessing' stamp: 'lr 5/28/2006 17:47'!
size
	"Answer the number of children of the receiver."

	^ self children size! !

!PRChildren methodsFor: 'events' stamp: 'lr 3/9/2006 11:29'!
triggerStructureAdded: aStructure
	PRDecoration withAllConcreteClassesDo: [ :each | each onStructureAdded: aStructure ]! !

!PRChildren methodsFor: 'events' stamp: 'lr 3/9/2006 11:29'!
triggerStructureRemoved: aStructure
	PRDecoration withAllConcreteClassesDo: [ :each | each onStructureRemoved: aStructure ]! !

!PRDecoration class methodsFor: 'events' stamp: 'lr 3/9/2006 11:30'!
onStructureAdded: aStructure
	"This event is called whenever a structure is added as a child to another structure."! !

!PRDecoration class methodsFor: 'events' stamp: 'lr 3/9/2006 11:30'!
onStructureRemoved: aStructure
	"This event is called whenever a structure is removed as a child from another structure."! !

!PRDecoration methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:29'!
<= aDecoration
	^ self priority <= aDecoration priority! !

!PRDecoration methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:29'!
= aDecoration
	^ self species = aDecoration species! !

!PRDecoration methodsFor: 'accessing' stamp: 'lr 5/28/2006 17:45'!
decorated
	"Answer the owner of the receiver, the decorated object."

	^ decorated! !

!PRDecoration methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:29'!
hash
	^ self species hash! !

!PRDecoration methodsFor: 'testing' stamp: 'lr 4/10/2007 21:48'!
isAllowedCommand: aCommandClass in: aContext
 	"Answer ==true== if the receiver allows one to execute ==aCommandClass== in ==aContext==. The default decoration is fine with all the commands, subclasses might restrict to a selected set of commands within a given context. This method might be overridden by decorations that want to control the security."

	^ true! !

!PRDecoration methodsFor: 'copying' stamp: 'lr 3/9/2006 11:29'!
postCopy
	super postCopy.
	self setDecorated: nil! !

!PRDecoration methodsFor: 'copying' stamp: 'lr 3/9/2006 11:29'!
postCopyTo: anObject
	super postCopyTo: anObject.
	self setDecorated: anObject! !

!PRDecoration methodsFor: 'accessing' stamp: 'lr 5/29/2006 09:27'!
priority
	"The default priority returns a number that defines in witch order the visitors will traverse through decorated objects. Negative numbers are visited before the decorated objects, positive numbers afterwards."

	^ self subclassResponsibility! !

!PRDecoration methodsFor: 'utilities' stamp: 'lr 3/9/2006 11:29'!
remove
	self decorated notNil
		ifFalse: [ ^ self ].
	self decorated
		removeDecoration: self
		ifAbsent: [ ]! !

!PRDecoration methodsFor: 'initialization' stamp: 'lr 3/9/2006 11:29'!
setDecorated: aStructure
	decorated := aStructure! !

!PRDecoration methodsFor: 'testing' stamp: 'lr 2/8/2009 19:23'!
validateCommand: aCommand
 	"Validates ==Command== to be executed within the context of the receiver."! !

PRObject subclass: #PRDocumentItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRDocumentItem commentStamp: 'lr 5/28/2006 20:30' prior: 0!
I am an abstract superclass for the document hierarchy. My subclasses include all the basic elements to represent a document.!

PRDocumentItem subclass: #PRAnchor
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRAnchor commentStamp: 'lr 5/29/2006 09:30' prior: 0!
I am an anchor within a document. I am used as a reference point within a large document.!

!PRAnchor class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRAnchor class methodsFor: 'accessing' stamp: 'lr 4/5/2007 13:10'!
markup
	^ '@'! !

!PRAnchor class methodsFor: 'instance creation' stamp: 'lr 4/5/2007 13:08'!
named: aString
	^ self new name: aString! !

!PRAnchor class methodsFor: 'instance creation' stamp: 'lr 4/24/2007 20:45'!
parse: aString with: aParser
	^ aParser add: (self named: (aString allButFirst: self markup size))! !

!PRAnchor methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:29'!
= anObject
	^ super = anObject
		and: [ self name = anObject name ]! !

!PRAnchor methodsFor: 'visiting' stamp: 'lr 3/30/2007 20:01'!
accept: aVisitor
	aVisitor visitAnchor: self! !

!PRAnchor methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:29'!
hash
	^ super hash bitXor: self name hash! !

!PRAnchor methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
name
	^ name! !

!PRAnchor methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
name: aString
	name := aString! !

PRDocumentItem subclass: #PRDocumentGroup
	instanceVariableNames: 'children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRDocumentGroup commentStamp: 'lr 5/28/2006 20:33' prior: 0!
I am an abstract group of document items.!

PRDocumentGroup subclass: #PRDocument
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRDocument commentStamp: 'lr 5/28/2006 21:06' prior: 0!
I am the root of a document composite.!

!PRDocument class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRDocument methodsFor: 'visiting' stamp: 'lr 3/30/2007 20:01'!
accept: aVisitor
	aVisitor visitDocument: self! !

!PRDocumentGroup class methodsFor: 'instance creation' stamp: 'lr 3/9/2006 11:30'!
with: aDocumentItem
	^ self new
		add: aDocumentItem;
		yourself! !

!PRDocumentGroup class methodsFor: 'instance creation' stamp: 'lr 3/9/2006 11:30'!
withAll: aCollection
	^ self new
		addAll: aCollection;
		yourself! !

!PRDocumentGroup methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:29'!
= anObject
	^ super = anObject
		and: [ self children = anObject children ]! !

!PRDocumentGroup methodsFor: 'visiting' stamp: 'lr 3/30/2007 20:01'!
accept: aVisitor
	aVisitor visitDocumentGroup: self! !

!PRDocumentGroup methodsFor: 'adding' stamp: 'lr 3/20/2006 19:06'!
add: aDocumentItem
	self setChildren: (self children copyWith: aDocumentItem)! !

!PRDocumentGroup methodsFor: 'adding' stamp: 'lr 7/31/2007 21:22'!
addAll: aCollection
	self setChildren: self children , aCollection! !

!PRDocumentGroup methodsFor: 'accessing' stamp: 'lr 5/28/2006 20:32'!
children
	"Answer the children of the receiver."

	^ children! !

!PRDocumentGroup methodsFor: 'testing' stamp: 'lr 3/9/2006 11:29'!
hasChildren
	^ self children notEmpty! !

!PRDocumentGroup methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:29'!
hash
	^ super hash bitXor: self children hash! !

!PRDocumentGroup methodsFor: 'initialization' stamp: 'lr 4/4/2007 15:05'!
initialize
	super initialize.
	self setChildren: #()! !

!PRDocumentGroup methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
owner: anObject
	super owner: anObject.
	self children do: [ :each | each owner: anObject ]! !

!PRDocumentGroup methodsFor: 'copying' stamp: 'lr 2/12/2007 19:07'!
postCopy
	super postCopy.
	self setChildren: (self children
		collect: [ :each | each copy ])! !

!PRDocumentGroup methodsFor: 'initialization' stamp: 'lr 3/20/2006 19:06'!
setChildren: aCollection
	children := aCollection! !

!PRDocumentGroup methodsFor: 'accessing-dynamic' stamp: 'lr 3/9/2006 11:29'!
size
	^ self children size! !

!PRDocumentGroup methodsFor: 'accessing-dynamic' stamp: 'lr 3/9/2006 11:29'!
text
	^ String streamContents: [ :stream |
		self children do: [ :each |
			stream nextPutAll: each text ] ]! !

PRDocumentGroup subclass: #PRFormat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

PRFormat subclass: #PRBoldFormat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRBoldFormat class methodsFor: 'testing' stamp: 'lr 3/30/2007 19:40'!
isAbstract
	^ false! !

!PRBoldFormat class methodsFor: 'accessing' stamp: 'lr 4/5/2007 15:36'!
markup
	^ '""'! !

!PRBoldFormat methodsFor: 'visiting' stamp: 'lr 3/30/2007 20:01'!
accept: aVisitor
	aVisitor visitBoldFormat: self! !

!PRFormat class methodsFor: 'accessing' stamp: 'lr 9/27/2007 10:32'!
markup
	self subclassResponsibility! !

!PRFormat class methodsFor: 'instance creation' stamp: 'lr 4/24/2007 21:10'!
parse: aString with: aParser
	^ self withAll: (aParser parseText: (aString copyFrom: self markup size + 1 to: aString size - self markup size))! !

!PRFormat methodsFor: 'visiting' stamp: 'lr 3/30/2007 20:01'!
accept: aVisitor
	aVisitor visitFormat: self! !

PRFormat subclass: #PRItalicFormat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRItalicFormat class methodsFor: 'testing' stamp: 'lr 3/30/2007 19:40'!
isAbstract
	^ false! !

!PRItalicFormat class methodsFor: 'accessing' stamp: 'lr 4/5/2007 15:36'!
markup
	^ ''''''! !

!PRItalicFormat methodsFor: 'visiting' stamp: 'lr 3/30/2007 20:01'!
accept: aVisitor
	aVisitor visitItalicFormat: self! !

PRFormat subclass: #PRMonospaceFormat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRMonospaceFormat class methodsFor: 'testing' stamp: 'lr 3/30/2007 19:40'!
isAbstract
	^ false! !

!PRMonospaceFormat class methodsFor: 'accessing' stamp: 'lr 3/30/2007 20:40'!
markup
	^ '=='! !

!PRMonospaceFormat methodsFor: 'visiting' stamp: 'lr 3/30/2007 20:01'!
accept: aVisitor
	aVisitor visitMonospaceFormat: self! !

PRFormat subclass: #PRStrikethroughFormat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRStrikethroughFormat class methodsFor: 'testing' stamp: 'lr 3/30/2007 19:40'!
isAbstract
	^ false! !

!PRStrikethroughFormat class methodsFor: 'accessing' stamp: 'lr 3/30/2007 19:44'!
markup
	^ '--'! !

!PRStrikethroughFormat methodsFor: 'visiting' stamp: 'lr 5/31/2007 07:46'!
accept: aVisitor
	aVisitor visitStrikethroughFormat: self! !

PRFormat subclass: #PRSubscriptFormat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRSubscriptFormat class methodsFor: 'testing' stamp: 'lr 3/30/2007 19:40'!
isAbstract
	^ false! !

!PRSubscriptFormat class methodsFor: 'accessing' stamp: 'lr 3/30/2007 19:46'!
markup
	^ '@@'! !

!PRSubscriptFormat methodsFor: 'visiting' stamp: 'lr 3/30/2007 20:01'!
accept: aVisitor
	aVisitor visitSubscriptFormat: self! !

PRFormat subclass: #PRSuperscriptFormat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRSuperscriptFormat class methodsFor: 'testing' stamp: 'lr 3/30/2007 19:40'!
isAbstract
	^ false! !

!PRSuperscriptFormat class methodsFor: 'accessing' stamp: 'lr 3/30/2007 19:45'!
markup
	^ '^^'! !

!PRSuperscriptFormat methodsFor: 'visiting' stamp: 'lr 3/30/2007 20:01'!
accept: aVisitor
	aVisitor visitSuperscriptFormat: self! !

PRFormat subclass: #PRUnderlineFormat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRUnderlineFormat class methodsFor: 'testing' stamp: 'lr 3/30/2007 19:43'!
isAbstract
	^ false! !

!PRUnderlineFormat class methodsFor: 'accessing' stamp: 'lr 3/30/2007 19:43'!
markup
	^ '__'! !

!PRUnderlineFormat methodsFor: 'visiting' stamp: 'lr 3/30/2007 20:01'!
accept: aVisitor
	aVisitor visitUnderlineFormat: self! !

PRDocumentGroup subclass: #PRHeader
	instanceVariableNames: 'level'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRHeader commentStamp: 'lr 5/28/2006 20:34' prior: 0!
I represent a header within a document. My level is a natural number.!

!PRHeader class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRHeader class methodsFor: 'accessing' stamp: 'lr 4/5/2007 13:10'!
markup
	^ '!!'! !

!PRHeader class methodsFor: 'instance creation' stamp: 'lr 2/2/2010 17:10'!
parse: aString with: aParser
	| index string |
	index := 0. string := aString.
	[ string beginsWith: self markup ] whileTrue: [
		index := index + 1.
		string := string allButFirst: self markup size ].
	^ aParser add: (self withAll: (aParser parseTopText: string) level: index)! !

!PRHeader class methodsFor: 'instance creation' stamp: 'lr 3/9/2006 11:30'!
withAll: aCollection level: anInteger
	^ (self withAll: aCollection)
		level: anInteger;
		yourself! !

!PRHeader methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:29'!
= anObject
	^ super = anObject
		and: [ self level = anObject level ]! !

!PRHeader methodsFor: 'visiting' stamp: 'lr 3/30/2007 20:01'!
accept: aVisitor
	aVisitor visitHeader: self! !

!PRHeader methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:29'!
hash
	^ super hash bitXor: self level hash! !

!PRHeader methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
level
	^ level! !

!PRHeader methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
level: anInteger
	level := anInteger! !

PRDocumentGroup subclass: #PRLink
	instanceVariableNames: 'reference owner embedded parameters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRLink commentStamp: 'lr 5/28/2006 21:02' prior: 0!
I am an abstract link built from an alias and a reference. The alias is the string representation that will be displayed to the user, whereas the reference is a string identifying the target. If there is no alias, the reference itself is displayed. Links can try to embed the referenced target into the containing document.

!!Examples
=*Reference*
=+Alias>Embedded Reference*!

PRLink subclass: #PRExternalLink
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRExternalLink commentStamp: 'lr 5/28/2006 20:41' prior: 0!
I am an abstract external link with an URL (Uniform Resource Locator) as reference.!

!PRExternalLink class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRExternalLink class methodsFor: 'testing' stamp: 'lr 8/26/2007 17:36'!
isValidReference: aString
	^ aString includesSubString: '://'! !

!PRExternalLink methodsFor: 'visiting' stamp: 'lr 3/30/2007 20:01'!
accept: aVisitor
	aVisitor visitExternalLink: self! !

!PRExternalLink methodsFor: 'testing' stamp: 'lr 4/1/2009 22:19'!
isExternal
	^ true! !

!PRExternalLink methodsFor: 'accessing' stamp: 'lr 9/8/2008 21:30'!
url
	"Answer the URL the receiver is pointing to."

	^ self urlPrefix , self urlEntry , self urlPostfix! !

!PRExternalLink methodsFor: 'accessing-dynamic' stamp: 'lr 3/9/2006 11:29'!
urlEntry
	^ self reference! !

!PRExternalLink methodsFor: 'accessing-dynamic' stamp: 'lr 10/20/2006 11:43'!
urlPostfix
	^ ''! !

!PRExternalLink methodsFor: 'accessing-dynamic' stamp: 'lr 10/20/2006 11:43'!
urlPrefix
	^ ''! !

PRExternalLink subclass: #PRMailLink
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRMailLink commentStamp: 'lr 6/2/2006 11:29' prior: 0!
I am an external link pointing to a mail address. I encode my URL to prevent spam bots collecting the address.!

!PRMailLink class methodsFor: 'testing' stamp: 'lr 9/22/2008 08:28'!
isValidReference: aString
	| index |
	index := aString indexOf: $@ ifAbsent: [ ^ false ].
	index := aString indexOf: $. startingAt: index ifAbsent: [ ^ false ].
	^ aString allSatisfy: [ :each | each isAlphaNumeric or: [ '@-.' includes: each ] ]! !

!PRMailLink class methodsFor: 'accessing' stamp: 'lr 1/9/2009 19:20'!
priority
	^ 50! !

!PRMailLink methodsFor: 'visiting' stamp: 'lr 3/30/2007 20:01'!
accept: aVisitor
	aVisitor visitMailLink: self! !

!PRMailLink methodsFor: 'accessing-dynamic' stamp: 'jf 11/2/2009 11:06'!
urlEntry
	^ String streamContents: [ :stream |
		super urlEntry do: [ :each |
			(1 to: 2) atRandom = 1
				ifTrue: [ stream nextPut: each ]
				ifFalse: [ stream nextPut: $%; nextPutAll: ((each codePoint printStringBase: 16)
		padded: #left to: 2 with: $0) ] ] ]! !

!PRMailLink methodsFor: 'accessing-dynamic' stamp: 'lr 3/9/2006 11:29'!
urlPrefix
	^ 'mailto:'! !

PRLink subclass: #PRInternalLink
	instanceVariableNames: 'target anchor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRInternalLink commentStamp: 'lr 4/10/2007 21:12' prior: 0!
I am an internal link pointing to a structure within the current kernel. I reference my owning structure to be able to lookup the referenced structure. The referenced structure is cached in the instance variable ==target==.!

!PRInternalLink class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRInternalLink class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isValidReference: aString
	^ true! !

!PRInternalLink class methodsFor: 'accessing' stamp: 'lr 1/9/2009 19:20'!
priority
	^ 100! !

!PRInternalLink class methodsFor: 'instance creation' stamp: 'lr 3/9/2006 11:30'!
reference: aString
	| index |
	^ (index := aString indexOf: $@) isZero
		ifTrue: [ super reference: aString ]
		ifFalse: [
			self new
				reference: (aString copyFrom: 1 to: index - 1);
				anchor: (aString copyFrom: index + 1 to: aString size);
				yourself ]! !

!PRInternalLink methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:29'!
= anObject
	^ super = anObject
		and: [ self anchor = anObject anchor ]! !

!PRInternalLink methodsFor: 'visiting' stamp: 'lr 3/30/2007 20:01'!
accept: aVisitor
	aVisitor visitInternalLink: self! !

!PRInternalLink methodsFor: 'accessing' stamp: 'lr 5/28/2006 20:48'!
anchor
	"Answer an anchor string the receiver is pointing to."

	^ anchor! !

!PRInternalLink methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
anchor: aString
	anchor := aString! !

!PRInternalLink methodsFor: 'testing' stamp: 'lr 3/9/2006 11:29'!
hasAnchor
	^ self anchor notNil! !

!PRInternalLink methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:29'!
hash
	^ super hash bitXor: self anchor hash! !

!PRInternalLink methodsFor: 'testing' stamp: 'lr 3/9/2006 11:29'!
isBroken
	^ self target isNil! !

!PRInternalLink methodsFor: 'testing' stamp: 'lr 3/9/2006 11:29'!
isInternal
	^ true! !

!PRInternalLink methodsFor: 'accessing' stamp: 'lr 4/24/2009 13:46'!
target
	"Answer the referenced structure. Do a lookup, if we haven't cached a real object reference."

	(target isNil and: [ self owner notNil and: [ self reference notNil ] ])
		ifTrue: [ target := self owner lookupPath: self reference ifAbsent: [ nil ] ].
	^ target! !

!PRInternalLink methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
target: aStructure
	target := aStructure! !

!PRInternalLink methodsFor: 'accessing-dynamic' stamp: 'lr 2/12/2007 19:07'!
title
	^ self target isNil
		ifTrue: [ super title ]
		ifFalse: [ self target title ]! !

!PRInternalLink methodsFor: 'actions' stamp: 'lr 4/15/2009 18:15'!
update
	"This method will be sent to all the internal-links whenever the owner is renamed or moved to a different location in the structure tree. It automatically adjusts the receivers state, so that the reference still points to the right location and doesn't get broken. The method tries to keep relative and absolute links consistent, whenever possible."	

	| absolute |
	(self target isNil or: [ self owner isNil ])
		ifTrue: [ ^ self ].
	absolute := self reference notNil
		and: [ self reference isEmpty not
		and: [ self reference first = PRPath pathDelimiter ] ].
	reference := absolute
		ifTrue: [ self target absolutePath ]
		ifFalse: [ self owner relativePathTo: self target ]! !

!PRLink class methodsFor: 'instance creation' stamp: 'lr 12/21/2009 14:14'!
escape: aString
	^ PRDocumentParser escape: aString all: (Array with: self markup with: self markupAlias with: self markupAnchor with: self markupEmbedded with: self markupParameter with: self markupParameterValue)! !

!PRLink class methodsFor: 'instance creation' stamp: 'lr 4/5/2007 15:16'!
fromString: aString
	| classes |
	classes := self withAllConcreteClasses
		select: [ :each | each isValidReference: aString ].
	classes sort: [ :a :b | a priority < b priority ].
	^ classes first reference: aString! !

!PRLink class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isValidReference: aString
	self subclassResponsibility! !

!PRLink class methodsFor: 'accessing' stamp: 'lr 4/5/2007 15:13'!
markup
	^ '*'! !

!PRLink class methodsFor: 'accessing' stamp: 'lr 4/5/2007 15:12'!
markupAlias
	^ '>'! !

!PRLink class methodsFor: 'accessing' stamp: 'lr 4/5/2007 15:12'!
markupAnchor
	^ '@'! !

!PRLink class methodsFor: 'accessing' stamp: 'lr 4/5/2007 15:12'!
markupEmbedded
	^ '+'! !

!PRLink class methodsFor: 'accessing' stamp: 'lr 8/26/2007 17:40'!
markupParameter
	^ '|'! !

!PRLink class methodsFor: 'accessing' stamp: 'lr 12/21/2009 14:14'!
markupParameterValue
	^ '='! !

!PRLink class methodsFor: 'instance creation' stamp: 'lr 2/2/2010 15:54'!
parse: aString with: aParser
	| string index embedded alias params |
	string := aString copyFrom: self markup size + 1 to: aString size - self markup size.
	embedded := aString beginsWith: self markupEmbedded.
	index := aParser class findFirst: self markupAlias at: 1 in: string.
	index isZero
		ifTrue: [ alias := #() ]
		ifFalse: [
			alias := aParser parseText: (string copyFrom: 1 to: index - 1).
			alias isEmpty ifTrue: [ alias := alias copyWith: (PRText content: '') ].
			string := string copyFrom: index + 1 to: string size ].
	index := aParser class findFirst: self markupParameter at: 1 in: string.
	index isZero
		ifTrue: [ params := #() ]
		ifFalse: [
			params := self parseParameters: (string copyFrom: index + 1 to: string size) with: aParser.
			string := string copyFrom: 1 to: index - 1 ].
	^ (self fromString: (aParser class unescape: string))
		parameters: params;
		embedded: embedded;
		addAll: alias;
		yourself! !

!PRLink class methodsFor: 'instance creation' stamp: 'lr 2/2/2010 15:54'!
parseParameters: aString with: aParser
	| index string result parameter |
	index := 1.
	string := aString.
	result := OrderedCollection new.
	[ string isEmpty ] whileFalse: [
		index := aParser class findFirst: self markupParameter at: 1 in: string.
		index := index < 1 
			ifTrue: [ string size ]
			ifFalse: [ index - self markupParameter size ].
		parameter := string first: index.
		string := string allButFirst: (string size min: index + self markupParameter size).
		parameter isEmpty ifFalse: [ 
			index := aParser class findFirst: self markupParameterValue at: 1 in: parameter.
			result add: (index isZero 
				ifTrue: [ (aParser class unescape: parameter) -> nil ]
				ifFalse: [
					(aParser class unescape: (parameter copyFrom: 1 to: index - 1))
						-> (aParser class unescape: (parameter copyFrom: index + self markupParameterValue size to: parameter size)) ]) ] ].
	^ result! !

!PRLink class methodsFor: 'accessing' stamp: 'lr 1/9/2009 19:18'!
priority
	^ 0! !

!PRLink class methodsFor: 'instance creation' stamp: 'lr 3/9/2006 11:30'!
reference: aString
	^ self new
		reference: aString;
		yourself! !

!PRLink methodsFor: 'comparing' stamp: 'lr 8/27/2007 10:28'!
= anObject
	^ super = anObject
		and: [ self reference = anObject reference
		and: [ self embedded = anObject embedded
		and: [ self parameters = anObject parameters ] ] ]! !

!PRLink methodsFor: 'visiting' stamp: 'lr 3/30/2007 20:01'!
accept: aVisitor
	aVisitor visitLink: self! !

!PRLink methodsFor: 'accessing-dynamic' stamp: 'lr 5/28/2006 20:39'!
alias
	"Answer the alias of the receiver or an empty string if none."

	^ self text! !

!PRLink methodsFor: 'accessing' stamp: 'lr 4/10/2007 21:49'!
embedded
	"Answer ==true== if the reference should be embedded."

	^ embedded! !

!PRLink methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
embedded: aBoolean
	embedded := aBoolean! !

!PRLink methodsFor: 'testing' stamp: 'lr 3/9/2006 11:29'!
hasAlias
	^ self hasChildren! !

!PRLink methodsFor: 'testing' stamp: 'lr 3/9/2006 11:29'!
hasAnchor
	^ false! !

!PRLink methodsFor: 'accessing-parameters' stamp: 'lr 10/9/2008 12:08'!
hasParameter: aKey
	self
		parameterAt: aKey
		ifAbsent: [ ^ false ].
	^ true! !

!PRLink methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:29'!
hash
	^ super hash bitXor: (self reference hash bitXor: self embedded hash)! !

!PRLink methodsFor: 'initialization' stamp: 'lr 1/30/2009 20:03'!
initialize
	super initialize.
	self embedded: false.
	self parameters: #()! !

!PRLink methodsFor: 'testing' stamp: 'lr 4/10/2007 21:49'!
isBroken
	"Answer ==true== if the receiver is broken."

	^ false! !

!PRLink methodsFor: 'testing' stamp: 'lr 3/9/2006 11:29'!
isEmbedded
	^ self embedded! !

!PRLink methodsFor: 'testing' stamp: 'lr 4/1/2009 22:18'!
isExternal
	^ false! !

!PRLink methodsFor: 'testing' stamp: 'lr 3/9/2006 11:29'!
isInternal
	^ false! !

!PRLink methodsFor: 'testing' stamp: 'lr 4/16/2007 12:00'!
isLink
	^ true! !

!PRLink methodsFor: 'accessing' stamp: 'lr 4/6/2009 13:22'!
owner
	^ owner! !

!PRLink methodsFor: 'accessing' stamp: 'lr 4/15/2009 18:12'!
owner: anObject
	super owner: (owner := anObject)! !

!PRLink methodsFor: 'accessing-parameters' stamp: 'lr 9/8/2008 17:17'!
parameterAt: aKey
	^ self parameterAt: aKey ifAbsent: [ nil ]! !

!PRLink methodsFor: 'accessing-parameters' stamp: 'lr 1/30/2009 20:03'!
parameterAt: aKey ifAbsent: aBlock
	| association |
	association := self parameters
		detect: [ :assoc | assoc key = aKey ] 
		ifNone: [ ^ aBlock value ].
	^ association value! !

!PRLink methodsFor: 'accessing-parameters' stamp: 'lr 2/2/2009 19:08'!
parameterAt: aKey ifPresent: aBlock
	^ aBlock value: (self parameterAt: aKey ifAbsent: [ ^ nil ])! !

!PRLink methodsFor: 'accessing-parameters' stamp: 'lr 1/30/2009 20:03'!
parameterAt: aKey put: aValue
	self parameters do: [ :assoc |
		assoc key = aKey ifTrue: [ 
			assoc value: aValue. 
			^ aValue ] ].
	self parameters: (self parameters
		copyWith: aKey -> aValue).
	^ aValue! !

!PRLink methodsFor: 'accessing' stamp: 'lr 5/20/2008 08:20'!
parameters
	"Answer an array of parameters."

	^ parameters! !

!PRLink methodsFor: 'accessing' stamp: 'lr 8/27/2007 10:41'!
parameters: aCollection
	parameters := aCollection asArray! !

!PRLink methodsFor: 'copying' stamp: 'lr 4/4/2009 11:50'!
postCopy
	super postCopy.
	self parameters: (self parameters
		collect: [ :each | each copy ])! !

!PRLink methodsFor: 'accessing' stamp: 'lr 5/28/2006 20:39'!
reference
	"Answer the reference of the receiver."

	^ reference! !

!PRLink methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
reference: aString
	reference := aString! !

!PRLink methodsFor: 'accessing-dynamic' stamp: 'lr 1/9/2009 19:26'!
text
	| text |
	^ (text := super text) isEmpty 
		ifTrue: [ self reference ]
		ifFalse: [ text ]! !

!PRLink methodsFor: 'accessing-dynamic' stamp: 'lr 10/20/2006 11:40'!
title
	"Answer a title of the link, this is should never be nil."

	^ self reference! !

!PRLink methodsFor: 'actions' stamp: 'lr 4/15/2009 17:36'!
update
	"Update the dynamic information of links, such as references and links."! !

PRLink subclass: #PRValueLink
	instanceVariableNames: 'selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRValueLink commentStamp: 'lr 2/5/2009 12:33' prior: 0!
I am a link to a contextual value. Contrary to all other links I am not necessarily rendered as a link but as a plain string or dynamic document depending on the current browsing context. Possible values are defined in my methods marked with the pragma ==<value:comment:>==.!

!PRValueLink class methodsFor: 'testing' stamp: 'lr 1/9/2009 19:20'!
isAbstract
	^ false! !

!PRValueLink class methodsFor: 'testing' stamp: 'lr 1/9/2009 20:19'!
isValidReference: aString
	^ aString beginsWith: 'value:'! !

!PRValueLink methodsFor: 'visiting' stamp: 'lr 5/13/2009 11:46'!
accept: aVisitor
	aVisitor visitValueLink: self! !

!PRValueLink methodsFor: 'values' stamp: 'lr 4/22/2009 12:58'!
childrenIn: aContext
	<value: 'children' comment: 'Display immediate children of the current structure.'>

	^ self lookupStructure: aContext structure do: [ :structure |
		self
			formatStructureCollection: (aContext
				enumeratorFor: structure) 
			in: aContext ]! !

!PRValueLink methodsFor: 'values' stamp: 'lr 4/22/2009 12:57'!
contentsIn: aContext
	<value: 'contents' comment: 'Display all the children of the current structure.'>

	^ self lookupStructure: aContext structure do: [ :structure |
		self 
			formatStructureCollection: (aContext
				enumeratorFor: structure) all
			in: aContext ]! !

!PRValueLink methodsFor: 'values' stamp: 'lr 4/13/2009 09:30'!
contextIn: aContext
	<value: 'context' comment: 'Display the current context.'>

	^ self formatDescribed: aContext default: #(command label)! !

!PRValueLink methodsFor: 'values' stamp: 'lr 4/1/2009 21:50'!
dateIn: aContext
	<value: 'date' comment: 'Display the current date.'>

	^ Date today! !

!PRValueLink methodsFor: 'values' stamp: 'lr 4/1/2009 21:51'!
editedIn: aContext
	<value: 'edited' comment: 'Display the last performed context.'>
	
	^ self lookupStructure: aContext structure do: [ :structure |
		aContext kernel persistency
			reverseDo: [ :each | ^ self contextIn: each ]
			for: structure.
		nil ]! !

!PRValueLink methodsFor: 'values' stamp: 'lr 4/22/2009 12:59'!
findIn: aContext
	<value: 'find' comment: 'Display all the structures matching the query parameter.'>

	^ self parameterAt: 'query' ifPresent: [ :query |
		self lookupStructure: aContext structure do: [ :structure |
			self
				formatStructureCollection: (structure fullTextSearch
					subString: query)
				in: aContext ] ]! !

!PRValueLink methodsFor: 'values' stamp: 'lr 4/22/2009 12:59'!
firstIn: aContext
	<value: 'first' comment: 'Display the first sibling of the current structure.'>
	
	^ self lookupStructure: aContext structure do: [ :structure |
		self 
			formatStructure: (aContext structure: structure)
				siblings first
			in: aContext ]! !

!PRValueLink methodsFor: 'private' stamp: 'lr 4/1/2009 22:13'!
formatCollection: aCollection
	"Format a collection of document objects or strings."
	
	| collection separator |
	collection := Array streamContents: [ :stream |
		aCollection do: [ :each |
			each isNil ifFalse: [ 
				each isString
					ifTrue: [ stream nextPut: (PRText content: each) ]
					ifFalse: [ stream nextPut: each ] ] ] ].
	collection isEmpty ifTrue: [ ^ nil ].
	^ (separator := self parameterAt: 'separator') isNil
		ifTrue: [
			collection
				inject: PRUnorderedList new
				into: [ :result :each | result add: (PRListItem with: each); yourself ] ]
		ifFalse: [
			Array streamContents: [ :stream |
				collection
					do: [ :each | stream nextPut: each ]
					separatedBy: [ stream nextPut: (PRText content: separator) ] ] ]! !

!PRValueLink methodsFor: 'private' stamp: 'lr 4/1/2009 21:34'!
formatDescribed: anObject default: anAccessor
	"Formats a described object anObject according to the display parameter, use anAccessor as a default."
	
	| display |
	anObject isNil 
		ifTrue: [ ^ nil ].
	(display := self parameterAt: 'display') isNil
		ifTrue: [ ^ anAccessor asAccessor read: anObject ].
	anObject description do: [ :description |
		description parameterName = display
			ifTrue: [ ^ description toString: ((anObject readUsing: description) ifNil: [ ^ nil ]) ] ].
	^ nil! !

!PRValueLink methodsFor: 'private' stamp: 'lr 4/22/2009 15:09'!
formatStructure: aStructure in: aContext
	"Format ==aStructure==. Link it, if the parameter ==link== is given; embed it, if the paremeter ==embed== is given."
	
	| string |
	((self selectAndReject: aStructure) isNil
		or: [ (aContext structure: aStructure) isValid not
		or: [ (aStructure propertyAt: #hideFromMenus ifAbsent: [ false ]) ] ])
			ifTrue: [ ^ nil ].
	string := self 
		formatDescribed: aStructure
		default: #title.
	^ ((self hasParameter: 'link') or: [ self hasParameter: 'embed' ])
		ifTrue: [
			PRInternalLink new
				embedded: (self hasParameter: 'embed');
				parameters: self parameters;
				target: aStructure;
				addAll: (string isNil
					ifTrue: [ Array new ]
					ifFalse: [ Array with: (PRText content: string) ]);
				yourself ]
		ifFalse: [ string isNil ifFalse: [ PRText content: string ] ]! !

!PRValueLink methodsFor: 'private' stamp: 'lr 4/29/2009 16:48'!
formatStructureCollection: aCollection in: aContext
	"Format a collection of structures."

	| result |
	^ self formatCollection: (Array streamContents: [ :stream |
		aCollection do: [ :each |
			(result := self formatStructure: each in: aContext) isNil
				ifFalse: [ stream nextPut: result ] ] ])! !

!PRValueLink methodsFor: 'values' stamp: 'lr 4/1/2009 22:24'!
historyIn: aContext
	<value: 'history' comment: 'Display the history for the current structure.'>
	
	| contexts |
	^ self lookupStructure: aContext structure do: [ :structure |
		contexts := (aContext kernel persistency historyFor: structure)
			collect: [ :context | self contextIn: context ].
		self formatCollection: contexts ]! !

!PRValueLink methodsFor: 'values' stamp: 'lr 4/29/2009 16:42'!
incomingIn: aContext
	<value: 'incoming' comment: 'Display all structures referencing the current structure.'>

	^ self lookupStructure: aContext structure do: [ :structure |
		self 
			formatStructureCollection: ((aContext root incomingReferences
				to: structure; 
				collect: [ :each | each owner ])
				select: [ :each | each notNil ]) asSet
			in: aContext ]! !

!PRValueLink methodsFor: 'testing' stamp: 'lr 5/13/2009 11:57'!
isBroken
	^ self selector isNil! !

!PRValueLink methodsFor: 'values' stamp: 'lr 4/1/2009 21:51'!
kernelIn: aContext
	<value: 'kernel' comment: 'Display kernel of this site.'>

	^ self formatDescribed: aContext kernel default: #name! !

!PRValueLink methodsFor: 'values' stamp: 'lr 4/22/2009 13:00'!
lastIn: aContext
	<value: 'last' comment: 'Display the last sibling of the current structure.'>
	
	^ self lookupStructure: aContext structure do: [ :structure |
		self 
			formatStructure: (aContext structure: structure) 
				siblings last
			in: aContext ]! !

!PRValueLink methodsFor: 'values' stamp: 'lr 4/1/2009 22:18'!
linksIn: aContext
	<value: 'links' comment: 'Display all links from the current structure.'>

	^ self lookupStructure: aContext structure do: [ :structure |
		self formatCollection: ((structure outgoingReferences 
			select: [ :each | each isInternal or: [ each isExternal ] ])
			collect: [ :each | each copy embedded: false ]) ]! !

!PRValueLink methodsFor: 'private' stamp: 'lr 4/24/2009 10:30'!
lookupStructure: aStructure do: aBlock
	"Lookup aStructure and evaluate aBlock if it is found. This performs different kinds of navigation starting from aStructure. If the parameter ==path== is given an absolute or relative lookup is started. The parameter ==level== choses a structure at the specified level in the parent chain, where the root is 1 and direct children of the root 2, etc. 0 is the current structure, -1 the parent of the current structure, etc. Furthermore the levels can be delimited using ==lower== and ==upper== bounds."

	| structure |
	structure := aStructure ifNil: [ ^ nil ].
	self parameterAt: 'target' ifPresent: [ :path |
		structure := structure
			lookupPath: path
			ifAbsent: [ ^ nil ] ].
	(self hasParameter: 'level') ifTrue: [
		| parents extractor level |
		parents := structure parents.
		extractor := [ :name |
			| value |
			value := (self parameterAt: name)
				asNumber asInteger.
			value < 1
				ifTrue: [ parents size + value ]
				ifFalse: [ value ] ].
		((level := extractor value: 'level') between: 1 and: parents size)
			ifFalse: [ ^ nil ].
		((self hasParameter: 'lower') and: [ level < (extractor value: 'lower') ])
			ifTrue: [ ^ nil ].
		((self hasParameter: 'upper') and: [ level > (extractor value: 'upper') ])
			ifTrue: [ ^ nil ].
		structure := parents at: level ifAbsent: [ ^ nil ] ].
	^ aBlock value: structure! !

!PRValueLink methodsFor: 'values' stamp: 'lr 4/23/2009 14:48'!
nextIn: aContext
	<value: 'next' comment: 'Display the following sibling of the current structure.'>
	
	^ self lookupStructure: aContext structure do: [ :target |
		| elements output |
		elements := (self hasParameter: 'nested')
			ifFalse: [ (aContext structure: target) siblings ]
			ifTrue: [ (aContext enumeratorFor: target root) everything contents ].
		(elements copyAfter: target) do: [ :structure |
			(output := self formatStructure: structure in: aContext) notNil
				ifTrue: [ ^ output ] ].
		nil ]! !

!PRValueLink methodsFor: 'values' stamp: 'lr 4/22/2009 12:58'!
outgoingIn: aContext
	<value: 'outgoing' comment: 'Display all structures referenced from the current structure.'>

	^ self lookupStructure: aContext structure do: [ :structure |
		self 
			formatStructureCollection: ((structure outgoingReferences
				select: [ :each | each isInternal ])
				collect: [ :each | each target ])
			in: aContext ]! !

!PRValueLink methodsFor: 'values' stamp: 'lr 5/6/2009 08:06'!
parentIn: aContext
	<value: 'parent' comment: 'Display the parent of the current structure.'>
	
	| output |
	^ self lookupStructure: aContext structure do: [ :target |
		target isRoot ifFalse: [
			target parent parents reverseDo: [ :structure |
				(output := self formatStructure: structure in: aContext) notNil
					ifTrue: [ ^ output ] ] ].
		nil ]! !

!PRValueLink methodsFor: 'values' stamp: 'lr 4/22/2009 12:58'!
parentsIn: aContext
	<value: 'parents' comment: 'Display the parent chain of the current structure.'>
	
	^ self lookupStructure: aContext structure do: [ :structure |
		self 
			formatStructureCollection: structure parents
			in: aContext ]! !

!PRValueLink methodsFor: 'querying' stamp: 'lr 4/6/2009 23:59'!
pragmas
	"Answer the method annotations of all currently supported value-links."
	
	^ Pragma allNamed: #value:comment: from: self class to: PRValueLink sortedByArgument: 1! !

!PRValueLink methodsFor: 'values' stamp: 'lr 4/23/2009 14:48'!
previousIn: aContext
	<value: 'previous' comment: 'Display the previous sibling of the current structure.'>
	
	^ self lookupStructure: aContext structure do: [ :target |
		| elements output |
		elements := (self hasParameter: 'nested')
			ifFalse: [ (aContext structure: target) siblings ]
			ifTrue: [ (aContext enumeratorFor: target root) everything contents ].
		(elements copyUpTo: target) reverseDo: [ :structure |
			(output := self formatStructure: structure in: aContext) notNil
				ifTrue: [ ^ output ] ].
		nil ]! !

!PRValueLink methodsFor: 'values' stamp: 'lr 4/22/2009 13:03'!
randomIn: aContext
	<value: 'random' comment: 'Display a random child of the current structure.'>

	| structures |
	^ self lookupStructure: aContext structure do: [ :structure |
		structures := (aContext structure: structure)
			enumerator all contents.
		structures isEmpty 
			ifFalse: [ self formatStructure: structures atRandom in: aContext ] ]! !

!PRValueLink methodsFor: 'accessing' stamp: 'jf 9/24/2009 14:06'!
reference: aString
	super reference: aString.
	selector := self selectorFor: self title asLowercase trimBoth! !

!PRValueLink methodsFor: 'values' stamp: 'lr 4/22/2009 13:04'!
rootIn: aContext
	<value: 'root' comment: 'Display the root structure.'>
	
	^ self formatStructure: aContext root in: aContext! !

!PRValueLink methodsFor: 'private' stamp: 'lr 4/22/2009 15:08'!
selectAndReject: anObject
	self parameterAt: 'select' ifPresent: [ :tokens |
		(tokens includesSubString: anObject class label)
			ifFalse: [ ^ nil ] ].
	self parameterAt: 'reject' ifPresent: [ :tokens |
		(tokens includesSubString: anObject class label)
			ifTrue: [ ^ nil ] ].
	^ anObject! !

!PRValueLink methodsFor: 'accessing' stamp: 'lr 5/13/2009 11:56'!
selector
	^ selector! !

!PRValueLink methodsFor: 'querying' stamp: 'lr 4/1/2009 21:47'!
selectorFor: aString
	"Answer the method selector for the given value link ==aString==, of nil if not found."

	self pragmas do: [ :pragma | 
		pragma arguments first = aString
			ifTrue: [ ^ pragma selector ] ].
	^ nil! !

!PRValueLink methodsFor: 'values' stamp: 'lr 4/22/2009 12:58'!
siblingsIn: aContext
	<value: 'siblings' comment: 'Display the siblings of the current structure.'>
	
	^ self lookupStructure: aContext structure do: [ :structure |
		self 
			formatStructureCollection: (aContext structure: structure)
				siblings
			in: aContext ]! !

!PRValueLink methodsFor: 'values' stamp: 'lr 4/22/2009 13:04'!
structureIn: aContext
	<value: 'structure' comment: 'Display the current structure.'>
	
	^ self lookupStructure: aContext structure do: [ :structure |
		self formatStructure: structure in: aContext ]! !

!PRValueLink methodsFor: 'values' stamp: 'lr 4/1/2009 22:06'!
timeIn: aContext
	<value: 'time' comment: 'Display the current time.'>

	^ Time now! !

!PRValueLink methodsFor: 'accessing' stamp: 'lr 3/10/2009 10:42'!
title
	^ self reference copyAfter: $:! !

!PRValueLink methodsFor: 'querying' stamp: 'lr 5/13/2009 11:56'!
valueIn: aContext
	"Answer the current value within aContext. The answer is either a ==PRDocument== composite, any other ==Object== that is printable, or ==nil== if context or parameters are invalid."

	^ (aContext notNil and: [ self class selectors includes: self selector ])
		ifTrue: [ self perform: self selector with: aContext ]! !

!PRValueLink methodsFor: 'values' stamp: 'lr 4/1/2009 22:06'!
valuesIn: aContext
	<value: 'values' comment: 'Display a table with all possible values with comment.'>

	^ PRTable new
		add: (PRTableRow new
			add: (PRTableCell new
				add: (PRText content: 'Markup');
				beHeading;
				yourself);
			add: (PRTableCell new
				add: (PRText content: 'Comment');
				beHeading;
				yourself);
			yourself);
		addAll: (self pragmas collect: [ :pragma |
			PRTableRow new
				add: (PRTableCell new
					add: (PRMonospaceFormat new
						add: (PRText content: '+value:' , pragma arguments first , '+');
						yourself);
					yourself);
				add: (PRTableCell new
					add: (PRText content: pragma arguments second);
					yourself);
				yourself ]);
		yourself! !

PRDocumentGroup subclass: #PRList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRList commentStamp: 'lr 5/28/2006 20:55' prior: 0!
I am an abstract list. My children are instances of *PRListItem*.!

PRList subclass: #PRDefinitionList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRDefinitionList commentStamp: 'lr 12/30/2007 19:44' prior: 0!
I am an definition list. I am typically used for a keyword and a longer definition string.!

!PRDefinitionList class methodsFor: 'testing' stamp: 'lr 12/30/2007 17:23'!
isAbstract
	^ false! !

!PRDefinitionList methodsFor: 'visiting' stamp: 'lr 12/30/2007 17:23'!
accept: aVisitor
	aVisitor visitDefinitionList: self! !

!PRList class methodsFor: 'private' stamp: 'lr 2/2/2010 17:10'!
parse: aString to: aGroup with: aParser
	| specification remainder |
	(specification := self specificationFor: aString) isNil
		ifTrue: [ ^ aGroup addAll: (aParser parseTopText: aString) ].
	(aGroup children isEmpty or: [ aGroup children last class ~= specification second ])
		ifTrue: [ aGroup add: specification second new ].
	remainder := aString allButFirst: specification first size.
	(aGroup children last children isEmpty or: [ (self specificationFor: remainder) isNil ])
		ifTrue: [ aGroup children last add: specification third new ].
	^ self parse: remainder to: aGroup children last children last with: aParser! !

!PRList class methodsFor: 'instance creation' stamp: 'lr 1/28/2009 15:46'!
parse: aString with: aParser
	^ self parse: aString to: aParser document with: aParser! !

!PRList class methodsFor: 'private' stamp: 'lr 12/30/2007 22:51'!
specificationFor: aString
	(aString beginsWith: PROrderedList markup)
		ifTrue: [ ^ Array with: PROrderedList markup with: PROrderedList with: PRListItem ].
	(aString beginsWith: PRUnorderedList markup)
		ifTrue: [ ^ Array with: PRUnorderedList markup with: PRUnorderedList with: PRListItem ].
	(aString beginsWith: PRTermItem markup)
		ifTrue: [ ^ Array with: PRTermItem markup with: PRDefinitionList with: PRTermItem ].
	(aString beginsWith: PRDataItem markup)
		ifTrue: [ ^ Array with: PRDataItem markup with: PRDefinitionList with: PRDataItem ].
	^ nil! !

!PRList methodsFor: 'visiting' stamp: 'lr 3/30/2007 20:01'!
accept: aVisitor
	aVisitor visitList: self! !

PRList subclass: #PROrderedList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PROrderedList commentStamp: 'lr 5/28/2006 20:53' prior: 0!
I am an ordered list. I am typically used for numbered items.!

!PROrderedList class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PROrderedList class methodsFor: 'accessing' stamp: 'lr 4/5/2007 13:12'!
markup
	^ '#'! !

!PROrderedList methodsFor: 'visiting' stamp: 'lr 12/30/2007 19:31'!
accept: aVisitor
	aVisitor visitOrderedList: self! !

PRList subclass: #PRUnorderedList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRUnorderedList commentStamp: 'lr 5/28/2006 20:53' prior: 0!
I am an unordered list. I am typically used for unnumbered lists!

!PRUnorderedList class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRUnorderedList class methodsFor: 'accessing' stamp: 'lr 4/5/2007 13:12'!
markup
	^ '-'! !

!PRUnorderedList methodsFor: 'visiting' stamp: 'lr 12/30/2007 19:31'!
accept: aVisitor
	aVisitor visitUnorderedList: self! !

PRDocumentGroup subclass: #PRListItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRListItem commentStamp: 'lr 6/2/2006 11:26' prior: 0!
I am a item within a *PRList*.!

PRListItem subclass: #PRDataItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRDataItem class methodsFor: 'accessing' stamp: 'lr 12/30/2007 21:59'!
markup
	^ ':'! !

!PRDataItem methodsFor: 'visiting' stamp: 'lr 12/30/2007 21:50'!
accept: aVisitor
	aVisitor visitDataItem: self! !

!PRListItem class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRListItem methodsFor: 'visiting' stamp: 'lr 3/30/2007 20:01'!
accept: aVisitor
	aVisitor visitListItem: self! !

PRListItem subclass: #PRTermItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRTermItem class methodsFor: 'accessing' stamp: 'lr 12/30/2007 22:00'!
markup
	^ ';'! !

!PRTermItem methodsFor: 'visiting' stamp: 'lr 12/30/2007 21:51'!
accept: aVisitor
	aVisitor visitTermItem: self! !

PRDocumentGroup subclass: #PRParagraph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRParagraph commentStamp: 'lr 5/28/2006 20:54' prior: 0!
I am a paragraph of text.!

PRParagraph subclass: #PRAnnotatedParagraph
	instanceVariableNames: 'annotation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRAnnotatedParagraph class methodsFor: 'accessing' stamp: 'lr 5/26/2009 21:59'!
markup
	^ '@@'! !

!PRAnnotatedParagraph class methodsFor: 'instance creation' stamp: 'lr 2/2/2010 17:11'!
parse: aString with: aParser
	| string annotation |
	string := aString allButFirst: self markup size.
	annotation := string copyUpTo: Character space.
	string := string copyAfter: Character space.
	^ aParser add: (self withAll: (aParser parseTopText: string) annotation: annotation)! !

!PRAnnotatedParagraph class methodsFor: 'instance creation' stamp: 'lr 5/26/2009 22:04'!
withAll: aCollection annotation: aString
	^ (self withAll: aCollection)
		annotation: aString;
		yourself! !

!PRAnnotatedParagraph methodsFor: 'comparing' stamp: 'lr 5/26/2009 22:07'!
= anObject
	^ super = anObject and: [ self annotation = anObject annotation ]! !

!PRAnnotatedParagraph methodsFor: 'visiting' stamp: 'lr 5/26/2009 21:59'!
accept: aVisitor
	aVisitor visitAnnotatedParagraph: self! !

!PRAnnotatedParagraph methodsFor: 'accessing' stamp: 'lr 5/26/2009 21:59'!
annotation
	^ annotation! !

!PRAnnotatedParagraph methodsFor: 'accessing' stamp: 'lr 5/26/2009 21:59'!
annotation: aString
	annotation := aString! !

!PRAnnotatedParagraph methodsFor: 'comparing' stamp: 'lr 5/26/2009 22:07'!
hash
	^ super hash bitXor: self annotation hash! !

PRParagraph subclass: #PREmptyParagraph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PREmptyParagraph methodsFor: 'visiting' stamp: 'lr 12/20/2007 12:12'!
accept: aVisitor
	aVisitor visitEmptyParagraph: self! !

!PRParagraph class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRParagraph class methodsFor: 'instance creation' stamp: 'lr 2/2/2010 17:10'!
parse: aString with: aParser
	^ aParser addParagraph: (self withAll: (aParser parseTopText: aString))! !

!PRParagraph methodsFor: 'visiting' stamp: 'lr 3/30/2007 20:01'!
accept: aVisitor
	aVisitor visitParagraph: self! !

PRDocumentGroup subclass: #PRPreformatted
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRPreformatted commentStamp: 'lr 5/28/2006 20:56' prior: 0!
I am preformatted text or source code. My children are instances of *PRText*.!

!PRPreformatted class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRPreformatted class methodsFor: 'accessing' stamp: 'lr 4/5/2007 13:12'!
markup
	^ '='! !

!PRPreformatted class methodsFor: 'instance creation' stamp: 'lr 4/24/2007 20:55'!
parse: aString with: aParser
	^ aParser combine: self with: (PRText content: (aString allButFirst: self markup size))! !

!PRPreformatted methodsFor: 'visiting' stamp: 'lr 3/30/2007 20:01'!
accept: aVisitor
	aVisitor visitPreformatted: self! !

PRDocumentGroup subclass: #PRTable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRTable commentStamp: 'lr 5/28/2006 20:56' prior: 0!
I am a table. My children are instances of *PRTableRow*.!

!PRTable class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRTable class methodsFor: 'instance creation' stamp: 'lr 2/2/2010 15:28'!
parse: aString with: aParser
	| line row cell markup index changed |
	line := aString.
	row := PRTableRow new.
	[ line isEmpty ] whileFalse: [
		cell := PRTableCell new.
		line := line allButFirst: cell class markup size.
		[	changed := false.	
			#(markupLeft markupCenter markupRight markupHeading) 
				with: #(beAlignedLeft beAlignedCenter beAlignedRight beHeading) 
				do: [ :selector :align |
					markup := cell class perform: selector.
					(line beginsWith: markup) ifTrue: [
						line := line allButFirst: markup size.
						cell perform: align.
						changed := true ] ].
			changed ] whileTrue.
		index := (aParser class findFirst: cell class markup at: 1 in: line) - 1.
		index < 1 ifTrue: [ index := line size ].
		row add: (cell addAll: (aParser parseText: (line first: index))).
		line := line allButFirst: index ].
	^ aParser combine: self with: row! !

!PRTable methodsFor: 'visiting' stamp: 'lr 3/30/2007 20:01'!
accept: aVisitor
	aVisitor visitTable: self! !

!PRTable methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
columnCount
	^ self children inject: 0 into: [ :max :row | max max: row columnCount ]! !

!PRTable methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
rowCount
	^ self children size! !

PRDocumentGroup subclass: #PRTableCell
	instanceVariableNames: 'align heading'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRTableCell commentStamp: 'lr 5/28/2006 20:57' prior: 0!
I am a cell of a table.!

!PRTableCell class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRTableCell class methodsFor: 'accessing' stamp: 'lr 4/5/2007 13:13'!
markup
	^ '|'! !

!PRTableCell class methodsFor: 'accessing' stamp: 'lr 4/5/2007 16:11'!
markupCenter
	^ '|'! !

!PRTableCell class methodsFor: 'accessing' stamp: 'lr 8/14/2008 08:53'!
markupHeading
	^ '!!'! !

!PRTableCell class methodsFor: 'accessing' stamp: 'lr 4/5/2007 16:11'!
markupLeft
	^ '{'! !

!PRTableCell class methodsFor: 'accessing' stamp: 'lr 4/5/2007 16:11'!
markupRight
	^ '}'! !

!PRTableCell methodsFor: 'comparing' stamp: 'lr 8/14/2008 08:52'!
= anObject
	^ super = anObject
		and: [ self align = anObject align
		and: [ self heading = anObject heading ] ]! !

!PRTableCell methodsFor: 'visiting' stamp: 'lr 3/30/2007 20:01'!
accept: aVisitor
	aVisitor visitTableCell: self! !

!PRTableCell methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
align
	^ align! !

!PRTableCell methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
align: aSymbol
	align := aSymbol! !

!PRTableCell methodsFor: 'actions' stamp: 'lr 3/9/2006 11:30'!
beAlignedCenter
	self align: #center! !

!PRTableCell methodsFor: 'actions' stamp: 'lr 3/9/2006 11:30'!
beAlignedLeft
	self align: #left! !

!PRTableCell methodsFor: 'actions' stamp: 'lr 3/9/2006 11:30'!
beAlignedRight
	self align: #right! !

!PRTableCell methodsFor: 'actions' stamp: 'lr 8/14/2008 08:52'!
beHeading
	self heading: true! !

!PRTableCell methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:30'!
hash
	^ super hash bitXor: self align hash! !

!PRTableCell methodsFor: 'accessing' stamp: 'lr 8/14/2008 08:52'!
heading
	^ heading! !

!PRTableCell methodsFor: 'accessing' stamp: 'lr 8/14/2008 08:52'!
heading: aBoolean
	heading := aBoolean! !

!PRTableCell methodsFor: 'initialization' stamp: 'lr 8/14/2008 09:01'!
initialize
	super initialize.
	heading := false! !

!PRTableCell methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAligned
	^ self align notNil! !

!PRTableCell methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAlignedCenter
	^ self align = #center! !

!PRTableCell methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAlignedLeft
	^ self align = #left! !

!PRTableCell methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAlignedRight
	^ self align = #right! !

!PRTableCell methodsFor: 'testing' stamp: 'lr 8/14/2008 09:00'!
isHeading
	^ self heading! !

PRDocumentGroup subclass: #PRTableRow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRTableRow commentStamp: 'lr 5/28/2006 20:56' prior: 0!
I am a row of a table. My children are instances of *PRTableCell*.!

!PRTableRow class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRTableRow methodsFor: 'visiting' stamp: 'lr 3/30/2007 20:01'!
accept: aVisitor
	aVisitor visitTableRow: self! !

!PRTableRow methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
columnCount
	^ self children size! !

!PRDocumentItem class methodsFor: 'accessing' stamp: 'lr 2/2/2010 15:47'!
markup
	^ nil! !

!PRDocumentItem class methodsFor: 'accessing' stamp: 'lr 2/2/2010 15:47'!
markupBegin
	^ self markup! !

!PRDocumentItem class methodsFor: 'accessing' stamp: 'lr 2/2/2010 15:58'!
markupEnd: aString
	^ aString! !

!PRDocumentItem class methodsFor: 'instance creation' stamp: 'lr 2/2/2010 16:44'!
parse: aStream with: aParser
	self error: self name , ' is not supposed to be parsed by ' , aParser printString! !

!PRDocumentItem methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:29'!
= anObject
	^ self species = anObject species! !

!PRDocumentItem methodsFor: 'visiting' stamp: 'lr 3/30/2007 20:01'!
accept: aVisitor
	aVisitor visitDocumentItem: self! !

!PRDocumentItem methodsFor: 'testing' stamp: 'lr 3/9/2006 11:29'!
hasChildren
	^ false! !

!PRDocumentItem methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:29'!
hash
	^ self species hash! !

!PRDocumentItem methodsFor: 'testing' stamp: 'lr 4/16/2007 12:00'!
isLink
	^ false! !

!PRDocumentItem methodsFor: 'accessing' stamp: 'lr 4/10/2007 21:48'!
owner
	"Answer the object owning the receiver. The default implementation doesn't know about its owner and therefore always returns ==nil==."

	^ nil! !

!PRDocumentItem methodsFor: 'accessing' stamp: 'lr 5/28/2006 20:30'!
owner: anObject! !

!PRDocumentItem methodsFor: 'accessing-dynamic' stamp: 'lr 5/28/2006 20:31'!
text
	"Answer a string representation of the receiver."

	^ String new! !

PRDocumentItem subclass: #PRHorizontalRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRHorizontalRule commentStamp: 'lr 5/28/2006 20:57' prior: 0!
I am a horizontal rule.!

!PRHorizontalRule class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRHorizontalRule class methodsFor: 'accessing' stamp: 'lr 4/5/2007 13:13'!
markup
	^ '_'! !

!PRHorizontalRule class methodsFor: 'instance creation' stamp: 'lr 4/24/2007 21:01'!
parse: aString with: aParser
	| index |
	index := aString findLast: [ :char | char isSeparator not ].
	^ self markup size < index
		ifFalse: [ aParser add: self new ]
		ifTrue: [ aParser class lineMatcherDefault parse: aString with: aParser ]! !

!PRHorizontalRule methodsFor: 'visiting' stamp: 'lr 3/30/2007 20:01'!
accept: aVisitor
	aVisitor visitHorizontalRule: self! !

PRDocumentItem subclass: #PRLineBreak
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRLineBreak commentStamp: 'lr 9/14/2009 08:31' prior: 0!
I am a line break. I only show up in the wiki format.!

!PRLineBreak class methodsFor: 'testing' stamp: 'lr 12/9/2007 09:19'!
isAbstract
	^ false! !

!PRLineBreak methodsFor: 'visiting' stamp: 'lr 12/9/2007 09:05'!
accept: aVisitor
	aVisitor visitLineBreak: self! !

PRDocumentItem subclass: #PRText
	instanceVariableNames: 'text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRText commentStamp: 'lr 5/28/2006 20:58' prior: 0!
I am a plain text. I am the most important leaf node of the document composite.!

!PRText class methodsFor: 'instance creation' stamp: 'lr 4/5/2007 14:41'!
content: aString
	^ self new text: aString! !

!PRText class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRText methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:30'!
= anObject
	^ super = anObject
		and: [ self text = anObject text ]! !

!PRText methodsFor: 'visiting' stamp: 'lr 3/30/2007 20:01'!
accept: aVisitor
	aVisitor visitText: self! !

!PRText methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:30'!
hash
	^ super hash bitXor: self text hash! !

!PRText methodsFor: 'printing' stamp: 'lr 3/9/2006 11:30'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' text: '; print: self text! !

!PRText methodsFor: 'accessing' stamp: 'lr 4/5/2007 14:40'!
text
	"Answer the string the receiver is representing."

	^ text! !

!PRText methodsFor: 'accessing' stamp: 'lr 4/5/2007 14:40'!
text: aString
	text := aString! !

PRText subclass: #PRVerbatim
	instanceVariableNames: 'type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRVerbatim class methodsFor: 'accessing' stamp: 'lr 2/2/2010 15:33'!
markup
	^ self markupBegin! !

!PRVerbatim class methodsFor: 'accessing' stamp: 'lr 2/2/2010 15:33'!
markupBegin
	^ '{{{'! !

!PRVerbatim class methodsFor: 'accessing' stamp: 'lr 2/2/2010 16:00'!
markupEnd: aString
	^ '}}}'! !

!PRVerbatim class methodsFor: 'instance creation' stamp: 'lr 2/2/2010 15:59'!
parse: aString with: aParser
	^ self content: (aString copyFrom: self markupBegin size + 1 to: aString size - self markup size)! !

!PRVerbatim methodsFor: 'comparing' stamp: 'lr 2/2/2010 15:17'!
= anObject
	^ super = anObject and: [ self type = anObject type ]! !

!PRVerbatim methodsFor: 'visiting' stamp: 'lr 2/2/2010 15:17'!
accept: aVisitor
	aVisitor visitVerbatim: self! !

!PRVerbatim methodsFor: 'comparing' stamp: 'lr 2/2/2010 15:16'!
hash
	^ super hash bitXor: self type hash! !

!PRVerbatim methodsFor: 'accessing' stamp: 'lr 2/2/2010 15:16'!
type
	^ type! !

!PRVerbatim methodsFor: 'accessing' stamp: 'lr 2/2/2010 15:16'!
type: aString
	type := aString! !

PRObject subclass: #PRKernel
	instanceVariableNames: 'name root persistency'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Kernel'!

PRKernel class
	instanceVariableNames: 'instances'!

!PRKernel commentStamp: 'lr 6/2/2006 10:33' prior: 0!
I am the kernel of Pier. Several instances of myself might exist at the same time, but they all exist independently and don't share any data. I know the root structure and the persistency strategy of the whole data-model. Moreover I prevent any concurrent modifications to the model by providing a global mutex.!

PRKernel class
	instanceVariableNames: 'instances'!

!PRKernel class methodsFor: 'configuration' stamp: 'lr 1/13/2009 16:20'!
defaultInfo
	^ (PRPage named: 'information')
		addChild: self defaultInfoIntroduction;
		addChild: self defaultInfoSyntax;
		addChild: self defaultInfoLicense;
		contents: '+value:children|link+';
		yourself! !

!PRKernel class methodsFor: 'configuration' stamp: 'jf 9/24/2009 15:24'!
defaultInfoIntroduction
	^ (PRPage named: 'introduction')
		contents: 'Pier is a powerful and extensible implementation of a meta-described content management and Wiki system, written with objects from top to bottom:

-''''Object-Oriented Design:'''' Pier features a fully object oriented and meta-described domain model built using Magritte. The content of the pages is parsed and stored as a tree of different entities representing text, links, tables, lists, formattings, etc.
-''''Extensibility:'''' Everything in Pier can be extended: page types, storage mechanism, actions, security mechanism, web-server, etc. Plug-ins can be shared within the community and loaded independently of each other into the system.
-''''Open Source:'''' Pier is released under the MIT license which grants unrestricted rights to copy, modify, and redistribute as long as the original copyright and license terms are retained.
-''''Test Suites:'''' Pier is heavily tested. There are more than 1200 unit tests included with the core of Pier. This makes it easy to change and verify the code and comes in extremely useful when porting Pier to other Smalltalk dialects or when writing extensions.

Up to date information about *Pier>http://www.piercms.com* and *Magritte>http://www.lukas-renggli.ch/smalltalk/magritte* can be obtained through their respective web sites.

!!Development
- *Code Repository>http://source.lukas-renggli.ch/pier.html*
- *Issue Tracker>http://code.google.com/p/pier/*

!!Mailing-Lists
- *Magritte, Pier and Related Tools>https://www.iam.unibe.ch/mailman/listinfo/smallwiki*
- *Seaside>http://lists.squeakfoundation.org/cgi-bin/mailman/listinfo/seaside*

!!Documentation
- *Magritte -- Meta-Described Web Application Development>http://www.iam.unibe.ch/~scg/Archive/Diploma/Reng06a.pdf* (Chapter 3)';
		yourself! !

!PRKernel class methodsFor: 'configuration' stamp: 'jf 9/24/2009 14:09'!
defaultInfoLicense
	^ (PRPage named: 'license')
		contents: '!!' , PRBasicObject pierLicense;
		yourself! !

!PRKernel class methodsFor: 'configuration' stamp: 'lr 3/17/2009 17:24'!
defaultInfoSyntax
	^ (PRPage named: 'syntax')
		contents: '!!Paragraphs
A single newline has no effect on the layout. An empty line starts a new paragraph.

!!Sections
A line starting with ==!!== becomes a section heading. Use multiple ==!!== to create a subsection.

!!Horizontal Line
A line starting with ==_== (underline) becomes a horizontal line. This is often used to separate topics.

!!Lists
Lines starting with ==#==, ==-==, ==;== or ==:== create a list:
-A block of lines, where each line starts with ==-== is transformed to a bulleted list, where each line is an entry.
-A block of lines, where each line starts with ==#== is transformed to an ordered list, where each line is an entry.
-A block of lines, where each line starts with ==;== or ==:== is transformed to a definition list, where the keyword is prepended with ==;== and the definition with ==:==. Keywords and definitions can be mixed arbitrary.
Lists can also be nested. Thus, a line starting with ==#-== is an element of a bulleted list that is part of an ordered list.

!!Tables
To create a table, start off the lines with ==|== and separate the elements with ==|==s. Each new line represents a new row of the table. The contents of cells can be aligned left, centered or aligned right by using ==|{==, ==||== or ==|}== respectively. Add a single ==!!== to let the cell become a table heading.

!!Preformatted
To create a preformatted section, begin each line with ==\===. A preformatted section uses equally spaced text so that spacing is preserved.

!!Formatting
There is some sugar for font formatting:
-To make something ""bold"", surround it with ==\""==
-To make something ''''italic'''', surround it with ==\''''==
-To make something ==monospaced==, surround it with ==\=\===
-To make something --strikethrough--, surround it with ==\--==
-To make something @@subscript@@, surround it with ==\@@==
-To make something ^^superscript^^, surround it with ==\^^==
-To make something __underlined__, surround it with ==\__==

!!Links
To create a link, put it between ==\*==. All links have the following form ==\*reference\*==, or ==\*alias>reference|parameters\*== for the complete form. The ''''reference'''' depends on the kind of link that is created (see below). The ''''alias'''' is a string being used as the text of the link, if left out a default is used. The ''''parameters'''' are optional parameters to further configure the behavior on the link, again this depends on the kind of link you create. The contents of some links, e.g. links pointing to image-files, downloads or other pages, can be embedded into the current document by putting the reference between ==\+== instead of ==\*==, for example ==\+reference\+==. Not all types of links support embedding and quietly ignore it.

!!!!Internal Links
If a structure with the given name exists, a link to that item shows up when the page is saved. In case the path points to an non-existing structure, the user will be offered the possibility to create a new one when clicking on the link. The reference can be an absolute (==/information/license==) or relative (==../license==) path. The parameters ==command== and ==view== are supported to create specific links onto commands and views of the target page.

!!!!External Links
-If the link is an URL (e.g. ==\*http://www.lukas-renggli.ch\*==), a link to the external page shows up.
-If the link is an e-mail address (e.g. ==\*renggli@gmail.com\*==), a link to mail that person shows up.

!!!!Value Links
To add dynamic content to a page use a value link. For example, the expression ==\+value:date\+== adds the current date ==+value:date+==. Some values might be undefined at certain points, in this case the alias of the link is displayed instead. For example, the expression ==\+untouched>value:edited|display=date\+== displays the date of the last edit operation, or ==untouched== if the current page has never been edited. There is a wide variety of possible expression available:

	+value:values+
	
The expressions that work on structures (==children==, ==parent==, ...) support a wide variety of ==display== parameters, namely ==title==, ==name==, ==tags==, ==menu==, ==owner==, and ==group==. Furthermore these expressions become an internal link if you add the parameter ==link==. The expressions on contexts (==context== and ==edited==) also support ==display== parameters, namely ==date==, ==time== and ==user==.';
		yourself! !

!PRKernel class methodsFor: 'configuration' stamp: 'lr 1/13/2009 20:26'!
defaultRoot
	^ (PRPage named: 'pier')
		addChild: self defaultInfo;
		contents: 'Welcome to Pier, the next generation of a fully extensible content management system implemented in Smalltalk. To read additional information, please consult the *information page>information* or go to the official Pier *web site>http://www.piercms.com*.';
		yourself! !

!PRKernel class methodsFor: 'accessing-description' stamp: 'lr 3/26/2009 20:58'!
descriptionName
	^ MAStringDescription new
		parameterName: 'name';
		accessor: #name;
		label: 'Name';
		priority: 100;
		beRequired;
		yourself! !

!PRKernel class methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
instanceNamed: aString
	^ self instances detect: [ :each | each name = aString ]! !

!PRKernel class methodsFor: 'accessing' stamp: 'jf 9/18/2009 15:23'!
instances
	^ instances ifNil: [ instances := Set new ]! !

!PRKernel class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRKernel class methodsFor: 'instance creation' stamp: 'lr 1/17/2007 11:05'!
named: aString
	^ self named: aString root: self defaultRoot! !

!PRKernel class methodsFor: 'instance creation' stamp: 'lr 1/17/2007 11:05'!
named: aString root: aStructure
	^ self instances add: (self new
		name: aString;
		root: aStructure;
		yourself)! !

!PRKernel class methodsFor: 'private' stamp: 'jf 9/18/2009 15:22'!
reset
	"This method is for development and testing purpose only, you should not call it directly unless you want to loose your wiki-kernels."

	instances := nil! !

!PRKernel methodsFor: 'configuration' stamp: 'lr 9/13/2007 22:00'!
defaultName
	^ 'Pier'! !

!PRKernel methodsFor: 'configuration' stamp: 'lr 1/29/2008 08:59'!
defaultPersistency
	^ PRHistoryPersistency new! !

!PRKernel methodsFor: 'initialization' stamp: 'lr 1/17/2007 11:03'!
initialize
	super initialize.
	self name: self defaultName.
	self persistency: self defaultPersistency! !

!PRKernel methodsFor: 'accessing' stamp: 'lr 1/16/2007 22:45'!
name
	"Answer the name of the kernel."

	^ name! !

!PRKernel methodsFor: 'accessing' stamp: 'lr 5/28/2006 17:10'!
name: aString
	name := aString! !

!PRKernel methodsFor: 'accessing' stamp: 'lr 1/16/2007 22:44'!
persistency
	"Answer the persistency strategy of the receiver."

	^ persistency! !

!PRKernel methodsFor: 'accessing' stamp: 'lr 2/18/2009 14:39'!
persistency: aPersistency
	| replacement |
	replacement := aPersistency 
		ifNil: [ PRNullPersistency new ].
	replacement setKernel: self.
	persistency isNil
		ifFalse: [ persistency setKernel: nil ].
	persistency := replacement! !

!PRKernel methodsFor: 'printing' stamp: 'lr 3/9/2006 11:29'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' name: '; print: self name! !

!PRKernel methodsFor: 'accessing' stamp: 'lr 1/16/2007 22:45'!
root
	"Answer the root structure of the kernel."

	^ root! !

!PRKernel methodsFor: 'accessing' stamp: 'lr 5/28/2006 17:10'!
root: aStructure
	root := aStructure! !

!PRObject class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ true! !

!PRObject class methodsFor: 'instance creation' stamp: 'jf 9/18/2009 15:41'!
new
	"Create a new instance of this class and checks if it isn't abstract."

	self isAbstract
		ifTrue: [ self error: self name , ' is abstract.' ].
	^ super new! !

!PRObject class methodsFor: 'reflection' stamp: 'lr 3/9/2006 11:30'!
withAllConcreteClasses
	^ Array streamContents: [ :stream |
		self withAllConcreteClassesDo: [ :each |
			stream nextPut: each ] ]! !

!PRObject class methodsFor: 'reflection' stamp: 'lr 3/9/2006 11:30'!
withAllConcreteClassesDo: aBlock
	self withAllSubclassesDo: [ :each |
		each isAbstract ifFalse: [
			aBlock value: each ] ]! !

!PRObject methodsFor: 'visiting' stamp: 'lr 4/10/2007 21:49'!
accept: aVisitor
	"Dispatch to ==aVisitor== depending on the receiver."! !

!PRObject methodsFor: 'private' stamp: 'lr 3/5/2007 14:03'!
errorPropertyNotFound: aSelector
	MAPropertyError signal: 'Property ' , aSelector , ' not found.'! !

!PRObject methodsFor: 'testing' stamp: 'lr 4/10/2007 21:49'!
hasProperty: aKey
	"Test if the property ==aKey== is defined within the receiver."

	^ self properties includesKey: aKey! !

!PRObject methodsFor: 'copying' stamp: 'lr 3/9/2006 11:29'!
postCopy
	super postCopy.
	properties := properties copy! !

!PRObject methodsFor: 'copying' stamp: 'lr 3/9/2006 11:29'!
postCopyTo: anObject! !

!PRObject methodsFor: 'printing' stamp: 'lr 12/18/2009 16:27'!
printOn: aStream
	super printOn: aStream.
	aStream nextPut: $[; print: self identityHash; nextPut: $]! !

!PRObject methodsFor: 'accessing-properties' stamp: 'lr 5/28/2006 17:01'!
properties
	"Answer the property dictionary of the receiver."

	^ properties ifNil: [ properties := Dictionary new ]! !

!PRObject methodsFor: 'accessing-properties' stamp: 'lr 4/10/2007 21:49'!
propertyAt: aKey
	"Answer the value of the property ==aKey==, raises an error if the property doesn't exist."

	^ self propertyAt: aKey ifAbsent: [ self errorPropertyNotFound: aKey ]! !

!PRObject methodsFor: 'accessing-properties' stamp: 'lr 4/10/2007 21:49'!
propertyAt: aKey ifAbsent: aBlock
	"Answer the value of the property ==aKey==, or the result of ==aBlock== if the property doesn't exist."

	^ self properties at: aKey ifAbsent: aBlock! !

!PRObject methodsFor: 'accessing-properties' stamp: 'lr 4/10/2007 21:49'!
propertyAt: aKey ifAbsentPut: aBlock
	"Answer the value of the property ==aKey==, or if the property doesn't exist adds and answers the result of evaluating ==aBlock==."

	^ self properties at: aKey ifAbsentPut: aBlock! !

!PRObject methodsFor: 'accessing-properties' stamp: 'lr 4/10/2007 21:50'!
propertyAt: aKey put: aValue
	"Adds or replaces the property ==aKey== with ==aValue==."

	^ self properties at: aKey put: aValue! !

PRObject subclass: #PRPersistency
	instanceVariableNames: 'kernel mutex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Persistence'!

!PRPersistency commentStamp: 'lr 2/5/2009 16:21' prior: 0!
An abstract persistency strategy. To use assign to a kernel by evaluating:

= aKernel persistency: PRNullPersistency new!

PRPersistency subclass: #PRHistoryPersistency
	instanceVariableNames: 'history maxHistory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Persistence'!

!PRHistoryPersistency commentStamp: 'lr 2/1/2009 17:03' prior: 0!
A simple persistency strategy remembering a configurable amount of the history.!

!PRHistoryPersistency class methodsFor: 'accessing-descriptions' stamp: 'lr 1/29/2009 21:18'!
descriptionMaxHistory
	^ MANumberDescription new
		comment: 'The maximum number of history items to keep.';
		accessor: #maxHistory;
		label: 'Max History';
		default: 1024;
		priority: 100;
		beInteger;
		yourself! !

!PRHistoryPersistency methodsFor: 'actions' stamp: 'lr 5/5/2009 16:49'!
add: aContext
	history addLast: aContext copy sanitize.
	maxHistory isNil ifTrue: [ ^ self ].
	[ history size <= maxHistory ]
		whileFalse: [ history removeFirst ]! !

!PRHistoryPersistency methodsFor: 'enumerating' stamp: 'lr 1/29/2008 08:13'!
do: aBlock
	history do: aBlock! !

!PRHistoryPersistency methodsFor: 'actions' stamp: 'lr 5/5/2009 16:49'!
execute: aCommand
	self mutex critical: [
		self apply: aCommand.
		aCommand isLogged 
			ifTrue: [ self add: aCommand context ] ]! !

!PRHistoryPersistency methodsFor: 'accessing' stamp: 'lr 6/22/2008 17:58'!
maxHistory
	^ maxHistory! !

!PRHistoryPersistency methodsFor: 'accessing' stamp: 'lr 6/22/2008 17:58'!
maxHistory: anInteger
	"The maximum number of commands to keep."

	maxHistory := anInteger! !

!PRHistoryPersistency methodsFor: 'enumerating' stamp: 'lr 1/29/2008 08:13'!
reverseDo: aBlock
	history reverseDo: aBlock! !

!PRHistoryPersistency methodsFor: 'initialization' stamp: 'lr 2/18/2009 14:49'!
setKernel: aKernel
	super setKernel: aKernel.
	history := OrderedCollection new.
	(aKernel notNil and: [ aKernel persistency notNil ])
		ifTrue: [ aKernel persistency do: [ :each | self add: each ] ]! !

PRPersistency subclass: #PRNullPersistency
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Persistence'!

!PRNullPersistency commentStamp: 'lr 2/1/2009 17:07' prior: 0!
The simplest possible persistency strategy. Using this strategy means there is no persistency (except for manual image saving). Also no history of applied commands is remembered.!

!PRNullPersistency methodsFor: 'enumerating' stamp: 'lr 1/17/2007 10:41'!
do: aBlock
	"There is no history for now."! !

!PRPersistency class methodsFor: 'testing' stamp: 'lr 1/16/2007 22:11'!
isAbstract
	^ self name = #PRPersistency! !

!PRPersistency methodsFor: 'protected' stamp: 'lr 2/12/2007 19:07'!
apply: aCommand
	"This method should not be called directly. It performs the basic execution of aCommand in the context of the receiver."

	aCommand isChecked
		ifTrue: [ aCommand doValidate ].
	aCommand doExecute! !

!PRPersistency methodsFor: 'configuration' stamp: 'jf 9/30/2009 00:19'!
defaultMutex
	^ GRPlatform current semaphoreClass forMutualExclusion! !

!PRPersistency methodsFor: 'enumerating' stamp: 'lr 3/9/2006 11:29'!
do: aBlock
	"Evaluates aBlock in chronological order for every item in the history of the kernel."

	self subclassResponsibility! !

!PRPersistency methodsFor: 'enumerating' stamp: 'lr 3/9/2006 11:29'!
do: aBlock for: aStructure
	"Evaluates aBlock in chronological order for every item in the history of aStructure. Subclasses might want to override the default implementation for efficiency."

	self do: [ :each |
		each structure = aStructure
			ifTrue: [ aBlock value: each ] ]! !

!PRPersistency methodsFor: 'actions' stamp: 'lr 4/10/2007 21:50'!
execute: aCommand
	"Execute aCommand using the persistency of the receiver. Subclasses might override this method, e.g. to create a transitional logic or to commit changes after execution. Make sure that you always perform the method ==#apply:== when overriding this code."

	self mutex critical: [ self apply: aCommand ]! !

!PRPersistency methodsFor: 'convenience' stamp: 'lr 3/9/2006 11:29'!
history
	^ Array streamContents: [ :stream |
		self do: [ :each |
			stream nextPut: each ] ]! !

!PRPersistency methodsFor: 'convenience' stamp: 'lr 3/9/2006 11:29'!
historyFor: aStructure
	^ Array streamContents: [ :stream |
		self
			do: [ :each | stream nextPut: each ]
			for: aStructure ]! !

!PRPersistency methodsFor: 'initialization' stamp: 'lr 3/10/2009 10:42'!
initialize
	super initialize.
	self initializeMagritte.
	mutex := self defaultMutex! !

!PRPersistency methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
kernel
	^ kernel! !

!PRPersistency methodsFor: 'accessing' stamp: 'lr 2/12/2007 19:07'!
mutex
	"Return a mutex (an object that understands #critical:) to ensure that only one process is modifying the model at once. This is needed to make certain that the model remains in a consistent state. All write access must go through this mutex."

	^ mutex! !

!PRPersistency methodsFor: 'enumerating' stamp: 'lr 3/9/2006 11:29'!
reverseDo: aBlock
	"Evaluates aBlock in inverse chronological order for every item in the history of aStructure. Subclasses might want to override the default implementation for efficiency."

	self history reverseDo: aBlock! !

!PRPersistency methodsFor: 'enumerating' stamp: 'lr 3/9/2006 11:29'!
reverseDo: aBlock for: aStructure
	"Evaluates aBlock in inverse chronological order for every item in the history of aStructure. Subclasses might want to override the default implementation for efficiency."

	(self historyFor: aStructure)
		reverseDo: aBlock! !

!PRPersistency methodsFor: 'initialization' stamp: 'lr 2/18/2009 14:33'!
setKernel: aKernel
	"Set the kernel the receiver is supposed to run on."

	kernel := aKernel! !

PRBasicObject subclass: #PRVisitor
	instanceVariableNames: 'escaper'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Visitor'!

!PRVisitor commentStamp: 'lr 6/2/2006 11:55' prior: 0!
I am an abstract visitor. I provide a default implementation of all visit messages that does not descend automatically into children of the visited graph. Subclasses should override all my messages in appropriate ways to visit the nodes they need.!

PRVisitor subclass: #PRDocumentWriter
	instanceVariableNames: 'stream nesting newline'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRDocumentWriter commentStamp: 'lr 6/1/2006 21:17' prior: 0!
I am a visitor being able to transform a composite of document-items back into the original Wiki string.

!!Example
=| document |
=document := PRDocumentParser parse: '+Hello+ *World*'.
=string := PRDocumentWriter write: document.
=string inspect.!

!PRDocumentWriter class methodsFor: 'instance creation' stamp: 'lr 3/9/2006 11:30'!
write: anObject
	^ self new write: anObject! !

!PRDocumentWriter class methodsFor: 'instance creation' stamp: 'lr 5/13/2009 11:32'!
write: anObject to: aStream
	^ self new write: anObject to: aStream! !

!PRDocumentWriter methodsFor: 'streaming' stamp: 'lr 5/13/2009 11:24'!
contents
	^ stream contents! !

!PRDocumentWriter methodsFor: 'private' stamp: 'lr 6/15/2009 20:10'!
defaultStream
	^ WriteStream on: String new! !

!PRDocumentWriter methodsFor: 'private' stamp: 'lr 4/5/2007 14:07'!
nest: aString do: aBlock
	nesting add: aString.
	aBlock ensure: [ nesting removeLast ]! !

!PRDocumentWriter methodsFor: 'private' stamp: 'lr 12/20/2007 19:45'!
newLine
	stream nextPut: Character cr.
	newline := true! !

!PRDocumentWriter methodsFor: 'streaming' stamp: 'lr 3/9/2006 11:29'!
nextPut: aCharacter
	stream nextPut: aCharacter.
	newline := false! !

!PRDocumentWriter methodsFor: 'streaming' stamp: 'lr 3/9/2006 11:29'!
nextPutAll: aString
	stream nextPutAll: aString.
	newline := false! !

!PRDocumentWriter methodsFor: 'visiting' stamp: 'jf 9/14/2009 15:35'!
start: anObject
	newline := true.
	nesting := OrderedCollection new.
	super start: anObject.
	(newline and: [ stream isEmpty not ])
		ifTrue: [ stream position: stream position -1 ]! !

!PRDocumentWriter methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
stream: aStream
	stream := aStream! !

!PRDocumentWriter methodsFor: 'visiting-document' stamp: 'lr 12/20/2007 20:09'!
visitLineBreak: anObject
	self newLine! !

!PRDocumentWriter methodsFor: 'visiting-document' stamp: 'lr 12/20/2007 14:23'!
visitParagraph: anObject
	super visitParagraph: anObject.
	self newLine! !

!PRDocumentWriter methodsFor: 'visiting' stamp: 'lr 3/9/2006 11:29'!
write: anObject
	^ self write: anObject to: self defaultStream! !

!PRDocumentWriter methodsFor: 'visiting' stamp: 'lr 5/13/2009 11:29'!
write: anObject to: aStream
	^ self stream: aStream; start: anObject; contents! !

PRDocumentWriter subclass: #PRTextWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRTextWriter methodsFor: 'visiting-document' stamp: 'lr 12/30/2007 23:25'!
visitDataItem: anObject
	self nest: ' ' do: [ super visitDataItem: anObject ]! !

!PRTextWriter methodsFor: 'visiting-document' stamp: 'lr 12/30/2007 23:24'!
visitDefinitionList: anObject
	newline ifFalse: [ self newLine ].
	self visitAll: anObject children! !

!PRTextWriter methodsFor: 'visiting-document' stamp: 'lr 12/20/2007 14:22'!
visitHeader: anObject
	super visitHeader: anObject.
	self newLine! !

!PRTextWriter methodsFor: 'visiting-document' stamp: 'lr 12/20/2007 14:22'!
visitHorizontalRule: anObject
	self nextPutAll: (String new: 40 withAll: $-); newLine! !

!PRTextWriter methodsFor: 'visiting-document' stamp: 'lr 2/7/2007 15:04'!
visitLink: anObject
	anObject hasAlias
		ifTrue: [ super visitLink: anObject ]
		ifFalse: [ self nextPutAll: anObject title ]! !

!PRTextWriter methodsFor: 'visiting-document' stamp: 'jf 9/30/2009 01:10'!
visitListItem: anObject 
	nesting last isInteger ifTrue: [ nesting addLast: nesting removeLast + 1 ].
	nesting size - 1 timesRepeat: [ stream tab ].
	self nextPutAll: nesting last greaseString.
	self nextPutAll: (nesting last isInteger 
			ifTrue: [ '. ' ]
			ifFalse: [ ' ' ]).
	super visitListItem: anObject.
	newline ifFalse: [ self newLine ]! !

!PRTextWriter methodsFor: 'visiting-document' stamp: 'lr 12/20/2007 19:59'!
visitOrderedList: anObject
	newline ifFalse: [ self newLine ].
	self nest: 0 do: [ super visitOrderedList: anObject ]! !

!PRTextWriter methodsFor: 'visiting-document' stamp: 'lr 12/20/2007 19:56'!
visitPreformatted: anObject
	anObject children do: [ :each | self visit: each; newLine ]! !

!PRTextWriter methodsFor: 'visiting-document' stamp: 'lr 12/20/2007 14:22'!
visitTableRow: anObject
	anObject children
		do: [ :each | self visit: each ]
		separatedBy: [ self nextPut: Character tab ].
	self newLine! !

!PRTextWriter methodsFor: 'visiting-document' stamp: 'lr 12/30/2007 23:24'!
visitTermItem: anObject
	self nest: '-' do: [ super visitDataItem: anObject ]! !

!PRTextWriter methodsFor: 'visiting-document' stamp: 'lr 2/6/2007 18:55'!
visitText: anObject
	self nextPutAll: anObject text! !

!PRTextWriter methodsFor: 'visiting-document' stamp: 'lr 12/20/2007 19:54'!
visitUnorderedList: anObject
	newline ifFalse: [ self newLine ].
	self nest: '*' do: [ super visitUnorderedList: anObject ]! !

PRDocumentWriter subclass: #PRWikiWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRWikiWriter methodsFor: 'accessing' stamp: 'lr 4/5/2007 13:07'!
lineMatcher
	^ PRDocumentParser lineMatcher! !

!PRWikiWriter methodsFor: 'visiting-document' stamp: 'lr 12/20/2007 14:19'!
visitAnchor: anObject
	self nextPutAll: anObject class markup; nextPutAll: anObject name; newLine! !

!PRWikiWriter methodsFor: 'visiting-document' stamp: 'lr 9/17/2009 17:59'!
visitAnnotatedParagraph: anObject
	self 
		nextPutAll: anObject class markup;
		nextPutAll: anObject annotation.
	anObject hasChildren 
		ifTrue: [ self nextPut: Character space ].
	super visitAnnotatedParagraph: anObject! !

!PRWikiWriter methodsFor: 'visiting-document' stamp: 'lr 12/30/2007 21:59'!
visitDefinitionList: anObject
	newline ifFalse: [ self newLine ].
	anObject children do: [ :each |
		self 
			nest: each class markup
			do: [ self visit: each ] ]! !

!PRWikiWriter methodsFor: 'visiting-document' stamp: 'lr 3/30/2007 20:08'!
visitFormat: anObject
	self nextPutAll: anObject class markup.
	super visitFormat: anObject.
	self nextPutAll: anObject class markup! !

!PRWikiWriter methodsFor: 'visiting-document' stamp: 'lr 12/20/2007 14:20'!
visitHeader: anObject
	anObject level timesRepeat: [ self nextPutAll: anObject class markup ].
	super visitHeader: anObject.
	self newLine! !

!PRWikiWriter methodsFor: 'visiting-document' stamp: 'lr 12/20/2007 14:20'!
visitHorizontalRule: anObject
	self nextPutAll: anObject class markup; newLine! !

!PRWikiWriter methodsFor: 'visiting-document' stamp: 'NickAger 1/7/2010 18:29'!
visitLink: anObject
	self nextPutAll: (anObject isEmbedded
		ifFalse: [ anObject class markup ]
		ifTrue: [ anObject class markupEmbedded ]).
	anObject hasAlias ifTrue: [
		super visitLink: anObject.
		self nextPutAll: anObject class markupAlias ].
	self nextPutAll: anObject reference.
	anObject hasAnchor ifTrue: [
		self nextPutAll: anObject class markupAnchor.
		self nextPutAll: (anObject class escape: anObject anchor) ].
	anObject parameters do: [ :assoc |
		self nextPutAll: anObject class markupParameter.
		self nextPutAll: (anObject class escape: assoc key).
		assoc value isNil
			ifFalse: [ self nextPutAll: anObject class markupParameterValue; nextPutAll: (anObject class escape: assoc value greaseString) ] ].
	self nextPutAll: (anObject isEmbedded
		ifFalse: [ anObject class markup ]
		ifTrue: [ anObject class markupEmbedded ])! !

!PRWikiWriter methodsFor: 'visiting-document' stamp: 'lr 12/20/2007 19:45'!
visitList: anObject
	newline ifFalse: [ self newLine ].
	self nest: anObject class markup do: [ super visitList: anObject ]! !

!PRWikiWriter methodsFor: 'visiting-document' stamp: 'lr 12/20/2007 19:52'!
visitListItem: anObject
	nesting do: [ :each | self nextPutAll: each ].
	super visitListItem: anObject.
	newline ifFalse: [ self newLine ]! !

!PRWikiWriter methodsFor: 'visiting-document' stamp: 'lr 12/20/2007 14:21'!
visitPreformatted: anObject
	anObject children do: [ :each |
		self
			nextPutAll: anObject class markup; 
			nextPutAll: each text;
			newLine ]! !

!PRWikiWriter methodsFor: 'visiting-document' stamp: 'lr 8/14/2008 08:58'!
visitTableCell: anObject
	self nextPutAll: anObject class markup.
	anObject isAligned ifTrue: [
		anObject isAlignedLeft ifTrue: [ self nextPutAll: anObject class markupLeft ].
		anObject isAlignedCenter ifTrue: [ self nextPutAll: anObject class markupCenter ].
		anObject isAlignedRight ifTrue: [ self nextPutAll: anObject class markupRight ] ].
	anObject isHeading ifTrue: [ self nextPutAll: anObject class markupHeading ].
	super visitTableCell: anObject! !

!PRWikiWriter methodsFor: 'visiting-document' stamp: 'lr 12/20/2007 14:21'!
visitTableRow: anObject
	super visitTableRow: anObject.
	self newLine! !

!PRWikiWriter methodsFor: 'visiting-document' stamp: 'lr 9/4/2009 17:19'!
visitText: anObject
	"Write out ==anObject=='s text to the receivers output-stream and escape special characters within and at the beginning of a line."

	| string key |
	string := anObject text.
	newline ifTrue: [
		key := self lineMatcher keys
			detect: [ :each | string beginsWith: each ]
			ifNone: [ nil ].
		key isNil ifFalse: [
			self nextPut: $\; nextPutAll: key.
			string := string allButFirst: key size ] ].
	self nextPutAll: (PRDocumentParser escape: string)! !

!PRWikiWriter methodsFor: 'visiting-document' stamp: 'lr 2/2/2010 15:20'!
visitVerbatim: anObject
	self nextPutAll: '{{{'.
	anObject type isNil
		ifFalse: [ self nextPutAll: anObject type; nextPut: $: ].
	self nextPutAll: anObject text.
	self nextPutAll: '}}}'! !

PRVisitor subclass: #PRPath
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Visitor'!

!PRPath class methodsFor: 'utilities' stamp: 'lr 11/3/2009 21:58'!
cleanName: aString
	^ aString isNil ifFalse: [
		 aString collect: [ :char |
			(self validCharacters includes: char)
				ifTrue: [ char asLowercase ]
				ifFalse: [
					char = Character space
						ifTrue: [ $- ]
						ifFalse: [ $_ ] ] ] ]! !

!PRPath class methodsFor: 'accessing' stamp: 'lr 9/27/2007 09:55'!
currentStructure
	^ '.'! !

!PRPath class methodsFor: 'testing' stamp: 'lr 4/21/2009 15:23'!
isValidName: aString
	^ aString isNil not
		and: [ aString isEmpty not
		and: [ aString ~= self parentStructure
		and: [ aString ~= self currentStructure
		and: [ aString allSatisfy: [ :char | self validCharacters includes: char ] ] ] ] ]! !

!PRPath class methodsFor: 'accessing' stamp: 'lr 9/27/2007 09:54'!
parentStructure
	^ '..'! !

!PRPath class methodsFor: 'accessing' stamp: 'lr 9/27/2007 09:55'!
pathDelimiter
	^ $/! !

!PRPath class methodsFor: 'accessing' stamp: 'lr 11/3/2009 21:36'!
validCharacters
	"Answer a string with all the valid characters for path names, these are all the Safe-HTTP characters."
	
	^ '-.0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ_abcdefghijklmnopqrstuvwxyz'! !

!PRPath methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
stream
	^ stream! !

!PRPath methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
stream: aStream
	stream := aStream! !

PRPath subclass: #PRPathLookup
	instanceVariableNames: 'absentBlock pathElement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Visitor'!

!PRPathLookup commentStamp: 'lr 5/28/2006 21:19' prior: 0!
I am a visitor used to look up a given path. I am able to lookup absolute and relative paths, following the syntax of unix operating systems.

!!Example
=(PRPathLookup
=	start: aStructure
=	path: '/Information/Copyright/..')
=		inspect!

PRPathLookup subclass: #PRIncompletePathLookup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Visitor'!

!PRIncompletePathLookup methodsFor: 'private' stamp: 'lr 4/11/2009 18:03'!
childNotFound: aStructure
	self escape: aStructure! !

!PRIncompletePathLookup methodsFor: 'actions' stamp: 'lr 4/11/2009 18:09'!
lookup: aStructure
	^ Association 
		key: (super lookup: aStructure)
		value: self pathElement! !

!PRPathLookup class methodsFor: 'instance creation' stamp: 'lr 4/11/2009 16:04'!
start: aStructure path: aString
	^ self start: aStructure path: aString ifAbsent: [ nil ]! !

!PRPathLookup class methodsFor: 'instance creation' stamp: 'lr 4/11/2009 16:04'!
start: aStructure path: aString ifAbsent: aBlock
	^ self new
		stream: aString readStream;
		absentBlock: aBlock;
		lookup: aStructure! !

!PRPathLookup methodsFor: 'accessing' stamp: 'lr 4/11/2009 16:03'!
absentBlock
	^ absentBlock! !

!PRPathLookup methodsFor: 'accessing' stamp: 'lr 4/11/2009 16:04'!
absentBlock: aBlock
	absentBlock := aBlock! !

!PRPathLookup methodsFor: 'private' stamp: 'lr 4/11/2009 18:04'!
childNotFound: aStructure
	self escape: self absentBlock value! !

!PRPathLookup methodsFor: 'actions' stamp: 'lr 9/27/2007 09:57'!
lookup: aStructure
	^ self withEscaper: [
		self stream peek = self class pathDelimiter
			ifTrue: [ self lookupRoot: aStructure ]
			ifFalse: [ self lookupStart: aStructure ].
		self childNotFound: aStructure ]! !

!PRPathLookup methodsFor: 'actions' stamp: 'lr 3/9/2006 11:29'!
lookupRoot: aStructure
	self stream next.
	self visit: aStructure root! !

!PRPathLookup methodsFor: 'actions' stamp: 'lr 3/9/2006 11:29'!
lookupStart: aStructure
	self visit: aStructure! !

!PRPathLookup methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
pathElement
	^ pathElement! !

!PRPathLookup methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
pathElement: aString
	pathElement := aString! !

!PRPathLookup methodsFor: 'private' stamp: 'lr 9/27/2007 09:58'!
readNext
	^ self stream upTo: self class pathDelimiter! !

!PRPathLookup methodsFor: 'visiting-decorations' stamp: 'lr 4/21/2009 18:44'!
visitChildren: anObject
	"This method does the lookup of the next structure by checking for a child with that name, since this value is hashed it can be done efficiently. If the lookup by name fails, it tries to match the title case-insensitive by iterating through the children. If this fails as well, the message ==#childNotFound:== is sent."

	anObject
		at: self pathElement
		ifPresent: [ :value | ^ self visit: value ].
	anObject children do: [ :each |
		((self pathElement sameAs: each name)
			or: [ self pathElement sameAs: each title ])
				ifTrue: [ ^ self visit: each ] ].
	self childNotFound: anObject decorated! !

!PRPathLookup methodsFor: 'visiting-structure' stamp: 'lr 9/27/2007 09:58'!
visitStructure: aStructure
	self stream atEnd
		ifTrue: [ self escape: aStructure ].
	self pathElement: self readNext.
	self pathElement = self class currentStructure
		ifTrue: [ ^ self visit: aStructure ].
	self pathElement = self class parentStructure
		ifTrue: [
			^ self visit: (aStructure isRoot
				ifTrue: [ aStructure ]
				ifFalse: [ aStructure parent ]) ].
	aStructure hasChildren
		ifFalse: [ self childNotFound: aStructure ]! !

PRPath subclass: #PRPathReference
	instanceVariableNames: 'source sourcePath target targetPath'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Visitor'!

!PRPathReference commentStamp: 'lr 5/28/2006 21:19' prior: 0!
I am a visitor used to print a short path from a structure to another one.

!!Example
=(PRPathReference
=	from: aFirstStructure
=	to: aSecondStructure)
=		inspect!

!PRPathReference class methodsFor: 'instance creation' stamp: 'lr 11/2/2007 13:29'!
from: aFirstStructure to: aSecondStructure
	^ self new
		setSource: aFirstStructure;
		setTarget: aSecondStructure;
		relativeReference! !

!PRPathReference class methodsFor: 'instance creation' stamp: 'lr 11/2/2007 13:30'!
to: aStructure
	^ self new
		setTarget: aStructure;
		absoluteReference! !

!PRPathReference methodsFor: 'actions' stamp: 'lr 11/2/2007 13:32'!
absoluteReference
	self targetPath removeFirst.
	self writeDelimiter.
	self targetPath 	
		do: [ :each | self visit: each ]
		separatedBy: [ self writeDelimiter ].
	^ self stream contents! !

!PRPathReference methodsFor: 'private' stamp: 'lr 9/27/2007 09:42'!
hasCommonPath
	"Answer true if the source and target path start with the same structure."
	
	 ^ self sourcePath notEmpty
		and: [ self targetPath notEmpty
		and: [ self sourcePath first = self targetPath first ] ]! !

!PRPathReference methodsFor: 'initialization' stamp: 'lr 3/9/2006 11:29'!
initialize
	super initialize.
	stream := WriteStream on: String new! !

!PRPathReference methodsFor: 'actions' stamp: 'lr 11/2/2007 13:36'!
relativeReference
	self validateKernel.
	self removeCommonPath.
	self source = self target 
		ifTrue: [ ^ self class currentStructure ].
	self sourcePath reverseDo: [ :each |
		self writeParent; writeDelimiter ].
	self targetPath 	
		do: [ :each | self visit: each; writeDelimiter ].
	^ self stream skip: -1; contents
! !

!PRPathReference methodsFor: 'private' stamp: 'lr 9/27/2007 09:44'!
removeCommonPath
	"Remove all common path elements from the source and target path."
	
	[ self hasCommonPath ] whileTrue: [ 
		self sourcePath removeFirst.
		self targetPath removeFirst ]! !

!PRPathReference methodsFor: 'initialization' stamp: 'lr 9/27/2007 09:41'!
setSource: aStructure
	source := aStructure.
	sourcePath := aStructure parents! !

!PRPathReference methodsFor: 'initialization' stamp: 'lr 9/27/2007 09:41'!
setTarget: aStructure
	target := aStructure.
	targetPath := aStructure parents! !

!PRPathReference methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
source
	^ source! !

!PRPathReference methodsFor: 'accessing' stamp: 'lr 9/27/2007 09:41'!
sourcePath
	^ sourcePath! !

!PRPathReference methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
target
	^ target! !

!PRPathReference methodsFor: 'accessing' stamp: 'lr 9/27/2007 09:41'!
targetPath
	^ targetPath! !

!PRPathReference methodsFor: 'private' stamp: 'lr 9/27/2007 09:43'!
validateKernel
	"Validate that the source and target are contained within the same kernel. This is done by comparing the root structure."
	
	self hasCommonPath
		ifFalse: [ PRInvalidKernelError signal: 'Unable to reference external wiki.' ]! !

!PRPathReference methodsFor: 'visiting' stamp: 'lr 3/9/2006 11:29'!
visitStructure: aStructure
	stream nextPutAll: aStructure name! !

!PRPathReference methodsFor: 'private-writing' stamp: 'lr 9/27/2007 09:58'!
writeDelimiter
	stream nextPut: self class pathDelimiter! !

!PRPathReference methodsFor: 'private-writing' stamp: 'lr 9/27/2007 09:54'!
writeParent
	stream nextPutAll: self class parentStructure! !

PRVisitor subclass: #PRPluggableVisitor
	instanceVariableNames: 'block'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Visitor'!

PRPluggableVisitor subclass: #PREnumerableVisitor
	instanceVariableNames: 'structure'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Visitor'!

PREnumerableVisitor subclass: #PRChildrenVisitor
	instanceVariableNames: 'with all sortBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Visitor'!

!PRChildrenVisitor methodsFor: 'actions' stamp: 'lr 3/9/2006 11:29'!
all
	"Tell the receiver to visit structures recursively."

	all := true! !

!PRChildrenVisitor methodsFor: 'actions' stamp: 'lr 9/27/2007 10:02'!
everything
	"Tell the receiver to visit everything."

	with := all := true! !

!PRChildrenVisitor methodsFor: 'initialization' stamp: 'lr 3/18/2008 22:35'!
initialize
	super initialize.
	with := all := false! !

!PRChildrenVisitor methodsFor: 'accessing' stamp: 'lr 8/24/2006 22:42'!
sortBlock: aBlock
	sortBlock := aBlock! !

!PRChildrenVisitor methodsFor: 'visiting-decoration' stamp: 'lr 11/15/2009 20:03'!
visitChildren: aDecoration
	(all or: [ structure = aDecoration decorated ])
		ifFalse: [ ^ self ].
	self visitAll: (sortBlock isNil 
		ifTrue: [ aDecoration children ]
		ifFalse: [ aDecoration children asSortedCollection: sortBlock ])! !

!PRChildrenVisitor methodsFor: 'visiting-structure' stamp: 'lr 9/27/2007 10:11'!
visitStructure: aStructure
	(with or: [ structure ~= aStructure ])
		ifTrue: [ block value: aStructure ]! !

!PRChildrenVisitor methodsFor: 'actions' stamp: 'lr 3/9/2006 11:29'!
with
	"Tell the receiver to visit the start structure as well."

	with := true! !

!PREnumerableVisitor class methodsFor: 'instance creation' stamp: 'lr 1/21/2007 11:04'!
on: aStructure
	^ self new structure: aStructure! !

!PREnumerableVisitor methodsFor: 'enumerating' stamp: 'lr 11/25/2008 09:06'!
anySatisfy: aBlock
	"Evaluate aBlock for every structure visited by the receiver. If aBlock returns true for any element return true. Otherwise return false."

	self do: [ :each | 
		(aBlock value: each)
			ifTrue: [ ^ true ] ].
	^ false! !

!PREnumerableVisitor methodsFor: 'enumerating' stamp: 'lr 10/30/2006 17:13'!
collect: aBlock
	"Evaluate aBlock for every structure visited by the receiver and answer a collection of the results."

	^ Array streamContents: [ :stream |
		self do: [ :each |
			stream nextPut: (aBlock value: each) ] ]! !

!PREnumerableVisitor methodsFor: 'accessing' stamp: 'lr 1/19/2007 14:07'!
contents
	"Answer a collection of all elements that have been visited."

	^ self collect: [ :each | each ]! !

!PREnumerableVisitor methodsFor: 'enumerating' stamp: 'NickAger 2/21/2010 10:06'!
detect: aBlock 
	"Evaluate aBlock for every structure visited by the receiver. 
	Answer the first element for which aBlock evaluates to true."
	
	^ self detect: aBlock ifNone: [GRObject error: 'Object is not in the collection']! !

!PREnumerableVisitor methodsFor: 'enumerating' stamp: 'NickAger 2/21/2010 10:05'!
detect: aBlock ifNone: exceptionBlock
	"Evaluate aBlock for every structure visited by the receiver.  
	Answer the first element for which aBlock evaluates to true. If none  
	evaluate to true, then evaluate the argument, exceptionBlock."

	self do: [:each | (aBlock value: each) ifTrue: [^ each]].
	^ exceptionBlock value! !

!PREnumerableVisitor methodsFor: 'enumerating' stamp: 'lr 1/21/2007 10:49'!
do: aBlock
	"Evaluate aBlock for every structure visited by the receiver."

	self setBlock: aBlock; start: structure; setBlock: nil! !

!PREnumerableVisitor methodsFor: 'enumerating' stamp: 'lr 4/5/2007 17:59'!
do: aBlock separatedBy: aSeparatorBlock
	"Evaluate aBlock for every structure visited by the receiver, and evaluate aSeparatorBlock between."

	| first |
	first := true.
	self do: [ :each |
		first
			ifTrue: [ first := false ]
			ifFalse: [ aSeparatorBlock value ].
		aBlock value: each ]! !

!PREnumerableVisitor methodsFor: 'enumerating' stamp: 'lr 4/5/2007 17:59'!
inject: anObject into: aBlock
	"Accumulate a running value associated with evaluating the argument aBlock with the current value of the argument anObject and the receiver as block arguments."

	| next |
	next := anObject.
	self do: [ :each | next := aBlock value: next value: each ].
	^ next! !

!PREnumerableVisitor methodsFor: 'enumerating' stamp: 'lr 4/10/2007 21:49'!
reject: aBlock
	"Evaluate aBlock for every structure visited by the receiver and answer a collection for which aBlock evaluates to ==false==."

	^ self select: [ :each | (aBlock value: each) not ]! !

!PREnumerableVisitor methodsFor: 'enumerating' stamp: 'lr 4/10/2007 21:49'!
select: aBlock
	"Evaluate aBlock for every structure visited by the receiver and answer a collection for which aBlock evaluates to ==true==."

	^ Array streamContents: [ :stream |
		self do: [ :each |
			(aBlock value: each)
				ifTrue: [ stream nextPut: each ] ] ]! !

!PREnumerableVisitor methodsFor: 'accessing' stamp: 'lr 5/5/2009 21:49'!
size
	"Answer the number of elements."

	| tally |
	tally := 0.
	self do: [ :each | tally := tally + 1 ].
	^ tally! !

!PREnumerableVisitor methodsFor: 'accessing' stamp: 'lr 1/21/2007 11:04'!
structure: aStructure
	structure := aStructure! !

PREnumerableVisitor subclass: #PRFullTextSearch
	instanceVariableNames: 'acceptToken rejectToken caseSensitive'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Visitor'!

!PRFullTextSearch commentStamp: 'lr 4/10/2007 21:12' prior: 0!
I am a pluggable visitor to quickly look for matching text in a subtree of structures.

!!Example
The following example opens an inspector on all structures with the text ==foo==:
=(PRFullTextSearch 
=	from: aStructure
=	find: 'foo'
=	caseSensitive: false)
=		inspect!

!PRFullTextSearch methodsFor: 'accessing' stamp: 'lr 9/12/2009 12:01'!
acceptToken: aString
	"Add the token aString to be accepted."
	
	aString isEmpty
		ifFalse: [ acceptToken add: aString ]! !

!PRFullTextSearch methodsFor: 'accessing' stamp: 'lr 2/12/2007 19:07'!
caseSensitive: aBoolean
	"Set if the search text is case sensitive or not."

	caseSensitive := aBoolean! !

!PRFullTextSearch methodsFor: 'initialization' stamp: 'lr 9/12/2009 11:58'!
initialize
	super initialize.
	acceptToken := Set new.
	rejectToken := Set new.
	caseSensitive := false! !

!PRFullTextSearch methodsFor: 'accessing' stamp: 'lr 9/12/2009 12:01'!
rejectToken: aString
	"Add the token aString to be rejected."

	aString isEmpty
		ifFalse: [ rejectToken add: aString ]! !

!PRFullTextSearch methodsFor: 'visiting' stamp: 'lr 9/12/2009 12:08'!
start: anObject
	(acceptToken isEmpty and: [ rejectToken isEmpty ])
		ifTrue: [ ^ self ].
	super start: anObject! !

!PRFullTextSearch methodsFor: 'deprecated' stamp: 'lr 9/12/2009 12:00'!
subString: aString
	self acceptToken: aString! !

!PRFullTextSearch methodsFor: 'visiting-decoration' stamp: 'lr 3/9/2006 11:29'!
visitChildren: anObject
	self visitAll: anObject children! !

!PRFullTextSearch methodsFor: 'visiting-structure' stamp: 'lr 9/12/2009 12:31'!
visitStructure: aStructure
	| accepted string |
	accepted := false.
	aStructure description do: [ :description |
		description isSearchable ifTrue: [
			string := description toString: (aStructure readUsing: description).
			(rejectToken anySatisfy: [ :token | string includesSubstring: token caseSensitive: caseSensitive ])
				ifTrue: [ ^ self ].
			accepted := accepted
				or: [ acceptToken anySatisfy: [ :token | string includesSubstring: token caseSensitive: caseSensitive ] ] ] ].
	(accepted or: [ acceptToken isEmpty ])
		ifTrue: [ block value: aStructure ]! !

PREnumerableVisitor subclass: #PRIncomingReferences
	instanceVariableNames: 'structures'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Visitor'!

!PRIncomingReferences commentStamp: 'lr 4/10/2007 21:12' prior: 0!
I am a pluggable visitor to detect incoming references.

!!Example
The following example opens inspectors on all instances of ==*PRInternalLink*== that point ==aStructure==:
=aStructure incomingReferences 
=	from: aRootStructure
=	to: aStructure
=	do: [ :each | each inspect ]!

!PRIncomingReferences methodsFor: 'initialization' stamp: 'lr 10/30/2006 20:11'!
initialize
	super initialize.
	structures := Set new! !

!PRIncomingReferences methodsFor: 'accessing' stamp: 'lr 10/30/2006 20:30'!
to: aStructure
	structures add: aStructure! !

!PRIncomingReferences methodsFor: 'accessing' stamp: 'lr 10/30/2006 20:30'!
toAll: aCollection
	structures addAll: aCollection! !

!PRIncomingReferences methodsFor: 'visiting-decoration' stamp: 'lr 3/9/2006 11:29'!
visitChildren: anObject
	self visitAll: anObject children! !

!PRIncomingReferences methodsFor: 'visiting-document' stamp: 'lr 10/30/2006 20:12'!
visitInternalLink: anObject
	(structures includes: anObject target)
		ifTrue: [ block value: anObject ]! !

!PRIncomingReferences methodsFor: 'visiting-structure' stamp: 'lr 2/18/2009 15:56'!
visitStructure: aStructure
	aStructure description do: [ :each |
		each isDocumentDescription
			ifTrue: [ self visit: (aStructure readUsing: each) ] ]! !

PREnumerableVisitor subclass: #PROutgoingReferences
	instanceVariableNames: 'continue structures'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Visitor'!

!PROutgoingReferences commentStamp: 'lr 4/10/2007 21:12' prior: 0!
I am a pluggable visitor visiting and probably following outgoing references. To do so I visit all the links of the page and evaluate my pluggable block for each of them. If the ==continue== block answers ==true== I follow the link and continue visiting the references of the target structure. The default behavior of the ==continue== block is to follow the link only if it is embedded. I take care not to run into infinite recursion, so no structure will be visited more than once.

!!Examples
The following example answers a collection of referenced pages from ==aStructure==:

=(aStructure outgoingReferences
=	collect: [ :each | each target ])
=		asSet
		
The following example answers a collection of all broken references that can be reached from ==aStructure==:

=aStructure outgoingReferences
=	continue: [ :each | each isBroken not ];
= 	collect: [ :each | each isBroken ]!

!PROutgoingReferences methodsFor: 'accessing' stamp: 'lr 2/12/2007 19:07'!
continue: aBlock
	"A block to decide if the visitor should visit the structure referenced by the link passed into aBlock or not."

	continue := aBlock! !

!PROutgoingReferences methodsFor: 'initialization' stamp: 'lr 4/1/2009 21:58'!
initialize
	super initialize.
	continue := [ :each | each isEmbedded and: [ each isBroken not ] ]! !

!PROutgoingReferences methodsFor: 'visiting' stamp: 'lr 10/30/2006 19:42'!
start: anObject
	structures := Set new.
	super start: anObject! !

!PROutgoingReferences methodsFor: 'visiting-document' stamp: 'lr 4/1/2009 21:54'!
visitInternalLink: anObject
	super visitInternalLink: anObject.
	(anObject target isNil or: [ structures includes: anObject target ])
		ifTrue: [ ^ self ].
	(continue value: anObject)
		ifTrue: [ self visit: anObject target ]! !

!PROutgoingReferences methodsFor: 'visiting-document' stamp: 'lr 4/1/2009 21:54'!
visitLink: anObject
	block value: anObject! !

!PROutgoingReferences methodsFor: 'visiting-structure' stamp: 'lr 2/18/2009 15:14'!
visitStructure: aStructure
	structures add: aStructure.
	aStructure description do: [ :each |
		each isDocumentDescription
			ifTrue: [ self visit: (aStructure readUsing: each) ] ]! !

!PRPluggableVisitor methodsFor: 'initialization' stamp: 'lr 10/30/2006 16:53'!
setBlock: aBlock
	block := aBlock! !

!PRVisitor class methodsFor: 'building' stamp: 'lr 3/30/2007 19:58'!
buildVisitorHierarchyForClass: aClass selector: aSelectorBlock classified: aClassifiedBlock
	" self buildVisitorHierarchyForClass: PRObject selector: [ :class | 'visit' , (class name allButFirst: 2) , ':' ] classified: [ :class | 'visiting-' , (class category copyAfterLast: $-) asLowercase ] "

	aClass withAllSubclassesDo: [ :class |
		(class category beginsWith: 'Pier-Model') ifTrue: [
			(self selectors includes: (aSelectorBlock value: class)) ifFalse: [
				self
					compile: (String streamContents: [ :stream |
						stream nextPutAll: (aSelectorBlock value: class); nextPutAll: ' anObject'; cr.
						class = aClass ifFalse: [
							stream tab; nextPutAll: 'self '; nextPutAll: (aSelectorBlock value: class superclass); nextPutAll: ' anObject' ] ])
					classified: (aClassifiedBlock value: class) ].
			class
				compile: (String streamContents: [ :stream |
					stream nextPutAll: 'accept: aVisitor'; cr.
					stream tab; nextPutAll: 'aVisitor '; nextPutAll: (aSelectorBlock value: class); nextPutAll: ' self' ])
				classified: #visiting ] ]! !

!PRVisitor methodsFor: 'escaping' stamp: 'lr 3/9/2006 11:30'!
escape: anObject
	escaper value: anObject! !

!PRVisitor methodsFor: 'escaping' stamp: 'lr 3/9/2006 11:30'!
hasEscaper
	^ escaper notNil! !

!PRVisitor methodsFor: 'visiting' stamp: 'lr 3/9/2006 11:30'!
start: anObject
	self visit: anObject! !

!PRVisitor methodsFor: 'visiting' stamp: 'lr 3/9/2006 11:30'!
visit: anObject
	anObject acceptDecorated: self! !

!PRVisitor methodsFor: 'visiting' stamp: 'lr 3/9/2006 11:30'!
visitAll: aCollection
	aCollection do: [ :each | self visit: each ]! !

!PRVisitor methodsFor: 'visiting' stamp: 'lr 3/9/2006 11:30'!
visitAll: aCollection separatedBy: aBlock
	aCollection do: [ :each | self visit: each ] separatedBy: aBlock! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/30/2007 20:01'!
visitAnchor: anObject
	self visitDocumentItem: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 5/26/2009 22:07'!
visitAnnotatedParagraph: aDocument
	self visitParagraph: aDocument! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/30/2007 20:01'!
visitBoldFormat: anObject
	self visitFormat: anObject! !

!PRVisitor methodsFor: 'visiting-structure' stamp: 'lr 3/30/2007 20:01'!
visitCase: anObject
	self visitStructure: anObject! !

!PRVisitor methodsFor: 'visiting-structure' stamp: 'lr 10/16/2007 22:28'!
visitChildren: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 12/30/2007 21:53'!
visitDataItem: anObject
	self visitListItem: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 12/30/2007 19:33'!
visitDefinitionList: anObject
	self visitList: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/30/2007 20:01'!
visitDocument: anObject
	self visitDocumentGroup: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/30/2007 20:05'!
visitDocumentGroup: anObject
	self visitAll: anObject children! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/30/2007 20:04'!
visitDocumentItem: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 12/20/2007 12:13'!
visitEmptyParagraph: anObject
	self visitParagraph: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/30/2007 20:01'!
visitExternalLink: anObject
	self visitLink: anObject! !

!PRVisitor methodsFor: 'visiting-structure' stamp: 'lr 3/30/2007 20:01'!
visitFile: anObject
	self visitStructure: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/30/2007 20:01'!
visitFormat: anObject
	self visitDocumentGroup: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/30/2007 20:01'!
visitHeader: anObject
	self visitDocumentGroup: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/30/2007 20:01'!
visitHorizontalRule: anObject
	self visitDocumentItem: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/30/2007 20:01'!
visitInternalLink: anObject
	self visitLink: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/30/2007 20:01'!
visitItalicFormat: anObject
	self visitFormat: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 12/30/2007 19:56'!
visitLineBreak: anObject
	self visitDocumentItem: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/30/2007 20:01'!
visitLink: anObject
	self visitDocumentGroup: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/30/2007 20:01'!
visitList: anObject
	self visitDocumentGroup: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/30/2007 20:01'!
visitListItem: anObject
	self visitDocumentGroup: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/30/2007 20:01'!
visitMailLink: anObject
	self visitExternalLink: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/30/2007 20:01'!
visitMonospaceFormat: anObject
	self visitFormat: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/30/2007 20:01'!
visitOrderedList: anObject
	self visitList: anObject! !

!PRVisitor methodsFor: 'visiting-structure' stamp: 'lr 3/30/2007 20:01'!
visitPage: anObject
	self visitCase: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/30/2007 20:01'!
visitParagraph: anObject
	self visitDocumentGroup: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/30/2007 20:01'!
visitPreformatted: anObject
	self visitDocumentGroup: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 5/31/2007 07:46'!
visitStrikethroughFormat: anObject
	self visitFormat: anObject! !

!PRVisitor methodsFor: 'visiting-structure' stamp: 'lr 10/16/2007 22:26'!
visitStructure: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/30/2007 20:01'!
visitSubscriptFormat: anObject
	self visitFormat: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/30/2007 20:01'!
visitSuperscriptFormat: anObject
	self visitFormat: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/30/2007 20:01'!
visitTable: anObject
	self visitDocumentGroup: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/30/2007 20:01'!
visitTableCell: anObject
	self visitDocumentGroup: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/30/2007 20:01'!
visitTableRow: anObject
	self visitDocumentGroup: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 12/30/2007 21:53'!
visitTermItem: anObject
	self visitListItem: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/30/2007 20:01'!
visitText: anObject
	self visitDocumentItem: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/30/2007 20:01'!
visitUnderlineFormat: anObject
	self visitFormat: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/30/2007 20:01'!
visitUnorderedList: anObject
	self visitList: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 1/9/2009 19:59'!
visitValueLink: anObject 
	self visitLink: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 2/2/2010 15:18'!
visitVerbatim: anObject
	self visitText: anObject! !

!PRVisitor methodsFor: 'escaping' stamp: 'lr 3/9/2006 11:30'!
withEscaper: aBlock
	| old |
	old := escaper.
	escaper := [ :value | ^ value ].
	^ aBlock ensure: [ escaper := old ]! !

!GRPackage class methodsFor: '*pier-model' stamp: 'lr 2/18/2010 10:31'!
pierModel
	^ self new
		name: 'Pier-Model';
		description: 'The Pier is a content management system.';
		addDependency: 'Magritte-Model';
		addDependency: 'Grease-Core';
		url: #pierUrl;
		yourself! !

!GRPackage methodsFor: '*pier-model' stamp: 'lr 2/16/2010 09:15'!
pierUrl
	^ 'http://source.lukas-renggli.ch/pier2'! !

!UndefinedObject methodsFor: '*pier-model' stamp: 'lr 3/9/2006 11:29'!
accept: aVisitor
	"do nothing"! !

!MAStringWriter methodsFor: '*pier-model-visiting' stamp: 'lr 10/16/2007 20:11'!
visitDocumentDescription: aDescription
	aDescription writerClass 
		write: self object
		to: self stream! !

!MAStringWriter methodsFor: '*pier-model-visiting' stamp: 'lr 4/11/2009 10:35'!
visitStructureDescription: aDescription
	stream nextPutAll: self object absolutePath! !

!Object methodsFor: '*pier-model' stamp: 'lr 3/9/2006 11:29'!
accept: aVisitor
	self subclassResponsibility! !

!Object methodsFor: '*pier-model' stamp: 'lr 3/9/2006 11:29'!
acceptDecorated: aVisitor
	self accept: aVisitor! !

Object subclass: #PRDiffAlgorithm
	instanceVariableNames: 'source sourceMap sourceText sourceRow target targetMap targetText targetRow'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Utilities'!

!PRDiffAlgorithm commentStamp: 'lr 9/28/2009 20:40' prior: 0!
Smalltalk Diff Algorithm, based on the Javascript implementation by John Resig and Chu Alan.

http://jquery-ui.googlecode.com/svn/tags/1.7.2/external/jsdiff/jsdiff.js!

!PRDiffAlgorithm class methodsFor: 'instance creation' stamp: 'lr 9/27/2009 19:13'!
from: aSourceSequence to: aTargetSequence
	^ self basicNew initializeFrom: aSourceSequence to: aTargetSequence! !

!PRDiffAlgorithm methodsFor: 'initialization' stamp: 'lr 9/28/2009 19:41'!
initializeFrom: aSourceSequence to: aTargetSequence
	self source: aSourceSequence.
	self target: aTargetSequence.
	self initializeMapping! !

!PRDiffAlgorithm methodsFor: 'initialization' stamp: 'lr 9/28/2009 19:40'!
initializeMapping
	targetMap keysDo: [ :i |
		((targetMap at: i) size = 1 and: [ (sourceMap includesKey: i) and: [ (sourceMap at: i) size = 1 ] ]) ifTrue: [ 
			targetText at: (targetMap at: i) first put: (target at: (targetMap at: i) first).
			targetRow at: (targetMap at: i) first put: (sourceMap at: i) first.
			sourceText at: (sourceMap at: i) first put: (source at: (sourceMap at: i) first).
			sourceRow at: (sourceMap at: i) first put: (targetMap at: i) first ] ].
	1 to: target size - 1 do: [ :i |
		((targetText at: i) notNil 
			and: [ (targetText at: i + 1) isNil 
			and: [ (targetRow at: i) + 1 < source size 
			and: [ (sourceText at: (targetRow at: i) + 1) isNil 
			and: [ (target at: i + 1) = (source at: (targetRow at: i) + 1) ] ] ] ]) ifTrue: [
				targetText at: i + 1 put: (target at: i + 1).
				targetRow at: i + 1 put: (targetRow at: i) + 1.
				sourceText at: (targetRow at: i) + 1 put: (source at: (targetRow at: i) + 1).
				sourceRow at: (targetRow at: i) + 1 put: i + 1 ] ].
	target size to: 2 by: -1 do: [ :i |
		((targetText at: i) notNil 
			and: [ (targetText at: i - 1) isNil 
			and: [ (targetRow at: i) > 1
			and: [ (sourceText at: (targetRow at: i) - 1) isNil 
			and: [ (target at: i - 1) = (source at: (targetRow at: i) - 1) ] ] ] ]) ifTrue: [
				targetText at: i - 1 put: (target at: i - 1).
				targetRow at: i - 1 put: (targetRow at: i) - 1.
				sourceText at: (targetRow at: i) - 1 put: (source at: (targetRow at: i) - 1).
				sourceRow at: (targetRow at: i) - 1 put: i - 1 ] ]! !

!PRDiffAlgorithm methodsFor: 'patching' stamp: 'lr 9/28/2009 20:32'!
patchset
	| patchset |
	patchset := OrderedCollection new.
	self patchsetDo: [ :operation :object :index | patchset addLast: (Array with: operation with: object) ].
	^ patchset asArray! !

!PRDiffAlgorithm methodsFor: 'patching' stamp: 'lr 9/28/2009 21:24'!
patchsetDo: aBlock
	"Evaluate aBlock for every patch operation of the receiver. The first argument is the operation, where #= is identity, #+ is insertion, and #- is deletion. The second argument is the object. The third argument the index in the source or target list."

	| sourceIndex targetIndex |
	sourceIndex := targetIndex := 1.
	[ sourceIndex <= source size or: [ targetIndex <= target size ] ] whileTrue: [
		[ sourceIndex <= source size and: [ (sourceText at: sourceIndex) isNil ] ] whileTrue: [
			aBlock value: #- value: (source at: sourceIndex) value: sourceIndex.
			sourceIndex := sourceIndex + 1 ].
		[ targetIndex <= target size and: [ (targetText at: targetIndex) isNil ] ] whileTrue: [
			aBlock value: #+ value: (target at: targetIndex) value: targetIndex.
			targetIndex := targetIndex + 1 ].
		targetIndex <= target size
			ifTrue: [ aBlock value: #= value: (targetText at: targetIndex) value: targetIndex ].
		sourceIndex := sourceIndex + 1.
		targetIndex := targetIndex + 1 ]! !

!PRDiffAlgorithm methodsFor: 'accessing' stamp: 'lr 9/28/2009 18:53'!
source: aCollection
	"Set the source sequence."

	source := aCollection asArray.
	sourceText := Array new: source size.
	sourceRow := Array new: source size.
	sourceMap := Dictionary new.
	source withIndexDo: [ :each :index |
		(sourceMap at: each ifAbsentPut: [ OrderedCollection new ])
			addLast: index ]! !

!PRDiffAlgorithm methodsFor: 'accessing' stamp: 'lr 9/28/2009 18:53'!
target: aCollection
	"Set the target sequence."
	
	target := aCollection asArray.
	targetText := Array new: target size.
	targetRow := Array new: target size.
	targetMap := Dictionary new.
	target withIndexDo: [ :each :index |
		(targetMap at: each ifAbsentPut: [ OrderedCollection new ])
			addLast: index ]! !

PRDiffAlgorithm subclass: #PRLineDiffAlgorithm
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Utilities'!

!PRLineDiffAlgorithm methodsFor: 'accessing' stamp: 'lr 9/28/2009 18:09'!
source: aString
	super source: (aString ifNil: [ String new ]) lines! !

!PRLineDiffAlgorithm methodsFor: 'accessing' stamp: 'lr 9/28/2009 18:08'!
target: aString
	super target: (aString ifNil: [ String new ]) lines! !

PRDiffAlgorithm subclass: #PRWordDiffAlgorithm
	instanceVariableNames: 'sourceSpaces targetSpaces'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Utilities'!

!PRWordDiffAlgorithm methodsFor: 'accessing' stamp: 'lr 9/28/2009 14:24'!
source: aString
	self split: aString do: [ :tokens :spaces |
		super source: tokens.
		sourceSpaces := spaces ]! !

!PRWordDiffAlgorithm methodsFor: 'private' stamp: 'lr 9/28/2009 14:25'!
split: aString do: aBlock
	"Split aString on all separators and pass in two collections inta aBlock, the first one being the split strings and the second one being the splitter strings inbetween."
	
	| strings splitters input output |
	strings := OrderedCollection new.
	splitters := OrderedCollection new.
	input := (aString ifNil: [ String new ])
		withBlanksTrimmed readStream.
	[ input atEnd ] whileFalse: [
		output := WriteStream on: String new.
		[ input atEnd or: [ input peek isSeparator ] ]
			whileFalse: [ output nextPut: input next ].
		output isEmpty
			ifFalse: [ strings addLast: output contents ].
		output := WriteStream on: String new.
		[ input atEnd or: [ input peek isSeparator not ] ]
			whileFalse: [ output nextPut: input next ].
		output isEmpty
			ifFalse: [ splitters addLast: output contents ] ].
	splitters addLast: (String with: Character cr).
	^ aBlock value: strings asArray value: splitters asArray! !

!PRWordDiffAlgorithm methodsFor: 'accessing' stamp: 'lr 9/28/2009 14:24'!
target: aString
	self split: aString do: [ :tokens :spaces |
		super target: tokens.
		targetSpaces := spaces ]! !
PRDocumentParser initialize!
PRMacroExpander initialize!
PRMigrations initialize!
